;;; fonctions correspondantes aux commandes du top-level 

(defvar #:sys-package:colon '#:shirka:top)

(de :aj-val (inst)
    (:impr-res
            (#:shirka:moteur:aj-valeur 
                    (#:shirka:noyau:schema 
                            (#:shirka:noyau:val-inst inst 3))
                    ; instance
                    (#:shirka:noyau:val-inst inst 4)       ; nom-att
                    (#:shirka:noyau:val-inst inst 5)       ; valeur
                    (let ((ben-fin (val? 'en-fin)))
                         (or (eq ben-fin 'oui) (eq ben-fin 'vrai))))))

(de :lister-noms (liste)
    (let ((lg-col) (nb-cols) (index -1) (colonne) (lemax '(max))
          (nb-elems) (inter-col 4) (largeur-ligne (rmargin)))
         (unless (or (null liste)
                     (atomp liste))
                 (setq nb-elems (length liste))
                 ; chercher le nom le + long -> largeur colonne avec inter-colonnage
                 (setq lg-col (+ (eval (append lemax (mapcar 'slength liste))) 
                                 inter-col))
                 (setq nb-cols (div largeur-ligne lg-col))
                 ; imprimer:
                 (tag impression
                      (while t
                             (setq colonne 1)
                             (outpos colonne)
                             (repeat nb-cols
                                     (if (= (incr index) nb-elems) 
                                         (exit impression ()))
                                     (prin (nth index liste))
                                     (outpos (incr colonne lg-col)))
                             (terpri))))))

(de :impr-res (valeur)
    (prin "-> ")
    (ifn valeur
         (prin "echec")
         (if (consp valeur)
             (mapc '(lambda (val) (prin val " ")) valeur)
             (if (vectorp valeur)
                 (prin (#:shirka:noyau:nom-sch valeur))
                 (prin valeur))))
    (terpri))

;;; suppression d'une valeur
(de :sup-val (inst)
    (:impr-res
            (#:shirka:moteur:sup-valeur 
                    (#:shirka:noyau:schema 
                            (#:shirka:noyau:val-inst inst 3))
                    (#:shirka:noyau:val-inst inst 4)
                    (#:shirka:noyau:val-inst inst 5))))

;;; modification de valeur
(de :mod-val (inst)
    (:impr-res
            (#:shirka:moteur:mod-valeur 
                    (#:shirka:noyau:schema 
                            (#:shirka:noyau:val-inst inst 3))
                    (#:shirka:noyau:val-inst inst 4)
                    (#:shirka:noyau:val-inst inst 5)
                    (#:shirka:noyau:val-inst inst 6))))

;;; creation d'instance en interactif
(de :creer-instance (inst)
    (:impr-res
            (:creer (#:shirka:noyau:schema 
                            (#:shirka:noyau:val-inst inst 3))
                    (#:shirka:noyau:val-inst inst 4)  ; pour-classes-att
                    (#:shirka:noyau:val-inst inst 5)  ; sauf-classes-att
                    nil t)))

;;; visualisation
(de :visu-inst (inst)
    (let ((instance (#:shirka:noyau:schema (#:shirka:noyau:val-inst inst 3)))
          (vu-comme (#:shirka:noyau:val-inst inst 4)))
         ; formation du nom de l'instance temporaire
         (let ((nom-inst-temp 
                       (when vu-comme
                             (#:shirka:comp:gen-symbole vu-comme))))
              (prog1 
                     (:impr-res
                             (prog1 (#:shirka:vi:visualiser
                                            (if vu-comme
                                                ; creation d'une instance temporaire 
                                                ; du schema precise par 'vu-comme'
                                                (let ((inst-temp
                                                              (#:shirka:classif:cr-inst-temp 
                                                                      instance vu-comme nom-inst-temp)))
                                                     (if inst-temp inst-temp instance))
                                                instance) 
                                            (#:shirka:noyau:val-inst inst 5)  ; classes-att
                                            (#:shirka:noyau:val-inst inst 6)  ; sauf-classes-att
                                            (let ((niv (#:shirka:noyau:val-inst inst 8)))
                                                 (if niv niv 0))
                                            (let ((avec-inf (#:shirka:noyau:val-inst inst 7)))
                                                 (or (eq avec-inf 'oui) (eq avec-inf 'vrai))))
                                    (terpri)))
                     ; suppression de l'instance temporaire
                     (when vu-comme
                           (let ((schema-temp (getprop nom-inst-temp 'schema)))
                                (when schema-temp
                                      (#:shirka:moteur:sup-inst schema-temp nil))))))))

;;; liste des specialisations d'une classe
(de :impr-l-spec-t (liste-spec nb-niveaux niveau-courant marge-g)
    (incr niveau-courant)
    (mapcan '(lambda (spec)
                     (unless 
                             (or (> niveau-courant nb-niveaux)
                                 (getprop spec 'est-un-filtre)
                                 (getprop spec 'spec-loc)
                                 (getprop spec 'traite))
                             (putprop spec t 'traite)
                             (print (makestring marge-g #/ ) spec)
                             (let ((liste-spec
                                           (#:shirka:noyau:l-spec 
                                                   (#:shirka:noyau:schema spec))))
                                  (when liste-spec
                                        (:impr-l-spec-t liste-spec 
                                                nb-niveaux
                                                niveau-courant  
                                                (+ marge-g 4)))
                                  )))
            liste-spec)
    (decr niveau-courant))

(de :liste-spec (inst)  
    (let ((schema (#:shirka:noyau:schema 
                          (#:shirka:noyau:val-inst inst 3)))
          (nb-niveaux (#:shirka:noyau:val-inst inst 4)))
         (:impr-l-spec-t (#:shirka:noyau:l-spec schema) 
                 (if nb-niveaux nb-niveaux 10000)
                 0 0)
         (#:shirka:noyau:demarquer-fils schema)
         (:impr-res  schema)))

;;; liste des instances d'une classe
(de :liste-inst (inst)
    (:impr-res 
            (#:shirka:noyau:l-inst-t 
                    (#:shirka:noyau:schema 
                            (#:shirka:noyau:val-inst inst 3)))))

;;; demande de valeur
(de :obtenir-valeur (inst)
    (slet ((nom-inst (#:shirka:noyau:val-inst inst 3))
           (nom-anc-schema (#:shirka:noyau:val-inst instance %est-un))
           (vu-comme (#:shirka:noyau:val-inst inst 5)))
          ; formation du nom de l'instance temporaire
          (let ((nom-inst-temp 
                        (when vu-comme
                              (#:shirka:comp:gen-symbole vu-comme))))
               (prog1 
                      (:impr-res 
                              (#:shirka:moteur:valeur? 
                                      (#:shirka:noyau:val-inst inst 4) ;nom de l'attribut
                                      ; nom de l'instance
                                      (if vu-comme
                                          ; creation d'une instance temporaire 
                                          ; du schema precise par vu-comme
                                          (let ((inst-temp
                                                        (#:shirka:classif:cr-inst-temp 
                                                                (#:shirka:noyau:schema nom-inst) 
                                                                vu-comme nom-inst-temp)))
                                               (if inst-temp nom-inst-temp nom-inst))
                                          nom-inst))))
               ; suppression de l'instance temporaire
               (when vu-comme
                     (let ((schema-temp (getprop nom-inst-temp 'schema)))
                          (when schema-temp
                                (#:shirka:moteur:sup-inst schema-temp nil)))))))

;;; suppression d'instance
(de :supprimer-inst (inst)
    (slet ((nom-inst (#:shirka:noyau:val-inst inst 3))
           (schema (#:shirka:noyau:schema nom-inst)))
          (when (#:shirka:noyau:sch-classe? schema)
                (print "Suppression de la classe " nom-inst ", ")
                (let ((l-spec (#:shirka:noyau:l-spec-t-vraies schema)))
                     (when l-spec
                           (prin "de ses specialisations : ")
                           (mapc '(lambda (nom-inst) (prin nom-inst " ")))
                           (print ", ")
                           (print "et de leurs instances.")))
                (print "et de ses instances."))
          (:impr-res 
                  (#:shirka:moteur:sup-inst schema t))))

;;; liste des attributs propres et herites d'un schema de classe
;;; avec  prise en compte des classes d'attributs
(de :liste-att (inst)
    (:impr-res
            (#:shirka:noyau:l-nom-att-he-class 
                    (#:shirka:noyau:schema 
                            (#:shirka:noyau:val-inst inst 3))
                    (#:shirka:noyau:val-inst inst 4)
                    (#:shirka:noyau:val-inst inst 5))))

;;; definition du sous-systeme Classif de Shirka
(de :classer (inst)
    (untilexit retour
            (tag erreur
                 ; decalage de la marge gauche 
                 (with ((lmargin (+ (lmargin) 8)))
                       (:commande 'dial-cl "Classif : "))
                 )))

;;; demande de specialisation d'une instance vers une classe unique
;;; il n'y a pas rattachement de l'instance a cette classe.
(de :specialiser-inst (inst)
    (:impr-res (#:shirka:classif:spec-inst 
                       (#:shirka:noyau:schema 
                               (#:shirka:noyau:val-inst inst 3))
                       (#:shirka:noyau:val-inst inst 4)
                       (#:shirka:noyau:val-inst inst 5)
                       (#:shirka:noyau:val-inst inst 6)
                       (let ((binf (#:shirka:noyau:val-inst inst 7)))
                            (or (eq binf 'vrai) (eq binf 'oui)))
                       ; avec dialogue si echec inference
                       (let ((bdial (#:shirka:noyau:val-inst inst 8)))
                            (and (neq bdial 'faux) (neq bdial 'non))))))

;;; demande de classification d'une instance vers une classe donnee
;;; comme origine et toutes ses filles.
(de :classer-inst (inst)
    (#:shirka:classif:impression
            (#:shirka:classif:class-inst
                    (#:shirka:noyau:schema 
                            (#:shirka:noyau:val-inst inst 3))
                    (#:shirka:noyau:val-inst inst 4)
                    (#:shirka:noyau:val-inst inst 5)
                    (#:shirka:noyau:val-inst inst 6)
                    ; mode guide?
                    (let ((bguide (#:shirka:noyau:val-inst inst 9)))
                         (and (neq bguide 'faux) 
                              (neq bguide 'non)))
                    ; avec inference ?
                    (let ((binf (#:shirka:noyau:val-inst inst 7)))
                         (or (eq binf 'vrai) (eq binf 'oui)))
                    ; avec dialogue si echec inference
                    (let ((bdial (#:shirka:noyau:val-inst inst 8)))
                         (and (neq bdial 'faux) (neq bdial 'non))))))

;;; rattachement d'une instance a une classe
(de :rattacher-inst (inst)
    (let ((nom-classe (#:shirka:noyau:val-inst inst 4)))
         (:impr-res
                 (#:shirka:classif:ratt-inst 
                         (#:shirka:noyau:schema 
                                 (#:shirka:noyau:val-inst inst 3))
                         nom-classe))))

;;; demande de nettoyage de toutes les marques des renseignements deja
;;; obtenus sur la specialisation ou classification d'instance.
(de :nettoyage (inst)
    (let ((liste-instances (#:shirka:noyau:val-inst inst 3)))
         (:impr-res (#:shirka:classif:fin-cl liste-instances))))

;;; demande d'explication de la specialisation d'une instance dans une classe
(de :explication (inst)
    (#:shirka:classif:expl-cl 
            (#:shirka:noyau:val-inst inst 3)
            (#:shirka:noyau:val-inst inst 4)))

;;; liste des specialisations d'une classe 
;;; avec mention des explications d'une classification
(de :impr-l-spec-t-expl (liste-spec nom-instance marge-g)
    (mapcan '(lambda (spec)
                     (let ((mention (#:shirka:classif:prop-inst 
                                            (getprop nom-instance 'inst-bid) spec)))
                          (unless mention
                                  (setq mention "?"))
                          (unless 
                                  (or (getprop spec 'est-un-filtre)
                                      (getprop spec 'spec-loc)
                                      (getprop spec 'traite))
                                  (putprop spec t 'traite)
                                  ; impression du nom de la classe
                                  (prin (makestring marge-g #/ ) spec)
                                  ; impression de la mention
                                  (print " (" mention ") ")
                                  (unless (eq mention 'impossible)
                                          (let ((liste-spec  
                                                        (#:shirka:noyau:l-spec 
                                                                (#:shirka:noyau:schema 
                                                                        spec))))
                                               (when liste-spec
                                                     (:impr-l-spec-t-expl 
                                                             liste-spec nom-instance 
                                                             (+ marge-g 4))))))))
            liste-spec))

;;; demande d'explication globale de la classification d'une instance
(de #:shirka:top:expl-globale (inst)
    (let ((nom-schema (#:shirka:noyau:val-inst inst 4))
          (nom-instance (#:shirka:noyau:val-inst inst 3)))
         (let ((nom-schema 
                       (if nom-schema 
                           nom-schema
                           (#:shirka:classif:chef-fam 
                                   (vref (#:shirka:noyau:schema nom-instance) 
                                         %est-un)))))
              (:impr-l-spec-t-expl (list nom-schema)  nom-instance 0)
              (#:shirka:noyau:demarquer-fils (#:shirka:noyau:schema nom-schema))
              (:impr-res  nom-instance))))

;;; affichage de la valeur d'un attribut d'instance classee
(de :v? (inst)
    (:impr-res (#:shirka:classif:v? (#:shirka:noyau:val-inst inst 4)
                       (#:shirka:noyau:val-inst inst 3))))

;;; visualisation de tous les attributs
(de :vi-c (inst)
    (#:shirka:classif:vi-c (#:shirka:noyau:val-inst inst 3))
    (:impr-res (#:shirka:noyau:val-inst inst 3)))

;;; ajout de valeur dans un attribut d'instance classee
(de :a-v (inst)
    (:impr-res (#:shirka:classif:a-v (#:shirka:noyau:val-inst inst 5)   ; instance
                       (#:shirka:noyau:val-inst inst 3)                 ; attribut
                       (#:shirka:noyau:val-inst inst 4))))              ; valeur

;;; modification de valeur dans un attribut d'instance classee
(de :m-v (inst)
    (:impr-res (#:shirka:classif:m-v (#:shirka:noyau:val-inst inst 6)   ; instance
                       (#:shirka:noyau:val-inst inst 3)                 ; attribut
                       (#:shirka:noyau:val-inst inst 5)                 ; valeur
                       (#:shirka:noyau:val-inst inst 4))))              ; nouvelle valeur

;;; suppression de valeur dans un attribut d'instance classee
(de :s-v (inst)
    (:impr-res (#:shirka:classif:s-v (#:shirka:noyau:val-inst inst 5)   ; instance
                       (#:shirka:noyau:val-inst inst 3)                 ; attribut
                       (#:shirka:noyau:val-inst inst 4))))              ; valeur

;;; execution d'un schema methode
(de :executer (inst)
    (let ((nom-methode (#:shirka:noyau:val-inst inst 3)))
         (:impr-res
                 (when (#:shirka:noyau:sorte-de? nom-methode 'attach-proc)
                       (slet ((sch-meth (#:shirka:noyau:schema nom-methode))
                              ; creation de l'instance
                              (l-att (#:shirka:noyau:l-nom-att-inst-he sch-meth))
                              ; initialisation de l'instance
                              (inst (makevector (length l-att) nil))
                              ; nom de l'instance
                              (nom-inst (#:shirka:comp:gen-symbole nom-methode)))
                             (vset inst %nom-inst nom-inst)
                             (putprop nom-inst inst 'schema)
                             (putprop nom-inst 0  'nb-indet)
                             ; liaison est-un     
                             (#:shirka:moteur:creer-est-un inst nom-methode)
                             (vset inst %est-un nom-methode)
                             ; remplissage en interactif
                             (tag fin-inst
                                  (mapc 
                                        '(lambda (nom-att)
                                                 (ifn (eq nom-att 'lui-meme)
                                                      (:dem-valeur sch-meth nom-att inst nil nil t nil)))
                                        (cdddr l-att)))
                             (when (#:shirka:moteur:verif-lui-meme sch-meth inst) 
                                   ; appel de la fonction
                                   (let ((resultat (funcall 
                                                           (#:shirka:noyau:val-fac-he
                                                                   sch-meth 'nom-fct '$valeur)
                                                           inst)))
                                        ; visualisation de l'instance apres execution
                                        (prog1 
                                               (#:shirka:vi:visualiser inst nil nil 0 nil)
                                               (terpri))
                                        resultat)
                                   ))))))

;;; demande d'information sur une liste de classes
(de :info (inst)
    (mapc '(lambda (nom-classe)
                   (let ((classe (#:shirka:noyau:schema nom-classe)))
                        (when classe
                              (print "Classe : " nom-classe)
                              (let ((com (#:shirka:noyau:val-fac-he classe 'lui-meme '$com)))
                                   (mapc 'print com)
                                   (if com (terpri))))))
          (#:shirka:noyau:val-inst inst 3)))

;;; demande d'informations sur des attributs d'une classe
(de :info-att (inst)
    (let ((nom-classe (#:shirka:noyau:val-inst inst 3))
          (liste-att (#:shirka:noyau:val-inst inst 4)))
         (let ((classe (#:shirka:noyau:schema nom-classe)))
              (print "Classe : "  nom-classe) 
              (let ((com (#:shirka:noyau:val-fac-he classe 'lui-meme '$com)))
                   (mapc 'print com))
              (print "Attributs :")
              ; par defaut, tous les attributs de la classe
              (ifn liste-att 
                   (setq liste-att (cdddr (#:shirka:noyau:l-nom-att-he classe))))
              (mapc '(lambda (nom-att)
                             (print  nom-att)
                             ; impression du commentaire associe a l'attribut
                             (let ((com (#:shirka:noyau:val-fac-he classe nom-att '$com)))
                                  (mapc '(lambda (ligne)
                                                 (print "     " ligne))
                                        com))
                             ; impression de la nature et du type de l'attribut
                             (let (((nat type) (#:shirka:noyau:nature classe nom-att)))
                                  (print "     " nat " " type))
                             ; impression des domaine, intervalle et valeur par defaut
                             (slet ((attrib (#:shirka:noyau:attrib-he 
                                                    classe nom-att))
                                    (def (#:shirka:noyau:val-fac-he 
                                                 classe nom-att '$defaut))
                                    (val  (#:shirka:noyau:val-fac-he 
                                                  classe nom-att '$valeur))
                                    (infer-proc (#:shirka:noyau:val-fac-he 
                                                        classe nom-att '$sib-exec))
                                    (infer-filtre (#:shirka:noyau:val-fac-he 
                                                          classe nom-att '$sib-filtre))
                                    (dom (vref attrib %dom))
                                    (sauf (vref attrib %sauf))
                                    (int (vref attrib %int)))
                                   (when infer-proc 
                                         (print "     inferable par attachement procedural"))
                                   (when infer-filtre
                                         (print "     inferable par filtrage"))
                                   (when dom
                                         (prin "     " "domaine : ")
                                         (mapc '(lambda (val)
                                                        (prin val " "))
                                               dom)(terpri))
                                   (when int
                                         (prin "     " "intervalle : ")
                                         (mapc '(lambda (val)
                                                        (prin "[" (car val) " " (cadr val)  "] "))
                                               int)(terpri))
                                   (when sauf
                                         (prin "     " "sauf : ")
                                         (mapc '(lambda (val)
                                                        (prin val " "))
                                               sauf)(terpri))
                                   (when val
                                         (print "     valeur : " val))
                                   (when def
                                         (print "     " "par defaut : " def))))
                    liste-att))))

;;; tableur
(de :tableur (inst)
    (if (typefn '#:shirka:tabl:tableur)
        (#:shirka:tabl:tableur inst)
        (print "Le tableur ShirCalc n'est pas charge.")))

;;; chargement de schemas inscrits dans un fichier
(de #:shirka:top:charger-fic (inst)
    (let ((nom-fichier (catenate #:shirka:*bases* (#:shirka:noyau:val-inst inst 3)))
          (un-schema) )
         (if (probefile nom-fichier)
             (progn 
                    (print "Chargement de la base " nom-fichier)
                    (with ((inchan (openi nom-fichier))
                           (typech '|{| 'cmsymb)
                           (typech '|}| 'cmsymb)
                           (typech '|&| 'cmsymb)
                           (typech '|[| 'cmsymb)
                           (typech '|]| 'cmsymb)
                           (typech '|;| 'cmsymb))
                          (:impr-res
                                  (tag erreur-descr
                                       (untilexit eof
                                               (let ((caract (read)))
                                                    (setq %deja-compile ())
                                                    (if (consp caract) ; lecture d'une fonction Lisp
                                                        (eval caract)
                                                        ; on evalue le schema shirka:
                                                        (setq un-schema (#:shirka:top:trad-sch caract () ))
                                                        (if un-schema
                                                            ; le schema existe (ce n'est pas du commentaire)
                                                            (def-sh un-schema)))))
                                       nom-fichier))))
             (print "Erreur : la base " nom-fichier " n'existe pas.")
             (:impr-res '()))))

;;; traduction forme externe non parenthesee a forme parenthesee
;;; type-att a une valeur non-nil si le schema a lire est 
;;; une instance non partageable
;;; === modif === admettre des commentaires lisp entre des schemas shirka
;;;
(de #:shirka:top:trad-sch (caract bsch-inst)
    (let ((nom-sch) (new-us caract))
         (tag traduction
              (when (eq new-us '|;|)
                    ; si commentaire: on va jusqu'a <eol>
                    (setq new-us (readcn))
                    (while (neq new-us #\cr)
                           (setq new-us (readcn)))
                    ; sortie des commentaires avec nil
                    (exit traduction))
              (unless (eq caract '|{|)
                      (:erreur-trad 1))
              (setq nom-sch (if bsch-inst '%%%%% (read))) ; lecture nom du schema
              (let ((descr-sch (list nom-sch)))
                   (unless (symbolp nom-sch)
                           (:erreur-trad 2))
                   (until (eq nom-sch '|}| )
                          (slet ((c-next (read))
                                 (nom-att)
                                 (descr-att (if (equal c-next '|&|) 
                                                (list '|&| (read) (setq nom-att (read)))
                                                (list (setq nom-att c-next)))))
                                (until (or 
                                           (eq nom-att '|;|)
                                           (eq nom-att '|}| ))
                                       (let ((nom-fac (read)))
                                            (while (#:shirka:top:facette? nom-fac)
                                                   (let ((descr-fac (list nom-fac))
                                                         (elem-suiv (read)))
                                                        (until 
                                                               (or 
                                                                   (#:shirka:top:facette?
                                                                           elem-suiv)
                                                                   (eq elem-suiv '|;|)
                                                                   (eq elem-suiv '|}|))
                                                               (when (eq elem-suiv '|{|)  
                                                                     ; la valeur de la facette est un schema
                                                                     (setq elem-suiv 
                                                                           (#:shirka:top:trad-sch '|{| (eq nom-fac '=))))
                                                               (when (eq elem-suiv '|[|)
                                                                     ; la valeur de la facette est un intervalle
                                                                     (setq elem-suiv (list (read) (read)))
                                                                     (unless (eq (read) '|]|)
                                                                             (:erreur-trad 3)))
                                                               (newr descr-fac
                                                                     elem-suiv)
                                                               (setq elem-suiv
                                                                     (read)))
                                                        (setq nom-fac elem-suiv)
                                                        (newr descr-att descr-fac)))
                                            (setq nom-att nom-fac))
                                       (newr descr-sch descr-att))
                                (setq nom-sch nom-att)))
                   descr-sch))))

;;; vrai si nom-fac est un nom de facette
(de #:shirka:top:facette? (nom-fac)
    (or (eq nom-fac '=)
        (memq nom-fac %liste-toutes-facettes)))

;;; traitement des erreurs de traduction
(de #:shirka:top:erreur-trad (numero)
    (print 
           "Erreur: "
           (selectq numero
                   (1  "caractere { attendu")
                   (2  "le nom du schema n'est pas un symbole")
                   (3  "caractere ] attendu")))
    (exit erreur-descr))

(de :sauver-inst (inst)
    (:impr-res
            (let ((l-nom-classe (#:shirka:noyau:val-inst inst 3))
                  (nom-base   (catenate #:shirka:*bases* (#:shirka:noyau:val-inst inst 4))))
                 (unless 
                         (and (probefile nom-base)
                              (prin  "La base " nom-base 
                                    " existe deja. Continuer ")(flush)
                              (with ((prompt "(o/n)? "))
                                    (eq (read) 'n)))
                         (with ((outchan (openo nom-base)))
                               (protect 
                                       (progn 
                                              (mapc '(lambda (nom-classe)
                                                             (if (getprop nom-classe 'schema)
                                                                 (mapc '(lambda (nom-sch)
                                                                                (#:shirka:vi:visualiser
                                                                                        (#:shirka:noyau:schema nom-sch)
                                                                                        nil nil
                                                                                        0 nil)
                                                                                (terpri))
                                                                       (#:shirka:noyau:l-inst-t (#:shirka:noyau:schema nom-classe)))))
                                                    l-nom-classe)
                                              (terpri))
                                       (close (outchan))))
                         nom-base))))

;;; fonctions associees aux methodes predefinies
;;; methode demander
(de :demander (inst)
    (let ((schema (#:shirka:noyau:classe-de (val? 'instance))))
         (with ((prompt (catenate 
                                (apply 'catenate 
                                       ; commentaire sur l'attribut comme liste de chaines 
                                       (#:shirka:noyau:val-fac-he
                                               schema
                                               (val? 'attribut)
                                               '$com))
                                " de " (val? 'instance) " ? ")))
               (if (eq (car (#:shirka:noyau:nature schema (val? 'attribut)))
                       '$un)
                   (affect 'reponse (read))
                   (let ((liste) (rep (read)))
                        (until (eq rep '-)
                               (setq liste (nconc1 liste rep))
                               (setq rep (read)))
                        liste)))))

;;; methode ranger-valeur
(de :ranger-valeur (inst)
    (#:shirka:moteur:aj-valeur
            (#:shirka:noyau:schema (val? 'instance))
            (val? 'attribut)
            (val? 'valeur)
            () ))
