(defvar #:sys-package:colon '#:shirka:top)

;;; fonction de demarrage de Shirka
(de shirka ()
    (untilexit retour
            (tag erreur
                 (:commande 'shirka "Shirka : ")))
    'au-revoir)


;;; creation en interactif d'une instance de "schema"
;;; utilisee par "util-par", renvoie le nom de l'instance
(de :creer (schema pour-classes sauf-classes util-par bprem-niv)
    (when (or 
              (and (not pour-classes) (not sauf-classes))
              sauf-classes)
          (setq sauf-classes (nconc1 sauf-classes 'Attribut-Shirka)))
    (let ((nom-sch (#:shirka:noyau:nom-sch schema)))
         (if (getprop nom-sch 'spec-loc)
             (setq nom-sch (car (#:shirka:noyau:peres schema))))
         (prin "Classe : ") (:aff-nom-classe nom-sch) (terpri)
         ; on peut vouloir instancier une sous-classe de "schema"
         (let ((nom-ssclasse (:dem-nom-ssclasse schema)))
              (if nom-ssclasse
                  (setq nom-sch nom-ssclasse 
                        schema (#:shirka:noyau:schema nom-ssclasse))))
         (let ((l-att (#:shirka:noyau:l-nom-att-inst-he schema))
               (l-att-dem (#:shirka:noyau:l-nom-att-inst-he-class 
                                  schema pour-classes sauf-classes)))
              ; initialisation de l'instance
              (let ((inst (makevector (length l-att) nil))
                    ; nom de l'instance
                    (nom-inst (:dem-nom-inst nom-sch bprem-niv)))
                   (vset inst %nom-inst nom-inst)
                   (putprop nom-inst inst 'schema)
                   (putprop nom-inst 0 'nb-indet)
                   ; liaison est-un     
                   (#:shirka:moteur:creer-est-un inst nom-sch)
                   (vset inst %est-un nom-sch)
                   (if util-par ;liaison util-par
                       (#:shirka:moteur:aj-util-par inst util-par)) 
                   (tag fin-inst
                        (mapc 
                              '(lambda (nom-att)
                                       (ifn (eq nom-att 'lui-meme)
                                            (:dem-valeur schema nom-att inst 
                                                    pour-classes sauf-classes t nil)))
                              l-att-dem))
                   (if (#:shirka:moteur:verif-lui-meme schema inst) 
                       (progn 
                              (#:shirka:moteur:filtrage:filt-const-anc 
                                      nom-inst nom-sch)
                              ; reprise des admissibilites non resolues 
                              ; si l'instance est elle-meme complete
                              (if (= (getprop nom-inst 'nb-indet) 0)
                                  (#:shirka:comp:traiter-liste-reprise  
                                          nom-inst))
                              ; on renvoie le nom d'une instance partageable
                              ; mais l'instance elle meme si non partageable
                              (if (getprop nom-inst 'non-part)
                                  inst nom-inst))
                       (prin "Erreur : instance " nom-inst " incorrecte ; ")
                       (print "predicats globaux non verifies")
                       (#:shirka:moteur:sup-inst inst t ) 'echec)))))

;;; demande le nom de la sous-classe de "schema" a l'utilisateur et
;;; le verifie. Renvoie nil si pas de nom fourni.
(de :dem-nom-ssclasse (schema)
    ; liste des sous classes vraies pas les filtres et les 
    ; specialisations locales
    (let ((l-ss-classe (#:shirka:noyau:l-spec-t-vraies schema))
          (rep)
          (bcorrect t))
         (when l-ss-classe
               (until (and rep bcorrect)
                      (with ((prompt " ? "))
                            (prin "Sous-classe")(flush)
                            (setq bcorrect t)
                            (setq rep (:lecture))
                            (selectq rep
                                    (-)
                                    (?  (print "un symbole")
                                        (setq bcorrect nil))
                                    (?? (print "Sous-classes connues : ")
                                        (:impr-l-spec-t 
                                                l-ss-classe 999 0 0)
                                        (#:shirka:noyau:demarquer-fils schema)
                                        (setq bcorrect nil))
                                    (t (unless 
                                               (and rep
                                                    (symbolp rep)
                                                    (getprop rep 'schema)
                                                    (#:shirka:noyau:sorte-de? 
                                                            rep 
                                                            (#:shirka:noyau:nom-sch schema)))
                                               (print "nom de classe inexistante ou incorrecte")
                                               (setq bcorrect nil))))))
               (ifn (eq rep '-) rep))))

;;; demande le nom d'instance a l'utilisateur
;;; si la reponse est -, l'instance est consideree comme une valeur
;;; donc non partageable (meme si un nom lui est attribue)
(de :dem-nom-inst (nom-sch bprem-niv)  
    (let ((rep nil))
         (until (and rep (symbolp rep))
                (with ((prompt "Nom de l'instance ? "))
                      (setq rep (:lecture))
                      (selectq rep
                              (- ; generation d'un nom si pas premier niveau
                                 (if bprem-niv
                                     (progn 
                                            (setq rep nil)
                                            (print 
                                                   "L'instance doit recevoir un nom.")) 
                                     (setq rep 
                                           (#:shirka:comp:gen-symbole nom-sch))
                                     (putprop rep t 'non-part)))
                              (? 
                                 (if bprem-niv ; vrai si premier niveau 
                                               ; d'instanciation interactive
                                     (print "un symbole") 
                                     (print 
                                            "un symbole si l'instance est un objet partageable")
                                     (print 
                                            "le signe - si l'instance est une valeur"))
                                 (setq rep () ))
                              (??
                                  (let ((nom-chef-fam (#:shirka:classif:chef-fam nom-sch)))
                                       (print "Instances existantes de la famille " nom-chef-fam " : ")
                                       (mapc '(lambda (val)
                                                      (prin val " "))
                                             (#:shirka:noyau:l-inst-t
                                                     (#:shirka:noyau:schema nom-chef-fam)))
                                       (terpri)
                                       (setq rep () )))
                              (t
                                 (when (and (symbolp rep)
                                            (getprop rep 'schema))
                                       (print "Instance existante")
                                       (setq rep () ))))))
         rep))

;;; demande la valeur de l'attribut "nom-att" de "instance" a l'utilisateur
;;; si "branger" est vrai, la valeur est rangee dans l'attribut
;;; si elle est admissible. Dans tous les cas, la valeur est renvoyee.
;;; "bcommande" est vrai si on est dans un appel de commande
;;; par opposition au cr-inst 
(de :dem-valeur (schema nom-att instance 
                        pour-classes sauf-classes branger bcommande)
    (with ((prompt (catenate (makestring (lmargin) #/ ) nom-att " ? ")))
          (slet (((nature type) (#:shirka:noyau:nature schema nom-att))
                 (nom-inst (#:shirka:noyau:nom-sch instance))
                 (bliste-de (eq nature '$liste-de)))
                (let ((brepeter t)
                      (res)(rep)
                      (pos-att (#:shirka:noyau:pos-nom-att schema nom-att))
                      (nb-att (vlength instance))
                      (valeur-prec (if bcommande 
                                       (#:shirka:moteur:valeur? nom-att nom-inst))))
                     (vset instance pos-att nil)
                     (tag fin-val
                          (while brepeter
                                 (let ((erreur nil))     
                                      (setq rep (:lecture))
                                      (selectq rep
                                              (? ;demande d'informations sur l'attribut
                                                 (let ((com (#:shirka:noyau:val-fac-he 
                                                                    schema nom-att '$com)))
                                                      ; impression du commentaire
                                                      (when com 
                                                            (mapc 'prin com)(prin " : "))
                                                      (prin (if bliste-de 
                                                                "liste de " "un "))
                                                      (:aff-nom-classe type)(terpri)
                                                      ; pour boucler sur lecture
                                                      (setq erreur t)))  
                                              (?? ; demande d'informations sur le domaine,
                                                  ; les intervalles, les sauf 
                                                  ; et les valeurs par defaut
                                                  (slet ((attrib 
                                                                 (#:shirka:noyau:attrib-he 
                                                                         schema nom-att))
                                                         (def (#:shirka:noyau:val-fac-he 
                                                                      schema nom-att '$defaut))
                                                         (dom (vref attrib %dom))
                                                         (sauf (vref attrib %sauf))
                                                         (int (vref attrib %int)))
                                                        (when dom
                                                              (prin "domaine: ")
                                                              (mapc '(lambda (val)
                                                                             (prin val " "))
                                                                    dom)(terpri))
                                                        (when int
                                                              (prin "intervalle: ")
                                                              (mapc '(lambda (val)
                                                                             (prin "[" (car val) " " (cadr val) "]  "))
                                                                    int)(terpri))
                                                        (when sauf
                                                              (prin "sauf: ")
                                                              (mapc '(lambda (val)
                                                                             (prin val " "))
                                                                    sauf)(terpri))
                                                        (when def
                                                              (print "par defaut: " def))
                                                        (setq erreur t)))
                                              (???   ; liste des reponses possibles
                                                   (print "?  commentaire et type de l'attribut")
                                                   (print "?? domaine, intervalle, sauf et valeur par defaut")
                                                   (print "-  pas de valeur ou fin de liste de valeurs")
                                                   (print "=  valeur de l'appel precedent")
                                                   (print "<  cet attribut et les suivants ne recoivent pas de valeur")
                                                   (print ">  poursuite de l'instantiation")
                                                   (print "<< cet attribut et les  suivants recoivent " 
                                                          "leurs valeurs de l'appel precedent")
                                                   (print "&  empilement d'appel")
                                                   (print "+  appel Lisp")
                                                   (setq erreur t))
                                              (- ; pas de valeur ou fin de liste de valeurs
                                                 (exit fin-val))
                                              (= ; valeur de l'appel precedent
                                                 (setq rep valeur-prec))
                                              (< ; fin de l'instanciation courante et fin de liste si liste en cours
                                                 (when bliste-de
                                                       (setq pos-att (add1 pos-att)))
                                                 (until (eq pos-att nb-att)
                                                        (vset instance pos-att ())
                                                        (setq pos-att (add1 pos-att)))
                                                 (exit fin-inst)) 
                                              (<< ; reprise des anciennes valeurs
                                                  (vset instance pos-att valeur-prec)
                                                  (exit fin-inst))
                                              (> ; poursuite de l'instanciation 
                                                 (ifn (#:shirka:noyau:type-simple? type) 
                                                      ; decalage de la marge gauche 
                                                      (with ((lmargin (+ (lmargin) 8)))
                                                            (let ((instp 
                                                                         (:creer 
                                                                                 (#:shirka:noyau:schema type)
                                                                                 pour-classes sauf-classes
                                                                                 ; utilise par 
                                                                                 (vref instance %nom-inst)
                                                                                 nil)))
                                                                 ; restaurer les positions
                                                                 (#:shirka:noyau:l-nom-att-inst-he schema)
                                                                 (setq rep instp)))  
                                                      (:msg "impossible pour un type simple")(terpri)
                                                      (setq erreur t)))
                                              (t ))
                                      (when 
                                            (and rep (not erreur))
                                            (setq rep (if branger 
                                                          (#:shirka:moteur:aj-valeur 
                                                                  instance nom-att rep t)
                                                          (#:shirka:moteur:admissible? 
                                                                  rep nom-att schema instance)))
                                            (if rep
                                                (setq res (if bliste-de 
                                                              (nconc1 res rep)
                                                              rep))
                                                (:msg "valeur non admissible")
                                                (terpri)
                                                (setq erreur t)))
                                      (setq brepeter (or erreur bliste-de)))))
                     res))))

;;; fonction generale de lecture autorisant des appels de commande 
(de :lecture ()
    ; les caracteres speciaux sont ignores
    (with ((typecn #/, cnull) 
           (typecn #/# cnull))
          (let ((rep (read)))
               (while (eq rep '&)
                      ; empilement contexte de commande               
                      (with ((lmargin (+ (lmargin) 8)))
                            (tag retour
                                 (:commande 'shirka "Shirka : ")))
                      (setq rep (read)))
               (while (eq rep '+)
                      ; top-level Lisp
                      (with ((prompt "Lisp : "))
                            (print (eval (read))))
                      (setq rep (read)))
               rep)))

;;; appel des commandes
(de :commande (nom-sous-systeme nom-prompt)
    (with ((prompt (catenate (makestring (lmargin) #/ ) 
                           nom-prompt)))
          (slet ((nom-com (:dem-nom-com nom-sous-systeme))
                 (instance (getprop nom-com 'instance))) 
                (if (eq nom-com '-)
                    ; sortie de Shirka ou du niveau de commande
                    (exit retour))
                (slet ((schema (#:shirka:noyau:schema nom-com))
                       (l-att (#:shirka:noyau:l-nom-att-inst-he schema))
                       (inst
                             (if instance instance
                                 (let 
                                      ((nom-inst (#:shirka:comp:gen-symbole 
                                                         nom-com))
                                       (inst (makevector (length l-att) () )))
                                      (vset inst %nom-inst nom-inst)
                                      (putprop nom-inst inst 'schema)
                                      (#:shirka:moteur:creer-est-un inst nom-com)
                                      (putprop nom-com inst 'instance)
                                      inst))))
                      ; lecture des valeurs des attributs 
                      ; decrivant les parametres
                      (tag fin-inst
                           (mapc 
                                 '(lambda (nom-att)
                                          (:dem-valeur schema nom-att inst nil nil t t))
                                 (cdddr l-att)))
                      ; appel de la fonction associee a la commande
                      (funcall (#:shirka:noyau:val-fac-he 
                                       schema 'nom-fct '$valeur) 
                              inst)
                      ))))

;;; lit le nom de commande, le verifie et le renvoie
(de :dem-nom-com (nom-sous-systeme)
    (let ((rep)(binfo)
          (bcorrect))
         (until bcorrect
                (setq bcorrect t binfo () )
                (setq rep (:lecture))
                (selectq rep
                        (-  )  ; retour
                        (?     ; liste des commandes disponibles
                           (prin "Commandes disponibles : ")
                           (mapc 
                                 '(lambda (nom-com)
                                          (if (#:shirka:noyau:val-facette 
                                                      (#:shirka:noyau:schema nom-com)
                                                      'nom-fct '$valeur)
                                              (prin nom-com " ")))
                                 (#:shirka:noyau:l-spec-t 
                                         (#:shirka:noyau:schema 
                                                 nom-sous-systeme)))
                           (terpri)
                           (setq bcorrect nil))
                        (t  (when (eq (car (explodech rep)) '?)
                                  (setq rep (implodech (cdr (explodech rep))))
                                  (setq binfo t))
                           (if (and rep
                                    (symbolp rep)
                                    (getprop rep 'schema)
                                    (#:shirka:noyau:sch-classe? 
                                            (getprop rep 'schema))
                                    (#:shirka:noyau:sorte-de?
                                            rep 'methode))
                               (if binfo
                                   ; impression du commentaire sur la commande
                                   (let ((com (#:shirka:noyau:val-fac-he 
                                                      (#:shirka:noyau:schema 
                                                              rep) 'lui-meme '$com)))
                                        (when com 
                                              (mapc 'prin com)(terpri))
                                        (setq bcorrect nil))
                                   rep)
                               (print "commande inconnue : " rep)
                               (setq bcorrect nil)))))
         rep))

(de :msg (message)
    (prin message)(flush))

;;; affiche le nom d'une classe en enlevant eventuellement
;;; les prefixes et suffixes des specialisations locales
(de :aff-nom-classe (nom-classe)
    (prin (if (or (getprop nom-classe 'est-un-filtre)
                  (getprop nom-classe 'spec-loc))
              (car (vref (#:shirka:noyau:schema nom-classe) 
                         %sorte-de))
              nom-classe) " "))
