(defvar #:sys-package:colon '#:shirka:comp)

;;; position du premier attribut utile dans une instance
(defvar %prem-att 3)
;;; positions des meta-attributs
(defvar %est-un 0)   ; lien est-un d'instance a classe
(defvar %util-par 1) ; lien util-par
(defvar %nom-sch 2)  ; nom d'un schema de classe
(defvar %nom-att 3)  ; nom d'attribut
(defvar %nom-inst 2) ; nom d'une instance
(defvar %list-att 3) ; liste des attributs d'un schema
(defvar %list-fac 4) ; liste des facettes d'un attribut
(defvar %nat 5)      ; nature d'un attribut: $un ou $liste-de
(defvar %type 6)     ; type d'un attribut
(defvar %dom  7)     ; domaine d'un attribut
(defvar %int  8)     ; intervalle d'un attribut
(defvar %sauf 9)     ; sauf d'un attribut
(defvar %list-val 3) ; liste des valeurs d'une facette            
(defvar %sorte-de 4) ; lien sorte-de de classe a classe
(defvar %spec 5)     ; liste des specialisations d'une classe    
(defvar %inst 6)     ; liste des instances d'une classe

(putprop 'inst 6 'position)
(putprop 'inst '($liste-de symbole) 'nature)

;;; les listes de facettes
(defvar %liste-toutes-facettes
        (#:shirka:noyau:l-spec-t
                (#:shirka:noyau:schema 'facette)))
(defvar %liste-F-multi 
        (#:shirka:noyau:l-spec-t
                (#:shirka:noyau:schema 'F-multi))) 
(defvar %liste-F-var 
        (#:shirka:noyau:l-spec-t 
                (#:shirka:noyau:schema 'F-var)))
(defvar %liste-F-type
        (#:shirka:noyau:l-spec-t 
                (#:shirka:noyau:schema 'F-type))) 
(defvar %liste-F-card 
        (#:shirka:noyau:l-spec-t 
                (#:shirka:noyau:schema 'F-card))) 
(defvar %liste-F-mono-multi
        (#:shirka:noyau:l-spec-t 
                (#:shirka:noyau:schema 'F-mono-multi)))
(defvar %liste-F-intervalle 
        (#:shirka:noyau:l-spec-t 
                (#:shirka:noyau:schema 'F-intervalle)))
(defvar %liste-F-fil-att
        (#:shirka:noyau:l-spec-t 
                (#:shirka:noyau:schema 'F-fil-att))) 
 
;;; pour eviter d'etre oblige de charger l'explication
(de #:exp:init-exp () ) 
(#:exp:init-exp)

;;; taille d'un attribut (nombre d'attributs instanciables)
(defvar %taille-att 10)                                         
           
;;; taille d'une instance de facette
(defvar %taille-fac 4)  ; car nom n'est pas instanciable dans les
                        ; specialisations de <facette>


;;; passe de la description externe d'un schema sous forme de A-liste
;;; a la representation interne qu'elle renvoie et qu'elle place en
;;; propriete 'schema' du nom du schema
(de :ext-int ((nom-sch . attributs))
    (setq %deja-compile nil)
    (setq %nom-schema-en-cours nom-sch)  
    (slet ( ; obtention du nom de meta-schema, par defaut <schema>
             (nom-meta-sch (car (cassq '= (cassq 'est-un attributs))))
             (nom-meta-sch (if nom-meta-sch nom-meta-sch 'schema))
             (meta-sch (#:shirka:noyau:schema nom-meta-sch))
             (l-att (#:shirka:noyau:l-nom-att-inst-he meta-sch))
             (schema (makevector (length l-att) nil))
             ; obtention des noms des peres
             (peres (cassq '= (cassq 'sorte-de attributs))))
          (let ((ex-def (getprop nom-sch 'schema)))
               (when ex-def                   ; le schema existait deja
                     (print "Attention: redefinition du schema " nom-sch)
                     ; remise a nil des proprietes schema, filtres, l-att,
                     ; dem, ass, f-imb, def, ordre-att, traite, lie, w-inst
                     (remprop nom-sch 'filtres)
                     (remprop nom-sch 'ordre-att)
                     (remprop nom-sch 'nb-indet)
                     (remprop nom-sch 'w-inst)
                     (remprop nom-sch 'lie)
                     (remprop nom-sch 'l-att)
                     (remprop nom-sch 'dem)
                     (remprop nom-sch 'ass)
                     (remprop nom-sch 'f-imb)
                     (remprop nom-sch 'def)
                     (when (#:shirka:noyau:sch-classe? ex-def)
                           ; schema de classe
                           ; recuperation des valeurs des attributs util-par,
                           ; inst et spec (ce dernier apres nettoyage)
                           (vset schema %util-par (vref ex-def %util-par))
                           (vset schema %inst (vref ex-def %inst))
                           (vset schema %spec 
                                 ; nettoyage memoire, en particulier pour les 
                                 ; facettes $sib-xxx et les specialisations locales
                                 (:sup-filt-spec-loc ex-def)))
                     ; schema de classe et d'instance
                     (remprop nom-sch 'schema) 
                     (remprop nom-sch 'traite))
               (vset schema %nom-sch  nom-sch)
               (#:shirka:moteur:creer-est-un 
                       schema (if nom-meta-sch nom-meta-sch 'schema))
               (putprop nom-sch schema 'schema)
               (putprop nom-sch 0 'nb-indet)
               (ifn peres   
                    ; si peres est nil => schema d'instance
                    (:trad-l-att meta-sch schema attributs)
                    ; schema de classe
                    (#:shirka:moteur:creer-sorte-de schema peres)
                    (vset schema %list-att 
                          (:trad-l-att meta-sch schema attributs))
                    (mapc '(lambda (attribut)
                                   (let ((nom-att) (facettes))
                                        (if (eq (car attribut) '|&|)
                                            (setq nom-att (caddr attribut) facettes (cdddr attribut))
                                            (setq nom-att (car attribut) facettes (cdr attribut)))
                                        (ifn (cassq '= facettes)
                                             (let (((nature type) 
                                                    (#:shirka:noyau:obtenir-nature schema 
                                                            nom-att))
                                                   (attribut (#:shirka:noyau:attrib schema nom-att)))
                                                  (vset attribut %nat nature)
                                                  (vset attribut %type type)
                                                  (vset attribut %dom
                                                        (#:shirka:noyau:domaine 
                                                                schema nom-att type)) 
                                                  (vset attribut %int
                                                        (#:shirka:noyau:intervalle 
                                                                schema nom-att type))
                                                  (vset attribut %sauf
                                                        (#:shirka:noyau:sauf 
                                                                schema nom-att type))))))
                          attributs)
                    ; verification des instances (dans le cas d'une redefinition)
                    ; apres recompilation de facon a ce que les $a-verifier marchent
                    (when ex-def
                          (:tr-var schema)
                          (:compilation schema)
                          (setq %deja-compile t)
                          (vset schema %inst (:verif-insts
                                                     (vref schema %inst)
                                                     schema))))
               ; verification des predicats globaux (lui-meme)
               (unless (#:shirka:moteur:verif-lui-meme meta-sch schema)
                       (prin "Attention: schema " nom-sch " incorrect; ")
                       (print "predicats globaux non verifies"))
               ; pre-filtrage constant de l'instance
               (#:shirka:moteur:filtrage:filt-const-anc nom-sch nom-meta-sch)
               ; reprise des admissibilites non resolues si l'instance est
               ; elle meme complete
               (if (= (getprop nom-sch 'nb-indet) 0)
                   (:traiter-liste-reprise  nom-sch))
               schema )))

(de :traiter-liste-reprise (nom-sch) 
    (let ((occurrences (assq nom-sch %liste-reprise)))
         (when occurrences
               (mapc '(lambda ((nom-classe nom-inst nom-att))
                              (if (#:shirka:moteur:admissible? nom-sch 
                                          nom-att ; nom d'attribut
                                          (#:shirka:noyau:schema nom-classe) ; schema
                                          (#:shirka:noyau:schema nom-inst))  ; instance
                                  (progn 
                                         (print "La valeur " nom-sch
                                                " de l'attribut " nom-att 
                                                " de l'instance " nom-inst
                                                " de la classe " nom-classe 
                                                " vient d'etre verifiee admissible.")
                                         ; mise a jour du nb. d'indeterminations
                                         (if (= 0
                                                (putprop nom-inst (sub1 
                                                                        (getprop nom-inst 'nb-indet))
                                                        'nb-indet))
                                             (:traiter-liste-reprise nom-inst)))
                                  (print "La valeur " nom-sch
                                         " pour l'attribut " nom-att 
                                         " de l'instance " nom-inst
                                         " de la classe " nom-classe 
                                         " n'est pas admissible.")
                                  (print "Cette valeur est supprimee")
                                  (#:shirka:moteur:sup-valeur 
                                          (#:shirka:noyau:schema nom-inst)
                                          nom-att
                                          nom-sch)))
                     (cdr occurrences))
               ; mise a jour de la liste de reprise
               (setq %liste-reprise 
                     (delete occurrences %liste-reprise)))))

(de :verif-insts (l-nom-inst schema)
    ; renvoie la liste des noms d'instances parmi <l-nom-inst>
    ; qui satisfont la classe schema
    (let ((l-att (#:shirka:noyau:l-nom-att-inst-he schema)))
         (mapcan 
                 '(lambda (nom-inst)
                          (if (:verif-inst nom-inst schema l-att)
                              (list nom-inst)
                              (print "Attention, l'instance " nom-inst
                                     " ne peut plus appartenir a la classe "
                                     (#:shirka:noyau:nom-sch schema))
                              (print "Elle est supprimee!")
                              (#:shirka:moteur:sup-inst 
                                      (#:shirka:noyau:schema nom-inst) t)
                              nil))
                 l-nom-inst)))

(de :verif-inst (nom-inst schema l-att)
    ; verifie que l'instance <nom-inst> peut appartenir a la classe <schema>
    (let ((instance (#:shirka:noyau:schema nom-inst)))
         (tag refus
              ; verification du nombre d'attributs
              (unless (= (length l-att)
                         (vlength instance))
                      (exit refus))
              (mapc  ; parcours de la liste des attributs instanciables
                    '(lambda (nom-att)
                             (let ((valeur (#:shirka:noyau:val-inst instance 
                                                   (#:shirka:noyau:position nom-att))))
                                  (if valeur
                                      (ifn (#:shirka:moteur:admissible? 
                                                   valeur nom-att 
                                                   schema instance)
                                           (exit refus)))))
                    (cdddr l-att))
              ; verification des predicats globaux
              (unless (#:shirka:moteur:verif-lui-meme schema instance)
                      (exit refus))
              t) ; sortie normale du tag refus
         ))

;;; nettoie la memoire occupee par la definition de la classe <schema>
;;; efface les filtres, attachements proceduraux et specialisations 
;;; locales, en particulier les liens 'spec' des classes correspondantes       
(de :sup-filt-spec-loc (schema)
    (mapc 
          '(lambda (att)
                   (mapc 
                         '(lambda (fac)
                                  (let ((nom-fac (vref fac 0))
                                        (val-fac (vref fac %list-val)))
                                       (cond 
                                             ((member nom-fac %liste-F-type)  ; specialisations locales
                                              (if (getprop  val-fac 'spec-loc)
                                                  (:sup-filt-spec-loc 
                                                          (#:shirka:noyau:schema val-fac))))
                                             ((member nom-fac %liste-F-fil-att)
                                              (mapc 
                                                    '(lambda (val-f)
                                                             (:sup-filt-spec-loc 
                                                                     (#:shirka:noyau:schema val-f))) 
                                                    val-fac)))))
                         (#:shirka:noyau:l-fac att)))
          (cdddr (#:shirka:noyau:l-att schema)))
    ; mise a jour des liens spec de la classe superieure
    (let ((super-classe (car (#:shirka:noyau:peres schema))))
         (#:shirka:moteur:sup-valeur 
                 (#:shirka:noyau:schema super-classe) 
                 'spec  
                 (#:shirka:noyau:nom-sch schema)))
    ; suppression de l'ancienne definition 
    ; en tant qu'instance
    (prog1 
           (vref schema %spec)
           (#:shirka:moteur:sup-inst schema () ))
    )

(de :trad-l-att (meta-sch schema attributs)
    (let ((bliste-de)) ; vrai si un attribut est multi-value
         (mapcan 
                 '(lambda (attribut)
                          (let ((c-next (car attribut))
                                (nom-att) (nom-type-attribut) (facettes))
                               (if (neq c-next '|&|)
                                   (setq nom-type-attribut 'attribut
                                         nom-att c-next
                                         facettes (cdr attribut))
                                   (setq nom-type-attribut (cadr attribut)
                                         nom-att (caddr attribut)
                                         facettes (cdddr attribut)))
                               (let ((fac= (cassq '= facettes)))
                                    (ifn fac=        
                                         ; attribut de la classe 
                                         (let ((attribut (makevector %taille-att nil)))
                                              (setq bliste-de 
                                                    (or (cassq '$liste-de facettes)
                                                        (#:shirka:noyau:val-fac-he 
                                                                schema nom-att '$liste-de)))
                                              (vset attribut %est-un nom-type-attribut)
                                              (vset attribut %nom-att nom-att)
                                              (vset attribut %list-fac 
                                                    (:trad-l-fac bliste-de facettes 
                                                            schema))
                                              (list attribut))
                                         ; meta-attribut: sorte-de, est-un, ... 
                                         ; ou attribut d'instance
                                         (slet ((nom-type (cadr (#:shirka:noyau:obtenir-nature
                                                                        meta-sch nom-att)))
                                                (l-val
                                                       (mapcar '(lambda (elem)
                                                                        (if (and (consp elem)
                                                                                 (eq (car elem) '%%%%%))
                                                                            (:detacher-inst elem nom-type)
                                                                            elem))
                                                               fac=))
                                                (val (if (#:shirka:noyau:val-fac-he 
                                                                 meta-sch nom-att '$liste-de) 
                                                         l-val 
                                                         (car l-val))))
                                               (if (#:shirka:moteur:admissible? 
                                                           val nom-att meta-sch schema)
                                                   (vset schema 
                                                         (#:shirka:noyau:pos-nom-att 
                                                                 meta-sch nom-att) 
                                                         val)
                                                   (print "valeur " val " non admissible dans "
                                                          nom-att 
                                                          " de " 
                                                          (#:shirka:noyau:nom-sch schema))))
                                         nil))))
                 attributs)))

(de :sort-sh (fn l)
    ; trie (au moyen de la fonction fn a 2 arguments) la liste l
    (if (null (cdr l))
        l
        (let ((l1 l) (l2))
             (setq l  (nthcdr (1- (div (length l) 2)) l)
                   l2 (cdr l))
             (rplacd l ())
             (:ffusion-sh (:sort-sh fn l1)
                     (:sort-sh fn l2)))))

(de :ffusion-sh (l1 l2)
    ; fusionne physiquement les 2 listes triees l1 et l2
    (unless (funcall fn (car l1) (car l2))
            (psetq l1 l2 l2 l1))
    (prog1 l1
           (while (and (cdr l1) l2)
                  (when (funcall fn (car l2) (cadr l1))
                        (rplacd l1 (prog1 l2 (setq l2 (cdr l1)))))
                  (nextl l1))
           (when l2 (rplacd l1 l2))))

(de :trad-l-fac (bliste-de facettes schema)
    ; tri des facettes par ordre alphabetique de leur nom
    (:sort-sh '#:shirka:comp:compar-fac
            (mapcar 
                    '(lambda ((nom-fac . valeurs))
                             (let ((facette (makevector %taille-fac nil)))                
                                  (vset facette %est-un nom-fac)
                                  (ifn (memq nom-fac %l-fac-filtre)
                                       (vset facette %list-val
                                             (:trad-l-val bliste-de 
                                                     nom-fac valeurs schema))
                                       (let ((l-nom-val (:detacher-filt valeurs)))
                                            (vset facette %list-val l-nom-val)))
                                  facette))
                    facettes)))

(de :compar-fac (fac1 fac2)
    ; realise le predicat a deux arguments necessaire a la fonction sort
    (alphalessp (vref (if (vectorp fac1) 
                          fac1 
                          (#:shirka:noyau:schema fac1)) 0) 
            (vref (if (vectorp fac2) 
                      fac2 
                      (#:shirka:noyau:schema fac2)) 0)))

(de :trad-l-val (bliste-de nom-fac valeurs schema)
    (cond 
          ; facettes mono-valuees
          ; facettes de variables et de cardinalite
          ((or (member nom-fac %liste-F-var) 
               (member nom-fac %liste-F-card)) 
           (car valeurs))
          ; facettes de typage
          ((member nom-fac %liste-F-type) 
           (if (atom (car valeurs))
               (car valeurs)
               (:detacher-spec-loc (car valeurs))))
          
          ; facettes mono- ou multi-valuees selon la nature de l'attribut
          ((member nom-fac %liste-F-mono-multi)
           (if bliste-de
               valeurs
               (car valeurs)))
          
          ; facette $intervalle: liste d'instances du schema "intervalle"
          ((member nom-fac %liste-F-intervalle)
           (mapcar 
                   '(lambda ((min max))
                            (let ((inter (makevector 5 nil)))
                                 (vset inter 0 'intervalle)
                                 (vset inter 3 min)
                                 (vset inter 4 max)
                                 inter))                             
                   valeurs)) 
          
          ; facettes multi-valuees
          ((member nom-fac %liste-F-multi)
           (mapcar 
                   '(lambda (valeur)
                            (if (atom valeur)
                                valeur
                                (:ext-int valeur)))
                   valeurs))
          (t ; **erreur** facette inconnue
             (print "Erreur: facette " nom-fac 
                    " inconnue dans le schema " 
                    (#:shirka:noyau:nom-sch schema))
             (remprop %nom-schema-en-cours 'schema)
             (exit erreur))))

(de :detacher-filt (filtres)
    (mapcar '(lambda (filtre)
                     (let ((nouv-nom-filt 
                                   (:gen-symbole (car filtre))))
                          (:ext-int (:sch-modif filtre nouv-nom-filt))
                          (putprop nouv-nom-filt t 'est-un-filtre)
                          nouv-nom-filt))
            filtres))

(de :detacher-spec-loc (spec-loc)
    (let ((nouv-nom (:gen-symbole (car spec-loc))))
         (:ext-int (:sch-modif spec-loc nouv-nom))
         (putprop nouv-nom t 'spec-loc)
         nouv-nom))

(de :sch-modif (schema nouv-nom)
    (let ((att-sorte-de (list 'sorte-de
                              (cons '= (list (car schema))))))
         (cons nouv-nom
               (cons att-sorte-de (cdr schema)))))
 
(de :detacher-inst (inst nom-type)  
    (let ((nom-inst (:gen-symbole nom-type))
          (att-est-un (ifn (assoc 'est-un inst)
                           (list 'est-un 
                                 (cons '= (list nom-type))))))
         (putprop nom-inst t 'non-part)
         (:ext-int (cons nom-inst
                         (if att-est-un  
                             (cons att-est-un (cdr inst))
                             (cdr inst))))
         (putprop nom-inst t 'non-part)
         nom-inst))
