(defvar #:sys-package:colon '#:shirka:tabl)

;;; Opere le scrolling horizontal. Appelee lorsque le curseur
;;; est en debut ou en bout de ligne.
(de :SCROLL_HOR (droite)
    ( let ( ( sch (:SCH_LGN %ligne) ) )
         ( cond 
               ( ( :ATTCOUR (+ %colonne 
                               (cond (droite +1) 
                                     (t -1)))
                         %ligne )
                ( :MAJ_COLONNE_1 sch droite )
                ( for ( lgn 0 1 %MAXLGN2 )
                     (cond 
                           ( (eq sch (:SCH_LGN lgn))
                            (:affiche lgn) )
                           ( t nil )
                           )     )
                ) 
               ( t ( tybeep ) )
               )
         ( :CURSEUR t )
         )  )

;;; Opere le scrolling vertical. Appelee lorsque le curseur 
;;; est en haut ou en bas du tableau. 
(de :SCROLL_VERT (bas)
    (let ( (sch (:SCH_LGN %ligne)) 
          (ind_ins ( + ( + (:INDICE_LIGNE_1 %sch_cour)
                          %ligne )
                      (cond (bas 1) 
                            (t -1))
                      )        )
          (tabl_ins (cassq %sch_cour DES_INS))
          )
         ( cond
               ( (and ( >= ind_ins 0 )
                      ( <  ind_ins (vlength tabl_ins))
                      )
                ( :MAJ_LIGNE_1 %sch_cour bas )
                (cond 
                      ( bas (for ( i 1 1 %MAXLGN1 ) 
                                 (:DECALER i (1- i))) 
                           (:CALC_LIGNE2 %MAXLGN1)
                           )
                      (  t  (for ( i  (1- %MAXLGN1) -1 0 ) 
                                 (:DECALER i (1+ i))) 
                         (:CALC_LIGNE2 0)
                         )    )                   
                (:AFFICHE %ligne)
                (for (i 0 1 %MAXLGN1) 
                     (if (neq i %ligne) 
                         (:AFFICHE i) nil))
                )
               ( t (tybeep) )
               )
         ( :CURSEUR t )
         )
    )

;;; Traitement de la commande de substitution de deux attributs
;;; du schema courant dans le tableau 2 .
(de :SUBST_ATT2 ()
    (let ( (sch (:SCH_LGN %ligne))
          (col (:INDICE_COLONNE_1 (:SCH_LGN %ligne)))
          (key nil)
          )
         ; Ecriture du nom du premier atrribut selectione.
         ;(tyattrib t)
         (tyco 0 %YMAX '#" Echange des attributs: ")
           ;(tyattrib nil)
           (tyco 30 %YMAX (pname (car (:ATTCOUR %colonne %ligne))))
           (setq col1 ( + col %colonne))
           ; Lecture du "E" suivant.
           (while (and (neq key 101) (neq key 69))
                  (setq key (:GET_KEY))
                  (cond
                  ( ( eq KEY %RIGHT )
                     ( cond
                          ( ( eq %colonne %MAXCOL ) ( :SCROLL_HOR t ) )
                          ( ( null (:ATTCOUR (1+ %colonne) %ligne) ) 
                            (tybeep) )
                          ( t   ( :CURSEUR  nil)
                                (setq %colonne ( 1+ %colonne )) 
                                ( :CURSEUR  t)  
                          )
                  )  )  
                  ( ( eq KEY %LEFT )
                     ( cond
                          ( ( eq %colonne '0 ) ( :SCROLL_HOR nil ) )
                          ( ( null (:ATTCOUR (1- %colonne) %ligne) ) (tybeep) )
                          ( t   ( :CURSEUR nil)
                                (setq %colonne ( 1- %colonne )) 
                                ( :CURSEUR t)  
                          )
                  )  )  
                  ( (or (eq key 101) (eq key 69)) nil )
                  ( t (tybeep) )
           )      )
           ; Ecriture du nom du second attribut selectionne
           (tyco 45 %YMAX (pname (car (:ATTCOUR %colonne %ligne))))
           (setq col (:INDICE_COLONNE_1 (:SCH_LGN %ligne)))
           (setq col2 (+ col %colonne))
           ; Validation
           (tyco 60 %YMAX '#"D'accord? (O/N)")
           (setq key (:GET_KEY))
           (cond
               ( (or (eq key 111) (eq key 79)) 
                 (:ECH_ATT sch col1 col2)
                 (for (lgn 0 1 %MAXLGN2)
                      (cond
                         ( (eq sch (:SCH_LGN lgn))
                           (:ECHANGE
                                (cadr (getprop '%ECRAN_2 lgn))
                                col1
                                col2)
                           (:affiche lgn) )
                         ( t nil ))))
                ( t nil )
           )
           ; effacement
           (tycursor 0 %YMAX)
           (tydelln)
           (:CURSEUR t)
     )
  )


;;; Description : Traitement de la commande de substitution de deux instances
;;;               du schema courant dans le tableau 2 .
(de :SUBST_INS ()
    (let ( (key nil) )
         ; Ecriture du nom de la premiere instance selectionee.
         ;(tyattrib t)
         (tyco 0 %YMAX '#" Permutation des instances: ")
           ;(tyattrib nil)
           (tyco 30 %YMAX (pname (car (getprop '%ECRAN_2 %ligne))))
           (setq lgn1 (+ (:INDICE_LIGNE_1 %sch_cour) %ligne))
           ; Lecture du "P" suivant.
            (while (and (neq key 112) (neq key 80))
                  (setq key (:GET_KEY))
                  (cond
                    ( ( eq KEY %DOWN )
                     ( cond
                          ( ( eq %ligne '%MAXLGN2 ) 
                            ( :SCROLL_VERT t ) )
                          ( t  ( while (and 
                                         (null 
                                            (:ATTCOUR (- %colonne i)
                                                      (1+ %ligne)))
                                         (>= %colonne i))
                                       (setq i (1+ i))
                                )
                                (cond ( (< %colonne i) (tybeep) )
                                      ( t  (:CURSEUR nil)
                                           (setq %colonne 
                                                 (- %colonne i))
                                           (setq %ligne 
                                                 ( 1+ %ligne )) 
                                           (:CURSEUR t)  
                          )     )     )
                    ))  
                    ( ( eq KEY %UP )
                     ( cond   ( ( eq %ligne '0 ) ( :SCROLL_VERT nil ) )
                              ( t  ( while (and 
                                             (null 
                                              (:ATTCOUR (- %colonne i)
                                                        (1- %ligne)))
                                             (>= %colonne i))
                                           (setq i (1+ i)))
                                   (cond ( (< %colonne i) (tybeep) )
                                         ( t  (:CURSEUR nil)
                                              (setq %colonne 
                                                    (- %colonne i))
                                              (setq %ligne 
                                                   ( 1- %ligne )) 
                                              (:CURSEUR t)  
                             )     )     )
      
                   ))
                   ( (or (eq key 112) (eq key 80)) nil )
                   ( t (tybeep) )
           )       )
; Ecriture du nom de la seconde instance selectionnee.
           (tyco 45 %YMAX (pname (car (getprop '%ECRAN_2 %ligne))))
           (setq lgn2 (+ (:INDICE_LIGNE_1 %sch_cour) %ligne))
; Validation
           (tyco 60 %YMAX '#"D'accord? (O/N)")
           (setq key (:GET_KEY))
           (cond
               ( (or (eq key 111) (eq key 79)) 
                 (:ECH_INS %sch_cour lgn1 lgn2)
                 (let ((save (getprop '%ECRAN_2 lgn1))
                       (ind_lgn (:INDICE_LIGNE_1 %sch_cour)))
                      (putprop '%ECRAN_2
                               (getprop '%ECRAN_2 lgn2)
                               lgn1)
                      (putprop '%ECRAN_2
                               save
                               lgn2)

                      (:AFFICHE (- lgn1 ind_lgn))
                      (:AFFICHE (- lgn2 ind_lgn))))
                ( t nil ))
           ; effacement
           (tycursor 0 23)
           (tydelln)
           (:CURSEUR t)))


;;; Opere le scrolling sur un emplacement ou l'attribut
;;; a une facette "liste de". 
;;; Le parametre "liste_inferee " est a nil lorsque la fonction 
;;; est appelee par GEST_CUR_2 apres que l'utilisateur ait tape " L ".
;;; Il est egal a la liste des valeurs de l'attribut sur lequel on 
;;; fait le scrolling, lorsque cette liste est obtenue par inference 
;;; (appel via la fonction GEST_COMMANDES,
;;; partie traitant une inference.)
(de :SCROLL_CASE ( liste_inferee )
    ( let ((l_valeur (if liste_inferee 
                         liste_inferee 
                         (:VAL_ATTCOUR)))
           (key nil)
           (i 0))
         ;(tyattrib t)
         (tyco 0 %YMAX '#" Liste de valeurs       ")
            ;(tyattrib nil)
            (cligno_texte t)
            (tyco ( + ( * %colonne 13 ) 25 ) 
                  ( + ( * %ligne 5 ) 6 ) 
                  '#/*)
            (cligno_texte nil)
            (while (and (neq key 108) (neq key 76))
                   (setq key (:GET_KEY))
                   (cond
                        ( (eq key %RIGHT) 
                          (if ( < i  (1- (length l_valeur))) 
                              (setq i (1+ i))  (tybeep)) )
                        ( (eq key %LEFT) 
                          (if ( > i 0 ) 
                              (setq i (1- i)) 
                              (tybeep)) )                                            
                        ( (or (eq key 108) 
                              (eq key 76)) 
                          nil )
                        ( t  (tybeep) )
                   )
                   (tyco ( + ( * %colonne 13 ) 16 )
                         ( + ( * %ligne 5 ) 5 )
                         (:format ( nth i l_valeur ) 10 )
                   )
            )
            (tyco ( + ( * %colonne 13 ) 25 ) 
                  ( + ( * %ligne 5 ) 6 ) '#/*)
; si la liste l_valeur est le resultat d'une inference, 
; on ne conserve pas sa valeur 
            (if liste_inferee nil 
; sinon on conserve dans %ECRAN_2 la valeur apparaissant sur la cellule au moment ou l'utilisateur
; arrete le scrolling sur l'attribut
                (vset (cadr (getprop '%ECRAN_2 %ligne))
                      (+ (:INDICE_COLONNE_1 (:SCH_LGN %ligne))
                         %colonne )
                      (nth i l_valeur)))
            (tyco 0 %YMAX)
            (tydelln)
  )    )


;;; Positionnement du curseur a la colonne %colonne et
;;;  a la ligne %ligne.
(de :CURSEUR (mode)
    ( tyattrib mode)
    ( tyco  ( + ( * %colonne 13 ) 16 )
          ( + ( * %ligne 5 ) 3 )
          (:format (car ( :ATTCOUR %colonne %ligne ) ) 10)  )
    ( tyattrib nil)
    )

;;; Deplace le curseur en reponse aux fleches de direction
;;; et declenche les scrollings.
(de :DEPL_CUR_2 ()
    ( let ( ( i 0 ) )
         ;KEY = la derniere touche enfoncee.
         ( while ( neq KEY 45 )
                ( setq i 0 )
                ( cond
                      ; 
                      ; deplacement du curseur a droite
                      ;
                      ( ( eq KEY %RIGHT )
                       ( cond
                             ( ( eq %colonne %MAXCOL ) ( :SCROLL_HOR t ) )
                             ( ( null (:ATTCOUR (1+ %colonne) %ligne) )
                              (tybeep) )
                             ( t   ( :CURSEUR  nil)
                                (setq %colonne ( 1+ %colonne )) 
                                ( :CURSEUR  t)  
                                )
                             )  )
                      ;
                      ; deplacement du curseur a gauche
                      ;
                      ( ( eq KEY %LEFT )
                       ( cond
                             ( ( eq %colonne '0 ) ( :SCROLL_HOR nil ) )
                             ( ( null (:ATTCOUR (1- %colonne) %ligne) )
                              (tybeep) )
                             ( t   ( :CURSEUR nil)
                                (setq %colonne ( 1- %colonne )) 
                                ( :CURSEUR t)  
                                )
                             )  )
                      ;
                      ; deplacement du curseur en bas
                      ;
                      ( ( eq KEY %DOWN )
                       ( cond
                             ( ( eq %ligne %MAXLGN1 ) 
                              ( :SCROLL_VERT t ) )
                             ( t  ( while (and 
                                               (null 
                                                     (:ATTCOUR (- %colonne i)
                                                             (1+ %ligne)))
                                               (>= %colonne i))
                                         (setq i (1+ i))
                                         )
                                (cond ( (< %colonne i) (tybeep) )
                                      ( t  (:CURSEUR nil)
                                         (setq %colonne 
                                               (- %colonne i))
                                         (setq %ligne 
                                               ( 1+ %ligne )) 
                                         (:CURSEUR t)  
                                         )     )     )
                             )  )
                      ;
                      ; deplacement du curseur en haut
                      ;
                      ( ( eq KEY %UP )
                       ( cond   ( ( eq %ligne '0 ) 
                                 ( :SCROLL_VERT nil ) )
                             ( t  ( while (and 
                                               (null 
                                                     (:ATTCOUR 
                                                             (- %colonne i)
                                                             (1- %ligne)))
                                               (>= %colonne i))
                                         (setq i (1+ i))
                                         )
                                (cond ( (< %colonne i) (tybeep) )
                                      ( t  (:CURSEUR nil)
                                         (setq %colonne 
                                               (- %colonne i))
                                         (setq %ligne 
                                               ( 1- %ligne )) 
                                         (:CURSEUR t)  
                                         )     )     )
                             
                             )   )
                      ;
                      ; defilement sur une cellule du type $liste_de : LISTE VALEURS
                      ;
                      ( (or (eq KEY 108) (eq KEY 76))
                       ( cond
                             ( (eq (cadr (:ATTCOUR %colonne %ligne)) 
                                   '$liste-de)
                              (:SCROLL_CASE nil) )
                             ( t (tybeep) )
                             )  )
                      ;
                      ; developpement d'un attribut : DESCENDRE
                      ; 
                      ( (or (eq KEY 100) (eq KEY 68))
                       ; la ligne courante est-elle vide ? 
                       (if (null (:LIGNE_COURANTE))
                           (tybeep)
                           ( let ( (typatt (car (last 
                                                      (:ATTCOUR %colonne %ligne)))) )
                                ( cond
                                      ; le type de l'attribut est simple
                                      ( (or (#:shirka:noyau:type-simple? typatt)
                                            ;  ou la valeur de l'attribut n'est pas connue.
                                            (null (vref (cadr (getprop 
                                                                      '%ECRAN_2 %ligne))
                                                        (+ (:INDICE_COLONNE_1 
                                                                   (:SCH_LGN %ligne))
                                                           %colonne))))
                                       (tybeep))
                                      ( t ( if (cassq typatt DES_ATT) 
                                              nil 
                                              (:CREAT_LATT typatt))
                                         (:DESCENDRE) )))))
                      ;
                      ; retour a l'instance source : REMONTER
                      ;
                      ( (or (eq KEY 114) (eq KEY 82))
                       ; la ligne courante est-elle vide ? 
                       (if (null (:LIGNE_COURANTE))
                           (tybeep)
                           ; Est-on bien a un niveau d'imbrication superieur a 1 ?
                           ( cond
                                 ( (null (cdr (vref (cassq %sch_cour DES_INS)
                                                    (+ (:INDICE_LIGNE_1 
                                                               %sch_cour)
                                                       %ligne)
                                                    )     )    )
                                  (tybeep)
                                  )
                                 ( t (:REMONTER) )
                                 ) ))
                      ;
                      ; substitution de deux attributs : ECHANGE ATTRIBUT
                      ;
                      ( (or (eq KEY 101) (eq KEY 69))
                       ; la ligne courante est-elle vide ? 
                       (if (null (:LIGNE_COURANTE))
                           (tybeep)
                           (:SUBST_ATT2))
                       )
                      ;
                      ; substitution de deux instances : PERMUTER INSTANCES
                      ;
                      ( (or (eq KEY 112) (eq KEY 80))
                       ; la ligne courante est-elle vide ? 
                       (if (null (:LIGNE_COURANTE))
                           (tybeep)
                           (:SUBST_INS))
                       )
                      ;
                      ; HELP
                      ;
                      ( (eq KEY 63)
                       (:help)
                       (tyi)
                       (:TAB_2 %sch_cour)
                       (for (i 0 1 %MAXLGN2) (:affiche i))
                       (:curseur t)
                       )
                      ; 
                      ; commandes d'interrogation de Shirka
                      ;
                      ( ( member KEY '( 65 97 83 115 77 109 
                                          73 105 67 99 84 116  ))
                       (:GEST_COMMANDES KEY)
                       (:curseur t)
                       )
                      (       t       ( tybeep ))
                      )
                ( setq KEY (:GET_KEY))
                ) )
    ))))))
