(defvar #:sys-package:colon '#:shirka:tabl)

;;; Realise l'imbrication d'une valeur d'attribut complexe 
;;; (c_a_d un schema) et l'affiche a l'ecran. 
(de :DESCENDRE ()
    (:EMPILE_IMB %sch_cour
            (+ (:INDICE_LIGNE_1 %sch_cour) %ligne)
            (vref (cadr (getprop '%ECRAN_2 %ligne))
                  (+ (:INDICE_COLONNE_1 
                             (:SCH_LGN %ligne)) 
                     %colonne))
            ) 
    (:CALC_LIGNE2 %ligne)
    (:affiche %ligne)
    (setq %colonne 0)
    (:CURSEUR t))

;;; Realise l'operation inverse de descendre  
(de :REMONTER ()
    (:DEPILE_IMB %sch_cour 
            (+ (:INDICE_LIGNE_1 %sch_cour) %ligne)
            )
    (:CALC_LIGNE2 %ligne) 
    (:affiche %ligne)
    (setq %colonne 0)
    (:CURSEUR t))

;;; Lit au terminal une information "type" , au point de
;;; coordonnees (icol , ilig) avec au maximum "nbr" caracteres.
(de :T_LECTURE (type icol ilig nbr)
    (let ((l nil) (c nil) (n 0) (partie_dec nil))
         (tycursor icol ilig)
         ;
         ; ---- lecture jusqu'a <CR> ----
         ;
         (while (neq (setq c (tyi)) #\CR)
                (cond
                      ;
                      ; ---- caractere <ESP_ARR> ----
                      ;
                      ((eq c 8)
                       (if (eq n 0)
                           (tybeep)
                           (setq n (1- n))
                           (if (and (eq type 'reel)
                                    (eq (car l) 46))
                               (setq partie_dec nil)
                               nil)
                           (setq l (cdr l))
                           (tyco (+ icol n) ilig 32)
                           (tycursor (+ icol n) ilig))
                       )
                      ;
                      ; ---- buffer plein ----
                      ;
                      ((eq n nbr) (tybeep))
                      ;
                      ; ---- caractere admissible . verifications selon le type ----
                      ;
                      (t
                         (if (not (selectq type
                                          (entier (or (= c 43) (= c 45)
                                                      (and (>= c 48) (<= c 57))))
                                          (reel (or (and (>= c 48) (<=  c 57))
                                                    (= c 43) (= c 45)
                                                    (and (eq c 46)(not partie_dec))))
                                          (t  t)))
                             ;
                             ; ---- erreur : caractere non convenable pour le type donne ----
                             ;
                             (tybeep)
                             ;
                             ; ---- caractere admis ----
                             ;
                             (setq n (1+ n))
                             (newl l c)
                             (tyo c)
                             (if (and (eq type 'reel) (eq c 46))
                                 (setq partie_dec t)
                                 nil))
                         ))
                ;
                ; ---- fin du "while" ----
                ;
                )
         ;
         ; ---- retour : convertions selon le type desire ----
         ;
         (selectq type
                 (entier (:conv_ent l))
                 (reel (:conv_reel l))
                 (chaine (string (nreverse l)))
                 (t (symbol () (nreverse l))))))

;;; Convertit la liste des codes ascii "l" en un entier.
(de :CONV_ENT (l)
    (cond  ((null l) 0)
          ((= (car (last l)) 43) (:conv_ent (delete 43 l)))
          ((= (car (last l)) 45) (- 0 (:conv_ent (delete 45 l))))
          ((+ (- (car l) 48)
              (* 10 (:conv_ent (cdr l)))))))

;;; Convertit la liste des codes ascii "l" en un reel.  
(de :CONV_REEL (l)
    (cond  ((null l) 0.0)
          ((= (car (last l)) 43) (:conv_reel (delete 43 l)))
          ((= (car (last l)) 45) (- 0.0 (:conv_reel (delete 45 l))))
          (t
             (let ((nbr_dec 0) (i 0) (continue t)(long (length l)) )
                  (while (and (<= i long) continue)
                         (if (neq (nth i l) 46)
                             (setq i (1+ i))
                             (setq continue nil)))
                  (if (eq (setq nbr_dec (if continue 0 i)) 0)
                      (:conv_ent (if (eq (car l) 46) (cdr l) l))
                      (+ (:conv_ent (lastn (1- (- long nbr_dec)) l))
                         (* (power 10 (- 0 nbr_dec))
                            (:conv_ent (firstn nbr_dec l)))))))))

;;; Traite les commandes du tableur a proprement dites.
;;; C'est a dire :
;;;
;;;      - Ajout d'une valeur
;;;      - Suppression d'une valeur
;;;      - Modification d'une valeur
;;;      - Interrogation (inference) d'une valeur
(de :GEST_COMMANDES (cle)
    ;
    ; Definitions des variables locales communes a toutes les commandes
    ;
    (lets  ( (sch_fictif (:SCH_LGN %ligne))
            (sch (if sch_fictif sch_fictif %sch_cour))
            (ligne (getprop '%ECRAN_2 %ligne))
            (tabl (cadr ligne))
            (instance (car ligne))
            (ind (+ (:INDICE_COLONNE_1 sch) %colonne))
            (info (vref (cassq sch DES_ATT) ind))
            (x (+ 16 (* 13 %colonne)))
            (y (+ 5  (* 5  %ligne)))
            (entree nil)
            (long 0) (lig 0) (OK t) )
          (cond
                
                ;    AJOUT         
                
                ((or (eq cle 65)(eq cle 97))
                 (if (null (:LIGNE_COURANTE))
                     (tybeep)
                     (cond
                           ((eq (cadr info) '$un)
                            ; type '$un 
                            
                            (if (vref tabl ind)
                                (tybeep)
                                ;(tyattrib t)
                                (tyco 0 %YMAX '#" Ajout de valeur ")
                   ;(tyattrib nil)
                   (tyco x y '#"     ")
                   (setq entree (:T_LECTURE (caddr info) x y 10))
                   (cond ((null (#:shirka:moteur:aj-valeur 
                                   (#:shirka:noyau:schema instance)
                                        (car info)
                                        entree t))
                               (tybeep)
                               (tyco x y '#"    -     "))
                         ( t
                               (vset (cadr (:LIGNE_COURANTE)) 
                                     ind entree)
                               (tyco x y (pname (string entree))))
                   )
                   (tyco 0 %YMAX)(tydelln)
               ))
           ( t

     ; type '$liste-de 

               ;(tyattrib t)
               (tyco 0 %YMAX '#" Ajout de valeur")
               (cond 
;il y a deja au moins une valeur dans la liste
                    ( (:VAL_ATTCOUR)
                      (tyco x %YMAX 
                             '#" en Debut ou Fin de liste? (D/F) ")
                      ;(tyattrib nil)
                      (setq KEY (:GET_KEY))
                      (while (and (neq KEY 68)
                                  (neq KEY 70)
                                  (neq KEY 100)
                                  (neq KEY 102))
                      (setq KEY (:GET_KEY)))
                      (tycursor 16 %YMAX)(tydelln)
                      (tyco x y '#"          ") 
                    )
;la liste est vide
                    (  t
                       (setq KEY 70)
                       ;(tyattrib nil)  
                     )
               )
               (setq entree (:T_LECTURE (caddr info) x y 10))
               (if (null (#:shirka:moteur:aj-valeur 
                              (#:shirka:noyau:schema instance)
                                    (car info)
                                    entree
                                    (eq KEY 70)))
                   (tybeep)
                   (vset (cadr (:LIGNE_COURANTE)) ind entree)
               )
               (tyco x y (:format (pname (vref (cadr(:LIGNE_COURANTE))
                                             ind )) 10))
               (tyco 0 %YMAX)(tydelln)
           )
         )
       )
     )

;    SUPPRESSION   

     ((or (eq cle 83)(eq cle 115))
       (if (null (:LIGNE_COURANTE))
           (tybeep)
         (setq entree (vref tabl ind))
         (if (null entree)
             (tybeep)
             ;(tyattrib t)
             (tyco 0 %YMAX '#" Suppression de valeur ")
             ;(tyattrib nil)
             (if (null (#:shirka:moteur:sup-valeur 
                                   (#:shirka:noyau:schema instance)
                                   (car info)
                                   entree))
                 (tybeep)
     ;
     ;  maj %ECRAN_2
     ;
                 (setq entree (if (eq (cadr info) '$un)
                                  (vset (cadr (:LIGNE_COURANTE)) 
                                        ind nil)
                                  (vset (cadr (:LIGNE_COURANTE))
                                        ind
                                        (car (#:shirka:noyau:val-inst 
                                         (#:shirka:noyau:schema instance)
                                        (#:shirka:noyau:pos-nom-att 
                                       (#:shirka:noyau:schema sch)
                                                      (car info))))
                                  )
                              ))
                 (tyco x y (:format (pname (string entree)) 11))
             )
             (tyco 0 %YMAX)(tydelln)
         )
       )
     )

;    MODIFICATION  

     ((or (eq cle 77)(eq cle 109))
       (if (null (:LIGNE_COURANTE))
           (tybeep)
         (if (null (vref tabl ind))
             (tybeep)
             ;(tyattrib t)
             (tyco 0 %YMAX '#" Modification de valeur ")
             ;(tyattrib nil)
             (tyco x y '#"           ")
             (setq entree (:T_LECTURE (caddr info) x y 10))
             (if (null (#:shirka:moteur:mod-valeur
                            (#:shirka:noyau:schema instance) 
                                   (car info)
                                   (vref tabl ind)
                                   entree))
                 (tybeep)
                 (vset (cadr (:LIGNE_COURANTE))
                       ind
                       entree)
             )
             (tyco x y (:format (pname (vref (cadr (:LIGNE_COURANTE)) ind))
                               11))
             (tyco 0 %YMAX)(tydelln)
         )
      )
     )

;    INFERENCE     

     ((or (eq cle 73)(eq cle 105))
       (if (null (:LIGNE_COURANTE))
           (tybeep)
                   ;(tyattrib t)
                   (tyco 0 %YMAX '#" Inference de valeur ")
                   ;(tyattrib nil)
                   (if (setq entree (#:shirka:moteur:valeur? 
                                         (car info) instance))
                       (if (atom entree) 
                           (tyco x y 
                               (:format (pname (string entree)) 11))
                           (tyco x y 
                               (:format (pname (string 
                                                  (car entree))) 11))
                           (:SCROLL_CASE entree)
                       )
                       (tyco x y '#"   echec  "))
                   (tyi)
                   (setq entree (vref (cadr (:LIGNE_COURANTE)) ind))
                   (if (null entree)
                       (tyco x y '#"    -      ")
                       (tyco x y (:format (pname entree) 11))
                   )
                   (tyco 0 %YMAX)(tydelln)
         )
     )

;    CREATION      

     ((or (eq cle 67)(eq cle 99))
         ;(tyattrib t)
         (tyco 0 %YMAX '#" Creation d'instance ")
         ;(tyattrib nil)
         (tyco 35 %YMAX '#"Donnez son nom:  ")
         (setq entree (:T_LECTURE 'symbole 53 23 10))
         (if (null entree)
             nil
             (#:shirka:comp:ext-int 
                     (list entree 
                           (list 'est-un 
                                  (list '= %sch_cour))))
     ;
     ; ---- maj DES_INS
     ;
             (setq tabl (cassq %sch_cour DES_INS))
             (setq long (vlength tabl))
             (setq DES_INS (acons %sch_cour
                                  (MAKEVECTOR (1+ long) nil)
                                  DES_INS))
             (setq ind (+ (:INDICE_LIGNE_1 %sch_cour) %ligne))
             (if (eq long 0)
                 (vset (cassq %sch_cour DES_INS) 0 (cons entree nil))
                 (BLTVECTOR (cassq %sch_cour DES_INS) 0
                        tabl 0 (1+ ind))
                 (vset (cassq %sch_cour DES_INS) (1+ ind) (cons entree nil))
                 (if (>= (1+ ind) long)
                     nil
                     (BLTVECTOR (cassq %sch_cour DES_INS) (+ 2 ind)
                            tabl (1+ ind) (1- (- long ind)))
                 )
             )
     ;
     ; ---- maj %ECRAN_2 et ecran
     ;
             (cond ((eq %ligne 3)
                    (for (i 1 1 3)
                         (:DECALER i (1- i)))
                    (:MAJ_LIGNE_1 %sch_cour t)
                    (:CALC_LIGNE2 3)
                    (for (i 0 1 3) (:AFFICHE i))
                   )
                   (t 
                    (setq i 2)
                    (setq lig (if (null (getprop '%ECRAN_2 %ligne))
                                   -1
                                   %ligne))
                    (while (> i lig)
                           (:DECALER i (1+ i))
                           (setq i (1- i))
                    )
                    (:CALC_LIGNE2 (1+ lig))
                    (setq lig    (1+ lig))
                    (setq OK t)
                    (while OK
                           (:AFFICHE lig)
                           (setq lig    (1+ lig))
                           (setq OK    (and (<= lig 3)
                                            (getprop '%ECRAN_2 lig)))
                    ))
             )
         )
         (tyco 0 %YMAX)(tydelln)
     )

;     TUER         

     ((or (eq cle 84)(eq cle 116))
       (if (null (:LIGNE_COURANTE))
           (tybeep)
         ;(tyattrib t)
         (tyco 0 %YMAX '#" Suppression de l'instance: ")
         ;(tyattrib nil)
         (tyco 30 %YMAX (pname (car (getprop '%ECRAN_2 %ligne))))
         (tyco 45 %YMAX '#"D'accord? (O/N)")
         (setq KEY (:GET_KEY))
         (while (and (neq KEY 79)(neq KEY 78)
                     (neq KEY 111)(neq KEY 110))
                (tybeep)
                (setq KEY (:GET_KEY))
         )
         (if (or (eq KEY 78) (eq KEY 110)) 
             nil
             (#:shirka:moteur:sup-inst
                  (#:shirka:noyau:schema 
                      (car (getprop '%ECRAN_2 %ligne)))
                   nil)
     ;
     ; ---- maj DES_INS ----
     ;
             (setq tabl (cassq %sch_cour DES_INS))
             (setq long (vlength tabl))
             (setq DES_INS (acons %sch_cour
                                  (MAKEVECTOR (1- long) nil)
                                  DES_INS))
             (if (eq long 1)
                 nil
                 (setq ind (+ (:INDICE_LIGNE_1 %sch_cour) %ligne))
                 (if (eq ind 0)
                     (BLTVECTOR (cassq %sch_cour DES_INS) 0
                                tabl 1 (1- long))
                     (BLTVECTOR (cassq %sch_cour DES_INS) 0
                                tabl 0 ind)
                     (if (eq (1+ ind) long)
                         nil
                         (BLTVECTOR (cassq %sch_cour DES_INS) ind
                                    tabl (1+ ind) (1- (- long ind)))
                     )
                 )
             )
     ;
     ; ---- maj %ECRAN_2 ----
     ;
             (if (eq %ligne %MAXLGN2)
                 nil
         ;
         ; --- decallage si besoin
         ;
                 (for (i %ligne 1 (1- %MAXLGN2))
                      (:DECALER (1+ i) i))
             )
             (if (null (getprop '%ECRAN_2 0))
                 nil
         ;
         ; --- CALCULER la dernire ligne  si besoin ----
         ;
                 (if (>= (+ (:INDICE_LIGNE_1 %sch_cour) %MAXLGN2)
                         (1- long))
         ;
         ; --- On ne peut pas lire la dernire ligne  dans DES_INS ----
         ;
                     (if (eq (:INDICE_LIGNE_1 %sch_cour) 0)
         ;
         ; --- Scrolling vers le haut possible ? ---
         ;
                         (putprop '%ECRAN_2 nil %MAXLGN2)
                         (:MAJ_LIGNE_1 %sch_cour nil)
                         (for (i 0 1 %MAXLGN2)
                              (:CALC_LIGNE2 i)
                              (:AFFICHE i))
                     )
         ;
         ; --- On peut lire la ligne 3 ---
         ;
                     (:CALC_LIGNE2 %MAXLGN2)
                 )
        )
         ;
         ; --- Affichage des lignes modifiees ---
         ;
                 (setq lig %ligne)
                 (setq OK t)
                 (while OK
                        (:AFFICHE lig)
                        (setq OK (and (<= lig (1- %MAXLGN2))(getprop '%ECRAN_2 lig)))
                        (setq lig (1+ lig))
                 )
        (cond ( (and (neq %ligne 0) (null (getprop '%ECRAN_2 %ligne)))
            (setq %ligne (1- %ligne))
            (setq %colonne 0))
        (t nil))
        (tyco 0 %YMAX)(tydelln)
     )
        (tyco 0 %YMAX)(tydelln)
    ))
 )))
;

(de :HELP ()
    (let ((i 2))
         
         ;    HELP          
         
         (tycls)
         ;(tyattrib t)
         (tyco 20 0 '#" -  L I S T E   des  C O M M A N D E S  - ")
;
; impression des cles 
;
         (tyco 1 (setq i (1+ i)) '#" E ")
         (tyco 1 (setq i (1+ i)) '#" L ")
         (tyco 1 (setq i (1+ i)) '#"   ")
         (tyco 1 (setq i (1+ i)) '#" D ")
         (tyco 1 (setq i (1+ i)) '#" R ")
         (tyco 1 (setq i (1+ i)) '#" P ")
         (tyco 1 (setq i (1+ i)) '#"   ")
         (tyco 1 (setq i (1+ i)) '#" A ")
         (tyco 1 (setq i (1+ i)) '#" S ")
         (tyco 1 (setq i (1+ i)) '#" M ")
         (tyco 1 (setq i (1+ i)) '#" I ")
         (tyco 1 (setq i (1+ i)) '#"   ")
         (tyco 1 (setq i (1+ i)) '#" C ")
         (tyco 1 (setq i (1+ i)) '#" T ")
         (tyco 1 (setq i (1+ i)) '#"   ")
         (tyco 1 (setq i (1+ i)) '#" - ")
         (tyco 1 (setq i (1+ i)) '#" ? ")
         ;(tyattrib nil)
;
; ---- impression des messages ----
;
   (tyco 4 3  '#"  ECHANGE ATTRIBUTS :  Echange deux attributs.")
   (tyco 4 4  '#"  LISTE VALEURS     :  Liste les valeurs d'un attribut multi-value.")
   (tyco 4 6  '#"  DESCEND           :  Descend dans le developpement d'un attribut.")
   (tyco 4 7  '#"  REMONTE           :  Remonte au niveau de developpement precedent.")
   (tyco 4 8  '#"  PERMUTE INSTANCES :  Permute deux instances.")
   (tyco 4 10 '#"  AJOUTE VALEUR     :  Ajoute une valeur d'attribut.")
   (tyco 4 11 '#"  SUPRIME VALEUR    :  Supprime la valeur affichee.")
   (tyco 4 12 '#"  MODIFIE VALEUR    :  Modifie la valeur affichee.")
   (tyco 4 13 '#"  INFERE VALEUR     :  Infere la valeur d'un attribut.")
   (tyco 4 15 '#"  CREE INSTANCE     :  Cree une instance.")
   (tyco 4 16 '#"  TUE INSTANCE      :  Tue l'instance courante.")
   (tyco 4 18 '#"  SORTIE            :  Retour  Shirka.")
   (tyco 4 19 '#"  AIDE              :  Aide en ligne.")
   )  )
