(defvar #:sys-package:colon '#:shirka:tabl)

;;; Echange les elements numero l et m d'une liste "liste"
(de :ECHANGE ( tabl l m )
    (let  ( (save  (vref tabl l)) )
         (vset tabl l (vref tabl m))
         (vset tabl m save)))

;;; Cree une liste a partir des elements de "l" avec un
;;; niveau de parenthesage supplementaire
(de :NIVEAU_2 ( l )
    (cond ((null l) nil)
          (t  (cons (cons (car l) nil)
                    (:NIVEAU_2 (cdr l))))))

;;; Formate la chaine str a nbr caracteres.
(de :FORMAT (str nbr)
    (let ((long (plength str)))
         (if (> long nbr)
             (pname (substring str 0 nbr))
             (pname (catenate str (makestring (- nbr long) 32 ))))))

;;; Initialise les variables chaines de caracteres utilisees
;;; pour l'affichage des tableaux.
(de :INIT_VAR_STR ()
    (setq line_1 (pname (catenate "+-------------+"
                                (duplstring (1+ %MAXCOL) 
                                        "------------+"))))
    (setq line_2 (pname (catenate "|             |"
                                (duplstring (1+ %MAXCOL) 
                                        "            |"))))
    (setq line_3 (pname (catenate "+=============+"
                                (duplstring (1+ %MAXCOL) 
                                        "============+"))))
    (setq line_4 (pname (catenate "              +"
                                (duplstring (1+ %MAXCOL) 
                                        "------------+"))))
    (setq line_5 (pname (catenate "              |"
                                (duplstring (1+ %MAXCOL) 
                                        "            |")))))

;;; Acquiert un caractere au clavier et le convertit s'il
;;; s'agit du code des fleches.
(de :GET_KEY ()
    (let  ((key nil))
         ( setq key (tyi))
         ( cond ((eq key 1) (setq key (tyi))
                 (tyi)
                 key )
               ( t  key))))


;;; Initialise la variable DES_ATT
(de :INIT_DES_ATT ()
    (setq DES_ATT nil))

;;; Ajoute le tableau descripteur des attributs dans
;;; la A-liste DES_ATT avec le cle "sch".
(de :CREAT_LATT (sch)
    (setq DES_ATT
          (acons sch (:TABL_ATT_TYP sch)
                 DES_ATT)))

;;; Initialise la A-liste description de la visualisation
;;; ecran de chaque schema.
(de :INIT_DES_VIS ()
    (setq DES_VIS nil))

;;; Initialise la variable DES_INS
(de :INIT_DES_INS () 
    (setq DES_INS nil))

;;; Cree le tableau descripteur du developpement des
;;; instances du schema "sch".
(de :CREAT_LINS (sch)
    (setq DES_INS
          (acons sch
                 (apply 'VECTOR
                        (:niveau_2 
                                (#:shirka:noyau:L-INST 
                                        (#:shirka:noyau:schema sch))) )
                 DES_INS)))

;;; Delivre le tableau decrivant les attributs de "sch".
;;; Pour chaque attribut, on donne ( nom-att , fac , type ).
(de :TABL_ATT_TYP (sch)
    (apply 'vector
           (cdddr 
                  (:COUPLES_ATT_TYP 
                          (#:shirka:noyau:schema sch) 
                          (#:shirka:noyau:l-nom-att-inst-he 
                                  (#:shirka:noyau:schema sch))))))

;;; Donne la liste des triplets decrits precedemment.
(de :COUPLES_ATT_TYP (schema l_att)
    (cond ((null l_att) nil)
          (t (cons (cons (car l_att)
                         (#:shirka:noyau:nature schema (car l_att)))
                   (:COUPLES_ATT_TYP schema (cdr l_att))))))

;;; Delivre le tableau des attributs du schema courant.
(de :TABL_COUR ()
    (cadr (getprop '%ECRAN_1 %ligne)))

;;; Echange les attributs n et p du schema "sch".
;;; (inversion de 2 colonnes)
(de :ECH_ATT (sch n p)
    (:ECHANGE (cassq sch DES_ATT) n p))

;;; Echange les instances n et p du schema "sch".
;;; (inversion de 2 lignes)
(de :ECH_INS (sch n p)
    (:ECHANGE (cassq sch DES_INS) n p))

;;; Mise a jour de l'indice de l'instance presente en ligne 1
;;; du schema "sch". inst_suiv indique si le scrolling est HAUT ou BAS.
(de :MAJ_LIGNE_1 (sch inst_suiv)
    (let  ( (indice (:INDICE_LIGNE_1 sch)) (new_ind 0))
         (setq new_ind  (cond (inst_suiv (1+ indice))
                              (t         (1- indice))))
         (if (cassq sch DES_VIS)
             (rplaca (cassq sch DES_VIS) new_ind)
             (setq DES_VIS (acons sch
                                  (cons new_ind (cons 0 nil))
                                  DES_VIS)))))

;;; Mise a jour de l'indice de l'attribut present en colonne 1
;;; du schema "sch". att_suiv indique si le
;;; scrolling est DROITE ou GAUCHE.
(de :MAJ_COLONNE_1 (sch att_suiv)
    (let  ( (indice (:INDICE_COLONNE_1 sch)) (new_ind 0))
         (setq new_ind  (cond (att_suiv (1+ indice))
                              (t        (1- indice))))
         (if (cassq sch DES_VIS)
             (rplaca (cdr (cassq sch DES_VIS)) new_ind)
             (setq DES_VIS (acons sch
                                  (cons 0 (cons new_ind nil))
                                  DES_VIS)))))

;;; Ajoute l'instance "inst" dans l'imbrication visualisant
;;; l'instance numero num_inst du schema "sch".
(de :EMPILE_IMB (sch num_inst inst)
    (let ( (tabl_inst (cassq sch DES_INS)) )
         ( vset tabl_inst num_inst
               (cons inst (vref tabl_inst num_inst)))))

;;; Supprime la derniere instance dans l'imbrication qui
;;; visualise l'instance numero num_inst du schema "sch".
(de :DEPILE_IMB (sch num_inst)
    (let ( (tabl_inst (cassq sch DES_INS)) )
         ( vset tabl_inst num_inst
               (cdr (vref tabl_inst num_inst)))))

;;; Retourne l'indice de l'instance en ligne 1 du schema "sch".
(de :INDICE_LIGNE_1 (sch)
    (if (cassq sch DES_VIS)
        (car (cassq sch DES_VIS))
        0))

;;; Retourne l'indice de l'attribut en colonne 1 du schema "sch".
(de :INDICE_COLONNE_1 (sch)
    (if (cassq sch DES_VIS)
        (cadr (cassq sch DES_VIS))
        0))

;;; Retourne le nom de l'instance derniere visualisee pour
;;; l'instance numero num_inst du schema "sch".
(de :VISUAL_INST (sch num_inst)
    (car (vref  (cassq sch DES_INS) num_inst) ))

;;; Ecrase la ligne j avec la ligne i dans %ECRAN_2 .
(de :DECALER ( i j )
    (putprop '%ECRAN_2 (getprop '%ECRAN_2 i) j))

(de :SCHS_FILS (sch)
    (#:shirka:noyau:l-spec (#:shirka:noyau:schema sch)))

(de :SCHS_PERES (sch)
    (#:shirka:noyau:peres (#:shirka:noyau:schema sch)))


;;; Rend le type de l'instance ( = un nom de schema )
;;; representee en ligne "ligne" de %ECRAN_2 .
(de :SCH_LGN (ligne)
    (let ((lignecour (getprop '%ECRAN_2 ligne)))
         (if lignecour
             (#:shirka:noyau:val-inst 
                     (#:shirka:noyau:schema (car lignecour)) %est-un)
             nil)))

;;; Rend la valeur de l'attribut en position "col" et "lgn"
;;; dans %ECRAN_2.
(de :VAL_ATTCOUR ()
    ( let ( (sch (:SCH_LGN %ligne)) )
         ( #:shirka:noyau:val-inst
                 (#:shirka:noyau:schema 
                         (car (getprop '%ECRAN_2 %ligne)))
                 (#:shirka:noyau:pos-nom-att 
                         (#:shirka:noyau:schema sch)
                         (car (vref (cassq sch DES_ATT)
                                    (+ (:INDICE_COLONNE_1 sch)
                                       %colonne)))))))

;;; Rend la valeur et le type de l'attribut en colonne "col" 
;;; et en ligne "lgn" du tableau a l'ecran ( nil si la case 
;;; en question est vide ) sous la forme :
;;;      ( "valeur" $un "type" )
;;; ou   ( "valeur" $liste_de "type" )
(de :ATTCOUR (col lgn)
    ( let ( ( sch (:SCH_LGN lgn) ) )
         ( cond 
               ( sch (let ( (tabl_att (cassq sch DES_ATT))
                           (ind_att (+ (:INDICE_COLONNE_1 sch) 
                                       col))
                           )
                          ( cond
                                ( (and ( >= ind_att 0 )
                                       ( <  ind_att 
                                          (vlength tabl_att))
                                       )
                                 (vref tabl_att ind_att)
                                 )
                                ( t nil)
                                )
                          )
                    )
               ( t nil )
               )
         )
    )

(de :LIGNE_COURANTE ()
    (getprop '%ECRAN_2 %ligne))
