;;; Actions Lexicales et Syntaxiques Shirka V3
(defvar #:sys-package:colon '#:shirka:verif)
;;;
;;;-- actions lexicales
;;;   -----------------
(de :actions-lex (action)
    ;
    (selectq action
            ;
            ; --- ACTIONS STANDARD (effacer actions inutiles si besoin)
            ;
            ; --- action vide:
            (NIL     () )
            ;
            ; --- erreur lexicale: cara invalide pour typcar declare
            (err-lex 
                    (incr :ptcurc)
                    (:msg-err '(ERREUR "caractere invalide"))
                    )
            ; --- empiler le curcar dans la ligne en cours de tabulation
            (getcurc
                    (:tabuler)
                    )
            ;
            ; --- memoriser debut d'une US
            (debut
                   (setq :debUS :ptcurc)
                   (:tabuler)
                   )
            ; --- repositionner lecture sur <debut>-1 pour "new-curcar"
            (go-deb
                    (setq :ptcurc (decr :debUS))
                    (decr :curtab))
            ;
            ; --- AUTRES ACTIONS LEXICALES
            ;
            ;-- debut deb-tab
            ; memorise debut de <idf>|<chaine>|<val> en cours de tabulation
            ; le marqueur "old-curtab" est utilise dans "tabuler"
            (deb-tab
                    (setq :old-curtab (+ 1 :curtab))
                    (:tabuler)
                    )
            ;
            ;
            ; rencontre de <<eofl>> pendant l'analyse de <chaine>
            ; il faut inserer un blanc a la place avant de tabuler
            (get-speol
                    (setq :curcar 32)
                    (setq :old-curtab :curtab)
                    (:tabuler)
                    )
            ;
            ;-- debut facette
            ; si <att> pas trop long: formater sur meme ligne sinon <new-line> d'abord
            (facette
                    (if (> :curtab (+ :marge :col-fa7))
                        (:source-tabul))
                    (setq :curtab (+ :marge :col-fa7))
                    (:tabuler)
                    )
            ;
            (perluet-att
                    (:tabuler)
                    )
            ;
            (empil-sch
                    (:source-tabul)
                    (incr :marge :marge-acco)
                    (:tabuler)
                    (incr :curtab 2)
                    )
            ;
            (depil-sch
                    (:source-tabul)
                    (setq :curtab (1- (decr :marge :marge-acco)))
                    (:tabuler)
                    (:source-tabul)
                    )
            ;
            (signe-egal
                    (if (> :curtab (+ :marge :col-fa7))
                        (:source-tabul))
                    (setq :curtab (+ :marge :col-fa7))
                    (:tabuler) (incr :curtab)
                    )
            ;
            (leftpar
                    (if :chaine-lisp
                        ()
                        (incr :nbparlisp))
                    ; marquer le debut d'une zone de definition lisp:
                    (when (= :nbparlisp 1)
                          (:listing 'wng "( [ debut lisp...]")
                          (setq :curtab -1)
                          (:source-tabul))
                    (:tabuler)
                    )
            ;
            (rightpar
                    (:tabuler)
                    (if :chaine-lisp
                        ()
                        (decr :nbparlisp)
                        ; ATTENTION: quand () = 0, relancer l'automate en 1
                        (when (= :nbparlisp 0)
                              (setq :retour-en-1 t)
                              (:source-tabul)
                              ; marquer la fin de la zone lisp:
                              (:listing 'wng "[...fin lisp ] )")) )
                    )
            ;
            (rpar-en-trop
                    ; parentheses droites en exces: warning liste
                    (:msg-err '(WARNING " ')' superflues!"))
                    )
            ;
            (ch-lisp
                    (setq :chaine-lisp (not :chaine-lisp))
                    (:tabuler)
                    )
            ;
            ;-- debut newl-lisp
            (newl-lisp
                    (:source-tabul)
                    ; ecrire ligne lisp courante (on n'empile pas le <eofl>)
                    )
            ;
            (f-idf
                   (incr :curtab)
                   )
            ;
            (v-chaine
                    ; un espace entre les chaines (domaine)
                    (incr :curtab)
                    )
            ;
            (v-entier
                    (incr :curtab)
                    )
            ;
            (v-reel
                    (incr :curtab)
                    )
            ;
            (fleche
                    (:tabuler)
                    (setq :curtab (max (+ :marge :col-args) (+ :curtab 2)))
                    )
            ;
            (f-facette
                    ; *** attention aux $var<- ***
                    (if (eq :type-cc 'inf)
                        ; ne rien faire sur "<": l'action "fleche" s'en charge
                        ()
                        (setq :curtab (max (+ :marge :col-args) (+ :curtab 2))))
                    )
            ;
            (f-perl-att
                    (setq :curtab (max (+ :marge :col-fa7) (+ :curtab 2)))
                    )
            ;
            ; --- AUTRE: erreur systeme ou action inconnue
            (t       (error 'action-lexicale action 'inconnue)))
    )
;;;-- fin actions-lex.

;;;-- actions semantiques <<verifier shirka>>
;;;   -------------------
(de :actions-sem (action)
    ;
    ;-- interprete une <action> semantique
    ;
    (selectq action
            ;
            ; --- action vide:
            (NIL ())
            ;
            ; --- ACTIONS SEMANTIQUES
            ;
            (empile
                    (incr :nbacco) (setq :err-ptv t) )
            ;
            (exit 
                  (ifn (= :nbacco 0)
                       ; *** erreur ***
                       (:msg-err '(FATALE "*** Terminaison sur desequilibre des {} ***")))
                  (if (= :nbschemas 0)
                      ; *** erreur ***
                      (:msg-err '(FATALE "*** Aucun schema compile *** (symbole invalide)")))
                  (:msg-err '(ERREUR "*** Arret sur symbole invalide hors schema Shirka ***"))
                  (:listing 'final :nbschemas)
                  )
            ;
            (exit-eof 
                    (ifn (= :nbacco 0)
                         ; *** erreur ***
                         (:msg-err '(FATALE "*** Terminaison sur desequilibre des {} ***")))
                    (if (= :nbschemas 0)
                        ; *** erreur ***
                        (:msg-err '(FATALE "*** Aucun schema compile *** (symbole invalide)")))
                    (:listing 'final :nbschemas)
                    )
            ;
            (nom-include
                    (:source-tabul)
                    (ifn (probefile :nom-US)
                         ; *** include shirka inconnu: arret fatal ***
                         (:msg-err '(ERREUR "<INCLUDE> sur base shirka inconnue"))
                         ; empiler le canal-courant et lire fichier "include"
                         ; ATTENTION: on suppose que l'acces est en ABSOLU
                         (:push :pile-include (inchan))
                         (inchan (openi :nom-US)))
                    )
            ;
            (effacer
                    ; erreur rencontree: effacer le <schema> courant
                    (setq :befface t) 
                    )
            ;
            (depile
                    (if (< (decr :nbacco) 0)
                        ; *** fatale ***
                        (:msg-err '(FATALE "Non parite des accolades schemas"))
                        )
                    ; reinit des compteurs
                    (if (= :nbacco 0)
                        (setq :nbattr 0 :nbfa7 0))
                    (if (and (= :nbacco 0) :befface)
                        ; sortir de la boucle "retour" et relancer l'analyse:
                        (setq :befface nil :reset-syntaxe t))
                    )
            ;
            (schema
                    (:source-tabul)
                    (setq :curtab (1- :marge))
                    (incr :nbschemas)
                    )
            ;
            (classe
                    (setq :curtab (max (+ :marge :col-fa7) (+ :curtab 2)))
                    )
            ;
            (est_inst
                    (setq :curtab (max (+ :marge :col-fa7) (+ :curtab 2)))
                    )
            ;
            (special
                    (:source-tabul)
                    (incr :nbschemas)
                    ) 
            ;
            ;-- a-la-ligne sur ";"
            (a-la-ligne
                    ; vider <ligne-courante>
                    (:source-tabul)
                    )
            ;
            (Ept-virg
                    (if :err-ptv
                        ; *** erreur ***
                        (:msg-err '(WARNING "schema <sorte-de>: on attend <attributs>")))
                    (setq :err-ptv nil)
                    )
            ;
            (Efa7
                  (if (= 0 :nbfa7)
                      (:msg-err '(WARNING "FIN_FA7 Attribut sans facette(s)")))
                  )
            ;
            (new-fa7
                    (incr :nbfa7)
                    )
            ;
            (attribs
                    (incr :nbattr)
                    (setq :nbinterv 0)
                    )
            ;
            (ss-attribs
                    (incr :nbattr)
                    (setq :nbinterv 0)
                    )
            ;
            (wng-sch
                    (if (= :nbattr 0)
                        ; *** schema sans attributs ***
                        (:msg-err '(WARNING "schema sans attributs")))
                    )
            ;
            (wng-att2
                    ; *** attribut sans decorations ***
                    (:msg-err '(WARNING "attribut sans facette(s)"))
                    )
            ;
            (new-comnt
                    (:source-tabul)
                    (setq :curtab (+ :marge :col-args))
                    )
            ;
            (Ebornes
                    (if (= :nbinterv 0)
                        ; *** erreur ***
                        (:msg-err '(ERREUR "BORNES: au moins 1 intervalle")))
                    )
            ;
            (moinsinf
                    (incr :nbinterv)
                    )
            ;
            (val_int
                    (incr :nbinterv)
                    )
            ;
            (ch_int
                    (incr :nbinterv)
                    )
            ;
            (id_int
                    (incr :nbinterv)
                    )
            ;
            ; --- AUTRE: erreur interne ou action inconnue
            (t    (error 'actions-sem action 'inconnue)))
    )
;;;-- fin actions-sem.
