;;; ANAlyse et FORmatage de bases Shirka V3

;;;(setq #:system:read-case-flag t)
(defvar #:sys-package:colon '#:shirka:verif)
;;;
;;;-- variables globales (lexico+syntaxe)
;;;   -----------------------------------
(de :init-globales ()
    ;
    ; Definition piles
    ; ----------------
    (defvar :pile-lex (makevector 20 0))    ; pile lexicale
    (defvar :pile-synt (makevector 30 0))   ; pile syntaxique
    (vset :pile-lex 0 19)                   ; pile [ 0 ] : nombre d'elements max
    (vset :pile-lex 19 1)                   ; pile [max] : <tete-de-pile>
    (vset :pile-synt 0 29)
    (vset :pile-synt 29 1)
    (defvar :val-pillex 0)                  ; evaluation de pile-lex
    ;
    ; Environ lexical
    ; ---------------
    (defvar :curcar '- )           ; caractere courant
    (defvar :oldcurcar '- )        ; copie de curcar
    (defvar :ptcurc 81 )           ; pointeur sur curcar
    (defvar :buff-in () )          ; tampon lecture source
    (defvar :lgbuff-in 0 )         ; nombre de caras lus en entree source
    (defvar :type-cc '- )          ; type du curcar via "typcar"
    (defvar :base 10 )             ; base de calcul <valeur>
    (defvar :etat 1 )              ; etat (numerique) de l'automate
    (defvar :exit-autre () )       ; sortie sur "AUTRE"
    (defvar :reconnue () )         ; unite US reconnue
    (defvar :buf-US () )           ; suite des caras de US courante
    (defvar :deb-US 0 )            ; pointeur secondaire debut US
    (defvar :fin-US 0 )            ; pointeur secondaire fin US
    (defvar :US '- )               ; unite syntaxique
    (defvar :nom-US '- )           ; nom symbolique US
    (defvar :symb-ascii-US '- )    ; symbole ASCII quand US = 1 cara
    (defvar :spec-US '- )          ; valeur de specialisation (classe spe)
    (defvar :valeur-US '- )        ; valeur interne associee (classe val)
    ;
    ; Environ ligne tabulee
    ; ---------------------
    (defvar :pile-include (makevector 8 0)) ; pile des fichiers "include"
    (vset :pile-include 0 7)       ; pile [ 0 ] : nombre d'elements max
    (vset :pile-include 7 1)       ; pile [max] : <tete-de-pile>
    (defvar :b-include () )        ; flag de presence fichiers "include"
    (defvar :trace-src () )        ; flag de trace source
    (defvar :marge 0 )             ; init. marge gauche dynamique
    (defvar :curtab -1)            ; pointeur curcar dans ligne tabulee
    (defvar :old-curtab 0)         ; memorise debut US dans ligne tabulee
    (defvar :canal-t 0) (defvar :canal-l 0) ; les canaux ftabul et fliste
    (defvar :ftabul (catenate #:shirka:*verif* "shirka_tab")) ; shirka tabule
    (defvar :fliste (catenate #:shirka:*verif* "liste"))      ; liste temoin
    ;
    ; Environ syntaxique
    ; ------------------
    (defvar :etiq '- )             ; etat (symbolique) de l'automate
    (defvar :cas-autre () )        ; sortie sur "AUTRE"
    (defvar :cas-erreur () )       ; sortie sur erreur
    (defvar :maxerrfat 20 )        ; nombre maximal d'erreurs
    (defvar :nb-errors 0 )         ; nombre cumule d'erreurs
    (defvar :e-of-l 127)           ; code de <fin-logique-ligne>
    (defvar :fatal () )            ; flag sur erreur fatale
    (defvar :flag-stop () )        ; arret sur instruction "STOP"
    (defvar :befface () )          ; flag de la boucle "retour"
    (defvar :reset-syntaxe () )    ; redemarrer sur le premier etat
    ;
    ; Environ special pour lisp (demasquer si besoin)
    ; -------------------------
    (defvar :nbparlisp 0)          ; compteur de parentheses
    (defvar :chaine-lisp () )      ; "chaine" dans une zone le-lisp
    (defvar :retour-en-1 () )      ; flag de reinitialisation lexicale
    ;
    ; Gestion liste
    ; -------------
    (defvar :liste-errs () )       ; liste des erreurs rencontrees
    (defvar :err-inline 0 )        ; nombre d'erreurs dans ligne
    (defvar :nlignes-src 0 )       ; numero ligne source lue
    (defvar :page-liste 0 )        ; compteur page de liste
    (defvar :marqueurs (makevector 50 1) ) ; marqueurs d'erreurs
    ;
    ; Actions semantiques
    ; -------------------
    (defvar :nbschemas 0 )      ; compteur schemas shirka
    (defvar :nbacco 0 )         ; balance des {}
    (defvar :nbinterv 0 )       ; compter les intervalles de $intervalle
    (defvar :nbattr 0 )         ; compteur attributs pour 1 schema
    (defvar :nbfa7 0)           ; compteur facettes pour 1 attribut
    (defvar :err-ptv t )        ; rattrapage erreur sur ";" ou acco fermante
    )

;;;-- gestion standard de la liste
;;;   ----------------------------
(de :listing (type imprimer)
    (let ( (fill-err 8)
          )
         ;
         (with ((outchan :canal-l))
               (selectq type
                       ;
                       ; --- marqueur(s) erreur
                       (marque
                               (princh '| | fill-err) (print imprimer))
                       ;
                       ; --- attention (warning)
                       (wng
                            (print "*** ATTENTION : " imprimer))
                       ;
                       ; --- erreur simple
                       (err 
                            (print "*** ERREUR    : " imprimer))
                       ;
                       ; --- erreur fatale
                       (fatal
                              (print "*** FATAL     : " imprimer))
                       ;
                       ; --- ligne source
                       (source
                               (princh '| | (- 5 (length (explode :nlignes-src))))
                               (print :nlignes-src " : " imprimer)
                               )
                       ;
                       ; --- impressions speciales
                       (trace 
                              (princh '| | 6) (print ": " imprimer)
                              )
                       ;
                       ; --- messages finals sur <eof> ou action =exit=
                       (final
                              (when (> :nb-errors 0)
                                    (:lister-marques)
                                    (:lister-erreurs :liste-errs)
                                    (setq :liste-errs () :err-inline 0)
                                    (setq :ligne-marq (makestring :ptmax-tab 32)))
                              (print)
                              (print "Nombre de schemas et sous-schemas analyses: " imprimer)
                              (print)
                              )
                       ;
                       ; --- AUTRE erreur systeme
                       (t (error ':listing type 'inconnu)))))
    )

;;;-- transferer <curcar> dans ligne en cours de tabulation
;;;   -----------------------------------------------------
(de :tabuler ()
    (let ( (index -1) )
         ; --- ligne tabulee pleine: vider dans <ftabul>
         (when (>= :curtab :ptmax-tab)
               (let ((troncat (makestring 50 32))
                     (lg (+ 1 (- :ptmax-tab :old-curtab)))
                     (xtron :old-curtab)
                     )
                    ; nettoyer ligne-courante tabulee pour eviter les troncatures
                    ; transferer la derniere sous-chaine dans la nouvelle ligne
                    (setq troncat (substring :ligne-tab xtron))
                    (repeat lg
                            (sset :ligne-tab xtron #$20 )
                            (incr xtron))
                    (:source-tabul)
                    (setq :curtab (+ :marge :col-args))
                    ; replacer sous-chaine en debut ligne courante:
                    (repeat (slength troncat)
                            (sset :ligne-tab (incr :curtab) (sref troncat (incr index))))))
         ; --- placer le <curcar>
         (sset :ligne-tab (incr :curtab) :curcar))
    )
;;;-- fin tabuler.

;;;-- ecrire une ligne source tabulee
;;;   -------------------------------
(de :source-tabul ()
    (let ((fin-ligne (+ :curtab 1)))
         ; envoyer les caras utiles [1..curtab]
         (with ((outchan :canal-t))
               (print (substring :ligne-tab 0 fin-ligne)))
         (setq :ligne-tab (makestring (+ 1 :ptmax-tab) 32) :curtab (1- :marge)))
    )

;;;-- empiler
;;;   -------
(de :push (pile valeur)
    (lets ((top-stack (vref pile 0))
           (ptr (vref pile top-stack)) )
          ;
          (if (equal top-stack ptr)
              (error 'push pile 'Pile-pleine))
          (vset pile ptr valeur)
          (vset pile top-stack (incr ptr)))
    )

;;;-- depiler
;;;   -------
(de :pop (pile)
    (lets ((top-stack (vref pile 0))
           (ptr (vref pile top-stack)) )
          ;
          (if (equal ptr 1)
              'Pile-vide
              (vset pile top-stack (decr ptr))
              (vref pile ptr)))
    )

;;;-- 'reset' pile
;;;    -----------
(de :reset (pile)
    (vset pile (vref pile 0) 1)
    )

;;;-- test pile-non-vide?
;;;   -------------------
(de :pile-non-vide? (pile)
    (lets ((top-stack (vref pile 0))
           (ptr (vref pile top-stack)) )
          ;
          (nequal ptr 1))
    )

;;;-- fonction principale (appel depuis Shirka: commande 'verifier')
(de :af-shirka (inst)
    ;
    ; Analyseur-Formateur de bases Shirka avec generation "dans la foulee"
    ; d'une copie formatee de la <base-source> contenant les schemas Shirka
    ; a charger + trace du source lu (deux formats: A4 portrait/ A4 paysage)
    ; Le traitement des macros "include" est effectue par ce formateur.
    ;
    ; N.B.: quand <base-source> existe la copie formatee est ecrite dans:
    ; ----  "#:shirka:*verif*:<base-source>"
    ;       la liste temoin d'analyse est "#:shirka:*verif*:liste"
    ;
    (lets ((base-source (string (#:shirka:noyau:val-inst inst 3)))
           (fsource (catenate #:shirka:*bases* base-source))
           (old-margin (rmargin))
           (t1 '(0 0 0)) (t2 '(0 0 0))
           )
          ;
          (protect 
                  (tag compile
                       (:init-globales)
                       (:select-format)
                       ; 
                       (if (probefile fsource) ()
                           ; *** source shirka inconnu: arret immediat
                           (tybeep) (tybeep)
                           (print " ??? " base-source " inconnu ???")
                           (print)
                           (exit compile))
                       ; *** source existe:
                       (defvar :titre-liste fsource)
                       ;
                       ; Prelude
                       ; -------
                       ; positionner marge droite format "a l'italienne"
                       (rmargin :nbcars-eff)
                       ; fichier recevant le source shirka tabule
                       (setq :ftabul (catenate #:shirka:*verif* base-source))
                       ;
                       (print)
                       (print " Lecture de: " fsource)
                       (print " ----------") (print)
                       ;
                       (inchan  (openi fsource))
                       (outchan (setq :canal-t (openo :ftabul)))
                       (outchan (setq :canal-l (openo :fliste)))
                       ;
                       ;--------------
                       (:analyse-synt )
                       ;--------------
                       ;
                       ; exit compile...
                       )
                  ; Postlude
                  ; --------
                  (close)
                  ; restaurer:
                  (rmargin old-margin)
                  (output ())
                  (print " -------")
                  (print " Erreurs: " :nb-errors " pour " :nlignes-src " lignes analysees.")
                  (print " -------")
                  (print " Base Shirka tabulee ==> " :ftabul)
                  (print)
                  ))
    )
