(defvar #:sys-package:colon '#:shirka:classif)

(defvar %pour-types nil)
(defvar %sauf-types nil)
(defvar %binf nil)
(defvar %bdial nil)

;;; specialisation d'une instance vers une classe fille directe
;;;     en entree
;;;       - instance : schema de l'instance a specialiser
;;;       - classe   : schema de la classe vers laquelle on specialise
;;;       - binf     : vrai pour inference, faux pour dialogue 
;;;    en sortie     : sur, possible, impossible
(de :instpp-de? (instance classe pour-types sauf-types bguide binf bdial)
    (let ((nom-inst (:nom-inst instance))
          (nom-sch (#:shirka:noyau:val-inst instance %est-un))
          (possibilite 'sur)         ; resultat dans possibilite
          (lui-meme)                 ; a traiter s'il existe
          (l-nouv-att))              ; attributs non values a voir plus
         (tag echec                  ; tard si besoin
              (mapc 
                    '(lambda (attrib)
                             ; l'attribut doit etre d'un des types a considerer
                             (slet ((nom-att (#:shirka:noyau:nom-att attrib))
                                    (type-att (#:shirka:noyau:classe-att-he classe nom-att)))
                                   (when (#:shirka:noyau:considerer-classe-att 
                                                 type-att pour-types sauf-types)
                                         (if (eq nom-att 'lui-meme)
                                             (setq lui-meme 'a-traiter)        
                                             (slet ((pos-att (#:shirka:noyau:pos-nom-att 
                                                                     (#:shirka:noyau:schema nom-sch)
                                                                     nom-att))
                                                    (nou-att (#:shirka:noyau:nouv-att? classe nom-att))
                                                    (att-a-trait (or nou-att ;nouvel attribut
                                                                     ; attribut herite: 
                                                                     ; test des restrictions locales
                                                                     (#:shirka:noyau:val-fac attrib '$domaine)
                                                                     (#:shirka:noyau:val-fac attrib '$valeur)
                                                                     (#:shirka:noyau:val-fac attrib '$sauf)
                                                                     (#:shirka:noyau:val-fac attrib '$intervalle)
                                                                     (#:shirka:noyau:val-fac attrib '$a-verifier)
                                                                     (#:shirka:noyau:val-fac attrib '$un)
                                                                     (#:shirka:noyau:val-fac attrib '$liste-de)
                                                                     (#:shirka:noyau:val-fac attrib '$cardmin)
                                                                     (#:shirka:noyau:val-fac attrib '$cardmax))))
                                                   
                                                   ; les attributs ne comportant pas les facettes precitees ne sont pas
                                                   ; contraints. Si pos-att, l'attribut existe pour l'instance     
                           
                                                   (cond ((and pos-att att-a-trait)
                                                          (slet ((instance (#:shirka:noyau:schema nom-inst))
                                                                 (valeur (#:shirka:noyau:val-inst instance pos-att))
                                                                 (resul (when valeur
                                                                              (slet  ((att (#:shirka:noyau:attrib classe nom-att))
                                                                                      (type (#:shirka:noyau:val-inst att %type))
                                                                                      (i (:pintervalle classe nom-att type))
                                                                                      (d (:pdomaine classe nom-att type))
                                                                                      (dom (:comb-i-d i d type)))
                                                                                    (:verif-val nom-inst nom-sch nom-att
                                                                                            valeur     
                                                                                            classe dom))))
                                                                 (testval (car resul))
                                                                 (val (cdr resul)))
                                                                (cond ((null resul)(setq l-nouv-att (nconc1 l-nouv-att nom-att)))
                                                                      ((eq testval 'impossible) (exit echec 'impossible))
                                                                      ((eq testval 'possible)
                                                                       (setq possibilite 'possible)))))
                                                         ((and (not pos-att) 
                                                               att-a-trait)
                                                          (setq l-nouv-att (nconc1 l-nouv-att nom-att)))))))))
                    (#:shirka:noyau:l-att classe))
              ; traitement des attributs non values
              (mapc '(lambda (nom-att)
                             (slet ((posit (#:shirka:noyau:pos-nom-att (#:shirka:noyau:schema nom-sch) nom-att))
                                    (pos-att(if posit posit (:allonge nom-inst nom-sch nom-att classe)))
                                    (instance (#:shirka:noyau:schema nom-inst))
                                    (resul (:obtien-val nom-inst nom-sch nom-att classe
                                                   binf bdial))
                                    (testval (car resul))
                                    (val (cdr resul)))
                                   (cond ((eq testval 'impossible)(exit echec 'impossible))
                                         ((eq testval 'possible)
                                          (setq possibilite 'possible)))))
                    l-nouv-att)
              (let ((instance (#:shirka:noyau:schema nom-inst)))
                   (if lui-meme
                       (let ((verif-lui (:verif-lui-meme classe instance)))
                            (cond ((eq verif-lui 'impossible)
                                   (progn (setq possibilite 'impossible)
                                          (:ecr-expl nom-inst (#:shirka:noyau:nom-sch classe)
                                                  'lui-meme nil 'impossible nil )))
                                  ((eq verif-lui 'possible)
                                   (progn 
                                          (setq possibilite 'possible)
                                          (:ecr-expl nom-inst (#:shirka:noyau:nom-sch classe)
                                                  'lui-meme nil 'possible nil )))
                                  ) ) )  )
              ; si verif-lui-meme est sur, rien n'est change
              possibilite)))

;;; allonge de 1 l'instance de nom nom-inst, rajoute l'attribut de nom
;;; nom-att venant de classe au schema de nom nom-sch
;;; en entree : - nom-inst : nom de l'instance bidon a allonger
;;;             - nom-sch  : nom de la classe bidon a completer
;;;             - nom-att  : nom de l'attribut a recuperer
;;;             - classe   : schema de la classe ou apparait l'attribut
;;; en sortie : position de l'attribut dans le schema de classe bidon
(de :allonge (nom-inst nom-sch nom-att classe)
    (slet ((u (vlength (#:shirka:noyau:schema nom-inst)))
           (v (makevector (add1 u) nil)))
          (bltvector v 0 (#:shirka:noyau:schema nom-inst) 0 u)
          (putprop nom-inst v 'schema))
    (slet ((attrib (copy (#:shirka:noyau:attrib-he classe nom-att)))
           (w (vref (#:shirka:noyau:schema nom-sch) %list-att))
           (l-att (#:shirka:noyau:l-nom-att-inst-he
                          (#:shirka:noyau:schema nom-sch))))
          (vset attrib %dom ())
          (vset attrib %int ())
          (vset attrib %list-fac ())
          (setq w (append w (list attrib)))
          (vset (#:shirka:noyau:schema nom-sch) %list-att w)
          (remprop nom-sch 'l-att)
          (#:shirka:noyau:pos-nom-att 
                  (#:shirka:noyau:schema nom-sch) nom-att)))

;;; creation de la classe bidon et de l'instance bidon
;;; en entree : -instance : schema de l'instance origine 
;;; en sortie : nom de l'instance bidon creee         
(de :crebid-cl-inst (instance)
    (slet ((schema  (:assoc-schema instance))
           (nom-inst (:nom-inst instance))
           (nom-sch (#:shirka:noyau:nom-sch schema))
           (peres (list nom-sch))
           (nom-cla-bid (gensym))
           (nom-inst-bid (gensym))
           (cla-bid (#:shirka:noyau:make-inst 'schema nom-cla-bid)))
          (#:shirka:moteur:creer-sorte-de cla-bid peres)
          (putprop nom-cla-bid t 'spec-loc)
          (let ((l (getprop 'liste-cl-bid 'classif)))
               (setq l (nconc1 l nom-cla-bid))
               (putprop 'liste-cl-bid l 'classif))
          (slet ((inst-bid 
                         (#:shirka:noyau:make-inst nom-cla-bid nom-inst-bid))
                 (lg (- (vlength inst-bid) %list-att)))
                ; lien de l'instance bidon vers l'instance reelle
                (vset inst-bid %util-par nom-inst)
                (bltvector inst-bid %list-att instance %list-att lg)
                (putprop nom-inst nom-inst-bid 'inst-bid)
                (putprop nom-inst-bid t 'a-repondre)
                (let ((l (getprop 'liste-inst 'classif)))
                     (setq l (nconc1 l nom-inst))
                     (putprop 'liste-inst l 'classif)))
          nom-inst-bid))

;;; rend le schema "reel" dont depend l'instance c-a-d le schema
;;; pere si specialisation locale
;;; en entree : - instance : schema de l'instance
;;; en sortie : - schema de classe dont depend l'instance
(de :assoc-schema (instance)
    (slet ((nom-sch (#:shirka:noyau:val-inst instance %est-un))
           (schema (#:shirka:noyau:schema nom-sch)))
          (if (getprop nom-sch 'spec-loc)
              (#:shirka:noyau:schema 
                      (car (#:shirka:noyau:peres schema)))
              schema)))

;;; demande de specialisation d'une instance vers une classe
;;; en entree : -instance : nom de l'instance a specialiser
;;;             -nom-sch-dest : nom de la classe vers laquelle
;;;                             on veut specialiser
;;;             -binf : si vrai avec inference
;;; en sortie : sur, possible, impossible
(de :spec-inst (instance nom-sch-dest pour-types sauf-types binf bdial)
    (tag erreur
         (slet ((nom-sch-orig (#:shirka:noyau:val-inst instance %est-un))
                (schema-orig (#:shirka:noyau:schema nom-sch-orig))
                (bguide)
                (nom-inst (:nom-inst instance))
                (nom-inst-bid (getprop nom-inst 'inst-bid)))
               (ifn (eq (:chef-fam nom-sch-orig)(:chef-fam nom-sch-dest))
                    (exit erreur (print "familles incoherentes")))
               (ifn nom-inst-bid
                    (setq nom-inst-bid (:crebid-cl-inst instance)))
               (:marquer-sur-anc schema-orig nom-inst-bid)
               (:specialiser-vers nom-inst-bid nom-sch-dest 
                       pour-types sauf-types
                       bguide binf bdial))
         ))

;;; specialisation recursive d'une instance bidon vers une classe
;;; et ses peres jusqu'a trouver sa propriete (sur possible impossible)
;;; en entree : - nom-inst : nom de l'instance bidon
;;;             - nom-sch-dest : nom de la classe destination
;;;             - binf : si vrai, inference
;;; en sortie  : sur, possible, impossible
(de :specialiser-vers (nom-inst nom-sch-dest 
                              pour-types sauf-types bguide binf bdial)
    (let ((prop (:prop-inst nom-inst nom-sch-dest)))
         (if prop
             prop
             (let ((peres (#:shirka:noyau:peres 
                                  (#:shirka:noyau:schema nom-sch-dest))))            
                  (let ((l (getprop 'liste-cl-vues 'classif)))
                       (setq l (append l (list nom-sch-dest))))
                  (while (and 
                              (nextl peres pere)
                              (not (member nom-inst 
                                           (getprop nom-sch-dest 'impossible)))
                              (not (:chef pere)))
                         (if (eq pere 'objet)
                             (:trait-imposs nom-inst nom-sch-dest)
                             (:specialiser-vers nom-inst pere 
                                     pour-types sauf-types bguide binf bdial)))
                  (if (member nom-inst 
                              (getprop nom-sch-dest 'impossible))
                      'impossible
                      (let ((valcase (:instpp-de? 
                                             (#:shirka:noyau:schema nom-inst)
                                             (#:shirka:noyau:schema nom-sch-dest)
                                             pour-types sauf-types
                                             bguide binf bdial)))                             
                           (cond ((eq valcase 'possible)
                                  (:trait-poss nom-inst nom-sch-dest))
                                 ((eq valcase 'impossible)
                                  (:trait-imposs nom-inst nom-sch-dest))
                                 (t (if (:sur-peres? nom-sch-dest nom-inst)
                                        (:trait-sur nom-inst nom-sch-dest)
                                        (:trait-poss nom-inst
                                                nom-sch-dest))))))
                  ))))

;;; marque le nom d'intance bidon nom-inst "sur" pour la classe de 
;;; nom nom-sch
(de :trait-sur (nom-inst nom-sch)
    (let ((marque (getprop nom-sch 'sur)))
         (if (member nom-inst marque)
             'sur
             (progn 
                    (setq marque (append marque (list nom-inst)))
                    (putprop nom-sch marque 'sur)
                    'sur))))

;;; marque le nom d'intance bidon nom-inst "possible" pour la classe de 
;;; nom nom-sch
(de :trait-poss (nom-inst nom-sch)
    (let ((marque (getprop nom-sch 'possible )))
         (if (member nom-inst marque)
             'possible
             (progn 
                    (setq marque (append marque (list nom-inst)))
                    (putprop nom-sch marque 'possible)
                    'possible))))

;;; marque le nom d'intance bidon nom-inst "impossible" pour la classe de 
;;; nom nom-sch. Marque egalement impossibles toutes les classes filles
(de :trait-imposs (nom-inst nom-sch)
    (let ((marque (getprop nom-sch 'impossible)))
         (if (member nom-inst marque)
             'impossible
             (progn 
                    (setq marque (append marque (list nom-inst)))
                    (putprop nom-sch marque 'impossible)
                    (mapc '(lambda (fille)
                                   (:trait-imposs nom-inst fille) )
                          (:filles (#:shirka:noyau:schema nom-sch)) )
                    'impossible))))

;;; nom de l'instance instance
(dmd :nom-inst (instance)
     `(vref ,instance %nom-inst))

;;; marque "sur" elle meme et tous les peres de la classe a laquelle
;;; appartient l'instance que l'on traite
;;; en entree : schema : schema de la classe origine
;;;             nom-inst : nom de l'intance bidon
(de :marquer-sur-anc (schema nom-inst)
    (slet ((nom-sch (#:shirka:noyau:nom-sch schema))
           (marque (getprop nom-sch 'sur)))
          (ifn (or (eq nom-sch 'objet) (member nom-inst marque))
               (progn 
                      (:trait-sur nom-inst nom-sch)
                      (mapc '(lambda(pere)
                                     (:marquer-sur-anc 
                                             (#:shirka:noyau:schema pere) nom-inst))
                            (#:shirka:noyau:peres schema))))))

;;; vrai si tous les peres sont "surs" pour l'instance de nom nom-inst
(de :sur-peres? (nom-sch nom-inst)
    (tag echec
         (mapc '(lambda (pere)
                        (ifn (member nom-inst (getprop pere 'sur))
                             (exit echec)))
               (#:shirka:noyau:peres (#:shirka:noyau:schema nom-sch)))
         t))

;;; rend la liste des specialisations "vraies" (ni spec-loc ni filtres)
(de :filles (schema)
    (mapcan '(lambda (spec)
                     (ifn (or (getprop spec 'spec-loc)
                              (getprop spec 'est-un-filtre))
                          (list spec)))
            (#:shirka:noyau:l-spec schema)))

;;; classification de l'instance instance dans la classe de nom 
;;; nom-sch-tete ainsi que ses filles
(de :class-inst (instance nom-sch-tete pour-types sauf-types bguide binf bdial)
    ; pour-types est la liste des types d'attribut qui doivent etre consideres
    ; sauf-types est la liste des types qui ne doivent pas etre consideres
    ; l'une des deux listes doit etre vide 
    ; si les deux listes sont vides, tous les attributs sont consideres, 
    ; quelque soit leur type
    (setq %pour-types pour-types
          %sauf-types sauf-types
          %binf binf
          %bdial bdial)
    (tag erreur
         (slet ((nom-sch-orig 
                        (#:shirka:noyau:nom-sch (:assoc-schema instance)))
                (chef-sch-inst (:chef-fam nom-sch-orig))
                (nom-sch-tete (if (null nom-sch-tete)
                                  chef-sch-inst
                                  nom-sch-tete))
                (schema-orig (#:shirka:noyau:schema nom-sch-orig))
                (nom-inst (:nom-inst instance))
                (nom-inst-bid (getprop nom-inst 'inst-bid))
                (nom-cl)
                (li-sur)(li-pos)(li-imp)(liatrait (list nom-sch-tete)))
               (when bdial
                     (print "Classification de l'instance "
                            (#:shirka:noyau:nom-sch instance)
                            " a partir de la classe "
                            nom-sch-tete))
               (if (or (null chef-sch-inst)
                       (neq (:chef-fam nom-sch-tete) chef-sch-inst))
                   (exit erreur (print "Familles incoherentes")))
               (ifn nom-inst-bid
                    (setq nom-inst-bid (:crebid-cl-inst instance)))
               (:marquer-sur-anc schema-orig nom-inst-bid)
               (while (nextl liatrait nom-cl)
                      (ifn (member nom-cl 
                                   (append li-sur li-pos li-imp))
                           (let ((trait (:specialiser-vers nom-inst-bid
                                                nom-cl pour-types sauf-types 
                                                bguide binf bdial))) 
                                (cond 
                                      ((eq trait 'sur)
                                       (setq li-sur (nconc1 li-sur nom-cl)))
                                      ((eq trait 'possible)
                                       (setq li-pos (nconc1 li-pos nom-cl)))
                                      (t (setq li-imp (nconc1 li-imp nom-cl))))
                                (unless (eq trait 'impossible)
                                        (mapc '(lambda (fille)
                                                       (ifn (member fille liatrait)
                                                            (setq liatrait 
                                                                  (nconc1 liatrait fille))))
                                              ( :filles (#:shirka:noyau:schema nom-cl)))))))
               ; renvoie les liste des classes sures, possibles et impossibles
               (list li-sur li-pos li-imp))))

(de :impression ((li-sur li-pos li-imp))
    ;impression des listes de classes sures, possibles et impossibles
    (if li-sur (progn 
                      (print " Les classes sures:")
                      (#:shirka:top:impr-res li-sur)))
    (if li-pos (progn 
                      (print " Les classes possibles:") 
                      (#:shirka:top:impr-res li-pos)))
    (if li-imp (progn 
                      (print " Les classes impossibles:") 
                      (#:shirka:top:impr-res li-imp))))

;;; rend le "chef de famille" de la classe nom-sch
(de :chef-fam (nom-sch)
    (if (member nom-sch '(schema objet attribut facette ))
        nil
        (if (:chef nom-sch)
            nom-sch
            (:chef-fam (car (#:shirka:noyau:peres 
                                    (#:shirka:noyau:schema nom-sch)))))))

;;; vrai si nom-sch est un "chef de famille"
(de :chef (nom-sch)
    (let ((pere (car (#:shirka:noyau:peres (#:shirka:noyau:schema nom-sch)))))
         (member pere '(schema objet attribut facette))))

;;; rend la propriete de l'instance bidon nom-inst pour la classe nom-sch
(de :prop-inst (nom-inst nom-sch)
    (cond ((member nom-inst (getprop nom-sch 'sur)) 'sur)
          ((member nom-inst (getprop nom-sch 'possible)) 'possible)
          ((member nom-inst (getprop nom-sch 'impossible)) 'impossible)))

;;; rend l'explication de l'instance reelle nom-inst pour la classe
;;; nom-sch
(de :expl-cl (nom-inst nom-sch)
    (let ((nom-inst-bid (getprop nom-inst 'inst-bid)))
         (ifn nom-inst-bid
              (print "L'instance "nom-inst " n'a pas ete classee")
              (let ((prop (:prop-inst nom-inst-bid nom-sch)))
                   (ifn prop
                        (print "L'instance " nom-inst 
                               " n'a pas ete testee par rapport a la classe "
                               nom-sch)
                        (if (eq prop 'sur)
                            (print "L'instance " nom-inst 
                                   " est totalement compatible avec la classe "
                                   nom-sch)
                            (progn 
                                   (:trait-expl nom-inst nom-inst-bid nom-sch)
                                   (#:shirka:noyau:demarquer 
                                           (#:shirka:noyau:schema nom-sch)))))))))

;;; traitement de l'explication sur la liste de classes passee en 
;;; parametres
(de :rech-expl (nom-inst nom-inst-bid lis-classes)
    (while (nextl lis-classes nom-pere)
           (unless (getprop nom-pere 'traite)
                   (putprop nom-pere t 'traite)
                   (:trait-expl nom-inst nom-inst-bid nom-pere))))

;;; recherche l'explication vers les peres et affiche au retour
;;; l'explication propre a la classe sur laquelle on se trouve
(de :trait-expl (nom-inst nom-inst-bid nom-sch)
    (ifn (eq (:prop-inst nom-inst-bid nom-sch) 'sur) 
         (let ((expl (getprop nom-inst-bid nom-sch)))
              (:rech-expl nom-inst nom-inst-bid
                      (#:shirka:noyau:peres (#:shirka:noyau:schema nom-sch)))
              (if expl
                  (:affexpl nom-inst nom-inst-bid nom-sch)))))

;;; affichage proprement dit de l'explication
(de :affexpl (nom-inst nom-inst-bid nom-sch)
    (slet ((explication (getprop nom-inst-bid nom-sch))
           (prop (car explication))
           (explic (cdr explication)))
          (print "L'instance " nom-inst
                 (selectq prop
                         (sur     " peut ")
                         (possible " pourrait ")
                         (impossible " ne peut pas "))
                 "appartenir a la classe " nom-sch)
          (while (nextl explic expl)
                 (if (neq (vref expl 2) 'vide)
                     (slet (((type-di . dom-inter)(vref expl 2))
                            (prop      (vref expl 0))
                            (nom-att   (car (vref expl 1)))
                            (val       (cadr (vref expl 1))))
                           (prin "La valeur de l'attribut " nom-att " est ")
                           (if (and (null type-di)(null dom-inter)(null val))
                               (print (if (eq prop 'possible)
                                          "inverifiable "
                                          "verifiee impossible "))
                               (progn 
                                      (ifn val
                                           (print "indefinie ") 
                                           (:ecr-dom val))
                                      (if (eq type-di 't)
                                          (let ((nom-classe (vref (#:shirka:noyau:schema val) %est-un))) 
                                               (print "qui appartient a la classe " nom-classe)))
                                      (if (eq type-di 'p)
                                          (progn (prin "et ne verifie pas le predicat ")
                                                 (:ecr-dom dom-inter))
                                          (prin  "alors que l'admissibilite est pour ") 
                                          (if (eq type-di 'i)
                                              (:ecr-int dom-inter)
                                              (if (eq type-di 'd)
                                                  (:ecr-dom dom-inter)
                                                  (print "la classe " (car dom-inter)))
                                              )))))
                     ; intersection vide des domaines et intervalles
                     (print "L'intersection des domaines et des intervalles ")
                     (print "de l'attribut " (car (vref expl 1))
                            " avec ceux de la classe d'origine "
                            (vref (#:shirka:noyau:schema nom-inst) %est-un)
                            " est vide")
                     ))))

(de :ecr-int (inter)
    (mapc '(lambda (int)
                   (prin "[" (car int) " " (cadr int) "] "))
          inter)(terpri))

(de :ecr-dom (dom)
    (when (vectorp dom)
          (setq dom (vref dom %nom-inst)))
    (if (consp dom)
        (mapc '(lambda (element)
                       (prin element " "))
              dom)
        (prin dom))
    (terpri))

;;; ecriture de l'explication
(de :ecr-expl (nom-inst nom-sch nom-att val prop dom)
    (slet ( (lisvec (getprop nom-inst nom-sch) )
           (vec (makevector 4 ()))
           (attrib (#:shirka:noyau:attrib 
                           (#:shirka:noyau:schema nom-sch) nom-att))
           (type (#:shirka:noyau:val-inst attrib %type)))
          (vset vec 0 prop)
          (vset vec 1 (list nom-att val))
          (vset vec 2 dom)
          (putprop nom-inst 
                  (nconc1 (cons prop (cdr lisvec)) vec ) nom-sch)))

;;; nettoyage des marques
(de :fin-cl (liste-instances)
    (slet ((l-inst-res (if liste-instances
                           liste-instances
                           (prog1 
                                  (getprop 'liste-inst 'classif)
                                  (remprop 'liste-inst 'classif))))
           (l-inst l-inst-res)
           (l-inst-bid))
          (while (nextl l-inst nom-inst)
                 (slet ((nom-inst-bid (getprop nom-inst 'inst-bid)))   
                       (when nom-inst-bid
                             (slet ((inst-bid (#:shirka:noyau:schema nom-inst-bid))
                                    (nom-cla-bid (#:shirka:noyau:val-inst 
                                                         inst-bid %est-un))
                                    (cla-bid (getprop nom-cla-bid 'schema)))
                                   (putprop 'liste-inst 
                                           (delete nom-inst 
                                                   (getprop 'liste-inst 'classif))
                                           'classif)
                                   (remprop nom-inst 'inst-bid)
                                   (remprop nom-inst-bid 'a-repondre)
                                   (remprop nom-inst-bid 'deja-repondu)
                                   (setq l-inst-bid (nconc1 l-inst-bid nom-inst-bid))
                                   (#:shirka:moteur:sup-inst inst-bid nil)
                                   (if cla-bid (#:shirka:comp:sup-filt-spec-loc cla-bid))
                                   (remprop nom-cla-bid 'spec-loc)))))
          (:sup-prop 'objet l-inst-bid)
          l-inst-res))

;;; suppression des proprietes accrochees a la classe nom-sch et ses
;;; descendants par rapport a la liste d'instances bidon l-inst-bid
(de :sup-prop (nom-sch l-inst-bid)
    (if l-inst-bid
        (mapc '(lambda (spec)
                       (let ((l l-inst-bid))
                            (mapc '(lambda (nom-inst)
                                           (putprop spec 
                                                   (remove nom-inst (getprop spec 'sur)) 'sur)
                                           (putprop spec 
                                                   (remove nom-inst (getprop spec 'possible)) 'possible)
                                           (putprop spec 
                                                   (remove nom-inst (getprop spec 'impossible))'impossible))
                                  l)
                            (while (nextl l nom-inst-bid)
                                   (remprop nom-inst-bid spec))))
              (#:shirka:noyau:l-spec-t-vraies 
                      (#:shirka:noyau:schema nom-sch)))))

;;; duplicata de sup-inst sans remob du symbole pour rattachement
;;; ulterieur a la classe destination
(de :sup-instance (instance)
    (let ((schema (#:shirka:noyau:schema (#:shirka:noyau:val-inst instance %est-un)))
          (nom-inst (#:shirka:noyau:nom-sch instance)))
         ; suppression du nom de l'instance dans le schema de classe
         (#:shirka:moteur:sup-valeur schema 'inst nom-inst)
         ; suppression dans les filtres (pre-filtrage constant)
         (#:shirka:moteur:filtrage:sup-inst-filt-anc nom-inst (#:shirka:noyau:nom-sch schema))))
;;; propagation de la suppression grace au lien "util-par"

;;; rattachement
(de :ratt-inst (instance nom-sch-dest)
    (slet ((prop (:spec-inst instance nom-sch-dest nil nil nil nil))
           (nom-inst (:nom-inst instance))
           (nom-inst-bid (getprop nom-inst 'inst-bid)))
          (if (not (memq prop '(sur possible)))
              (progn 
                     (print "Rattachement refuse.")
                     (:expl-cl nom-inst nom-sch-dest) () )
              (slet ((inst-bid (#:shirka:noyau:schema nom-inst-bid))
                     (nom-sch-bid 
                             (#:shirka:noyau:val-inst inst-bid %est-un))
                     (p (:sup-instance (#:shirka:noyau:schema nom-inst)))
                     (inst 
                           (#:shirka:noyau:make-inst nom-sch-dest nom-inst)))
                    (mapc '(lambda (nom-att)
                                   (let ((pos-att 
                                                 (#:shirka:noyau:pos-nom-att 
                                                         (#:shirka:noyau:schema nom-sch-bid)
                                                         nom-att)))
                                        (if (> pos-att %nom-inst)
                                            (#:shirka:moteur:aj-valeur 
                                                    inst nom-att
                                                    (#:shirka:noyau:val-inst 
                                                            inst-bid pos-att) t))))
                          (#:shirka:noyau:l-nom-att-he 
                                  (#:shirka:noyau:schema nom-sch-dest)))
                    (#:shirka:moteur:aj-valeur 
                            inst 'nom-inst nom-inst t)
                    (#:shirka:moteur:creer-est-un inst nom-sch-dest))
              nom-sch-dest)))

;;; creation d'une instance temporaire de nom nom-inst-temp 
;;; avec recopie des valeurs d'attributs
;;; et rattachement a la classe nom-sch-dest
(de :cr-inst-temp (instance nom-sch-dest nom-inst-temp)
    (slet ((prop (:spec-inst instance nom-sch-dest nil nil nil nil))
           (nom-inst (:nom-inst instance))
           (nom-inst-bid (getprop nom-inst 'inst-bid)))
          (if (not (memq prop '(sur possible)))
              (progn 
                     (print "Rattachement refuse.")
                     (:expl-cl nom-inst nom-sch-dest) () )
              (slet ((inst-bid (#:shirka:noyau:schema nom-inst-bid))
                     (nom-sch-bid (#:shirka:noyau:val-inst inst-bid %est-un))
                     (inst (#:shirka:noyau:make-inst 
                                   nom-sch-dest nom-inst-temp)))
                    ; recopie des valeurs d'attributs
                    (mapc '(lambda (nom-att)
                                   (let ((pos-att 
                                                 (#:shirka:noyau:pos-nom-att 
                                                         (#:shirka:noyau:schema nom-sch-bid)
                                                         nom-att)))
                                        (when (and pos-att
                                                   (> pos-att %nom-inst))
                                              (#:shirka:moteur:aj-valeur 
                                                      inst nom-att
                                                      (#:shirka:noyau:val-inst 
                                                              inst-bid pos-att) t))))
                          (#:shirka:noyau:l-nom-att-he 
                                  (#:shirka:noyau:schema nom-sch-dest)))
                    ; ajout des valeurs des attributs nom-inst et est-un
                    (#:shirka:moteur:aj-valeur inst 'nom-inst nom-inst-temp t)
                    (#:shirka:moteur:creer-est-un inst nom-sch-dest)
                    inst))))

;;; copie de dem-valeur avec traitement specifique du ??
;;; ramene dans ce cas l'union des intervalles et domaines apparaissant
;;; dans l'ensemble de la famille
(de :dem-val (schema classe nom-att instance bguide branger)
    (with ((prompt (catenate (makestring (lmargin) #/ ) nom-att "? ")))
          (slet (((nature type) (#:shirka:noyau:nature schema nom-att))
                 (nom-inst (#:shirka:noyau:nom-sch instance))
                 (bliste-de (eq nature '$liste-de)))
                (let ((brepeter t)
                      (dej-rep (member nom-att 
                                       (getprop nom-inst 'deja-repondu)))
                      (res)(rep))
                     (tag fin-val
                          (while brepeter
                                 (let ((erreur nil))     
                                      (setq rep (#:shirka:top:lecture))
                                      (selectq rep
                                              (? ; demande d'informations sur l'attribut
                                                 (let ((com 
                                                            (#:shirka:noyau:val-fac-he 
                                                                    classe nom-att '$com)))
                                                      ; rappel de l'instance en cours
                                                      (print "A propos de "
                                                             (vref instance %util-par))
                                                      ; impression du commentaire
                                                      (when com 
                                                            (mapc 'prin com)(prin ": "))
                                                      (prin (if bliste-de 
                                                                "liste de " "un "))
                                                      (#:shirka:top:aff-nom-classe type)
                                                      (terpri)
                                                      (setq erreur t)))  ;pour boucler sur lecture
                                              (?? ; demande d'informations sur le domaine
                                                  ; et la liste d'intervalles
                                                  (let (((int . dom) 
                                                         (:union-int-dom schema 
                                                                 (#:shirka:noyau:nom-sch instance) 
                                                                 nom-att bguide)))
                                                       (when dom
                                                             (prin "domaine: ")
                                                             (:ecr-dom dom))
                                                       (when int
                                                             (prin "intervalle: ")
                                                             (:ecr-int int))
                                                       (setq erreur t)))
                                              (- ; fin des valeurs de l'attribut 
                                                 (exit fin-val)) 
                                              (* ; exploration de l'ilot de meme nom 
                                                 ; que l'attribut
                                                 (setq res (:traiter-ilot nom-att bliste-de))
                                                 (ifn bliste-de
                                                      (setq rep res)
                                                      ; memorisation dans l'instance de la liste reponse
                                                      (mapc '(lambda (valeur)
                                                                     (#:shirka:moteur:aj-valeur instance nom-att valeur t))
                                                            res)
                                                      (exit fin-val)))
                                              (< ; fin de l'instanciation courante
                                                 (progn 
                                                        (remprop (#:shirka:noyau:nom-sch instance)
                                                                'a-repondre)
                                                        (exit fin-val)))
                                              (> ; poursuite de l'instanciation 
                                                 (ifn (#:shirka:noyau:type-simple? type) 
                                                      ;decalage de la marge gauche 
                                                      (with ((lmargin (+ (lmargin) 8)))
                                                            (slet ((sch-type
                                                                           (ifn (getprop type 'spec-loc)
                                                                                (#:shirka:noyau:schema type)
                                                                                (#:shirka:noyau:schema (car (#:shirka:noyau:peres 
                                                                                                                    (#:shirka:noyau:schema type))))))
                                                                   (instp (#:shirka:top:creer sch-type
                                                                                  ;utilise par 
                                                                                  (vref instance %nom-inst))))
                                                                  ; restaurer les positions
                                                                  (#:shirka:noyau:l-nom-att-inst-he schema)
                                                                  (setq rep instp)))  
                                                      (#:shirka:top:msg "impossible pour un type simple")
                                                      (terpri)
                                                      (setq erreur t)))
                                              (t ))
                                      (when (and rep (not erreur))
                                            (setq rep (if branger 
                                                          (#:shirka:moteur:aj-valeur instance nom-att rep t)
                                                          (#:shirka:moteur:admissible? rep nom-att schema instance)))
                                            (if   rep
                                                (setq res (if bliste-de 
                                                              (nconc1 res rep)
                                                              rep))
                                                (#:shirka:top:msg "valeur non admissible")
                                                (terpri)
                                                (setq erreur t)))
                                      (setq brepeter (or erreur bliste-de)))))
                     (ifn dej-rep
                          (let (
                                (l-dej-rep 
                                        (getprop nom-inst 'deja-repondu)))
                               (setq l-dej-rep 
                                     (nconc1 l-dej-rep nom-att))
                               (putprop nom-inst 
                                       l-dej-rep 'deja-repondu)))
                     res))))

;;; traitement des ilots de connaissance
(de :traiter-ilot (nom-ilot bliste)
    (let ((schema (getprop nom-ilot 'schema))
          (rep))
         (ifn schema
              (print "Ilot de connaissance inconnu")
              (let ((inst (#:shirka:noyau:make-inst nom-ilot () )))
                   (with ((lmargin (+ (lmargin) 8))
                          (prompt 
                                  (catenate (makestring (lmargin) #/ ) 
                                          "choix? "))) 
                         (print "Ilot " nom-ilot ":") 
                         (let ((liste-classes 
                                       ; classification de l'instance vide
                                       (:class-inst inst nom-ilot t () t)))
                              (:impression liste-classes)
                              ; l'instance ne sert qu'a la classification
                              (#:shirka:moteur:sup-inst inst nil)           
                              (until rep
                                     (if bliste 
                                         ; plusieurs reponses possibles
                                         (setq rep (:lire-reponses liste-classes)) 
                                         ; une seule reponse
                                         (print "Quel est votre")
                                         (setq rep (read))
                                         (unless (or (member rep (car liste-classes))   ;sures
                                                     (member rep (cadr liste-classes))) ;possibles
                                                 (print "Choix incorrect!")
                                                 (setq rep ()))))))))
         (flush)
         rep))

(de :lire-reponses (liste-classes)
    (print "Quels sont vos")
    (let ((nom-classes) (rep (read)))
         (until (eq rep '-)
                (if (or (member rep (car liste-classes))   ;sures
                        (member rep (cadr liste-classes))) ;possibles
                    (setq nom-classes (nconc1 nom-classes rep))
                    (print "Choix incorrect!"))
                (setq rep (read)))
         nom-classes))
