;;; Repertoire: ~LeShirka/LeIvan/CodeIace/
;;;
;     +----------------------------------------+-----------------------------------------+
;     | fichier :  fc-edatt.ll                 | package : #:iace:fc-edatt               |
;     +----------------------------------------+-----------------------------------------+
;     |                                                                                  |
;     |                     Projet de memoire CNAM en informatique                       |
;     |             Interface d'Aide a la Classification et a l'Explication              |
;     |                dans une base de connaissances a objets Shirka.                   |
;     |                        Francois Cruypenninck          1991-1992                  |
;     |                                                                                  |
;     +----------------------------------------------------------------------------------+
;     | descriptif du package :                                                          |
;     |                                                                                  |
;     | La fonction :edit permet l'edition d'un attribut d'une instance Shirka.          |
;     | Une instance de la structure AIDA {fc-edatt} composee de 8 champs est creee.     |
;     | La taille de la fenetre finale est fixe mais les composants sont crees dynami-   |
;     | quement en fonction de l'attribut.                                               |
;     |                                                                                  |
;     +----------------------------------------------------------------------------------+

;;;***************************************************************************************
;;; personnalisation du package
;;;***************************************************************************************

(defvar #:sys-package:colon '#:iace:fc-edatt)

;;;***************************************************************************************
;;; mise en place de l'image graphique de l'application editeur d'attribut
;;;***************************************************************************************

;;;***************************************************************************************
;;; creer une instance de la structure {fc-edatt} pour permettre l'edition de l'attribut

(de :edit (nom-inst titre-inst nom-attr nom-inst-trav b int dom classe schema bmodif)
    (lets ((appli (omakeq {fc-edatt} x 0 y 0 w 0 h 0))
           (schema-clas classe)
           (sch-clas schema)
           (list-dom dom)
           (list-sauf (#:ivan:ed-util:val-fac-he schema-clas nom-attr '$sauf))
           (list-inter int)
           (list-valeur (#:ivan:ed-util:val-fac-he schema-clas nom-attr '$valeur))
           (card-min (#:ivan:ed-util:val-fac-he schema-clas nom-attr '$cardmin))
           (card-max (#:ivan:ed-util:val-fac-he schema-clas nom-attr '$cardmax))
           (bvaleur (not (null list-valeur)))
           (valeur-prec (if (null (copy (#:ivan:ed-util:val-attr-sym nom-attr nom-inst-trav)))
                            list-valeur 
                            (copy (#:ivan:ed-util:val-attr-sym nom-attr nom-inst-trav))
                            )
                   )
           (list-nature (#:ivan:ed-util:nature schema-clas nom-attr))
           (bliste (eq (car list-nature) '$liste-de))
           (type-attr-temp (cadr list-nature))
           (bspec-loc (equal (ascii (sref (string type-attr-temp) 0)) '%))
           (type-attr (if bspec-loc (car (#:iace:fc-util:peres (#:iace:fc-util:schema type-attr-temp)))
                          type-attr-temp
                          )
                   )
           (btype-simple (not (null (#:ivan:ed-util:type-simple? type-attr))))
           (bchaine (eq type-attr 'chaine))
           
           )
          (unless (listp list-dom) (setq list-dom (list list-dom)))
          (unless (listp list-sauf) (setq list-sauf (list list-sauf)))
          (unless (listp list-inter) (setq list-inter (list list-inter)))
          ({application}:components appli (acons 'top appli ()))
          ({fc-edatt}:ch-scroll-com appli (:const-ch-scroll-com appli nom-attr sch-clas))
          ({fc-edatt}:ch-titre appli (:const-ch-titre appli nom-attr bliste type-attr bspec-loc))
          ({fc-edatt}:ch-sa-action appli (:const-ch-sa-action appli))
          ({fc-edatt}:ch-edc-val appli (:const-ch-edc-val appli nom-inst-trav nom-attr bliste btype-simple
                                               type-attr valeur-prec bvaleur list-dom bspec-loc bmodif
                                               )
                  )
          (if bmodif
              ({fc-edatt}:ch-ligne-valid appli (#:iace:fc-modif:const-ch-ligne-valid appli nom-inst-trav nom-attr
                                                       bliste btype-simple type-attr
                                                       valeur-prec bvaleur
                                                       )
                      )
              ({fc-edatt}:ch-ligne-valid appli (:const-ch-ligne-valid appli nom-inst-trav nom-attr bliste
                                                       btype-simple type-attr valeur-prec bvaleur
                                                       )
                      )
              )
          ({fc-edatt}:ch-scroll-val appli (:const-ch-scroll-val appli nom-inst-trav nom-attr schema-clas bliste
                                                  type-attr card-min card-max list-valeur
                                                  )
                  ) 
          ({fc-edatt}:ch-scroll-choix appli (:const-ch-scroll-choix appli bliste btype-simple type-attr list-dom))
          ({fc-edatt}:ch-contraintes appli (:const-ch-contraintes appli list-sauf list-inter))
          (setq image-ed (column (#:ivan:ed-util:centeredimage
                                         (view (filledbox 0 0 (send 'width ({fc-edatt}:ch-sa-action  appli)) 0 0)
                                               (column ({fc-edatt}:ch-titre appli)
                                                       ({fc-edatt}:ch-scroll-com appli)
                                                       ({fc-edatt}:ch-sa-action appli)
                                                       (row ({fc-edatt}:ch-scroll-val appli)
                                                            ({fc-edatt}:ch-scroll-choix appli)
                                                            )
                                                       ({fc-edatt}:ch-contraintes appli)
                                                       ({fc-edatt}:ch-edc-val appli)
                                                       )
                                               )
                                         )
                                 ({fc-edatt}:ch-ligne-valid appli)
                                 )
                )
          (send 'new-image appli (header (icon 0 0 ic-question) 
                                         (catenate nom-attr #M#:txt-const:de titre-inst)
                                         (view) (view) image-ed t t
                                         )
                )
          (#:ivan:ed-util:titre-fenetre appli #M#:txt-const:titre-ed-att)  
          (when bvaleur (:action-sa-warn appli (list (font #:ivan:ed-global:fstd #M#:txt-const:non-modifiable)
                                                     ""
                                                     (font #:ivan:ed-global:fstd #M#:txt-const:clique-annul)
                                                     )
                                )
                )
          (send 'fit-to-contents appli)
          (read-mouse)
          (let ((larg-appli (fix (/ (send 'width appli) 2)))
                (haut-appli (fix (/ (send 'height appli) 2)))
                )
               (if (> #:mouse:x larg-appli)
                   (if (< (- #:ivan:in-global:larg-appli #:mouse:x) larg-appli)
                       (let ((posx (- #:ivan:in-global:larg-appli (* 2 larg-appli))))
                            (test-y posx haut-appli appli)
                            )
                       (let ((posx (- #:mouse:x larg-appli)))
                            (test-y posx haut-appli appli)
                            )
                       )
                   (let ((posx 0))
                        (test-y posx haut-appli appli)
                        )
                   )
               )
          sortie
          )
    )

;;;***************************************************************************************
;;; test de la position de y pour placer l'application sous le curseur

(de test-y (posx haut-appli appli)
    (if (> #:mouse:y haut-appli)
        (if (< (- #:ivan:in-global:haut-appli #:mouse:y) haut-appli)
            (let ((posy (- #:ivan:in-global:haut-appli (* 2 haut-appli))))
                 (prompt-application (send 'translate appli posx posy))
                 )
            (let ((posy (- #:mouse:y haut-appli)))
                 (prompt-application (send 'translate appli posx posy))
                 )
            )
        (let ((posy 0))
             (prompt-application (send 'translate appli posx posy))
             )
        )
    )

;;;***************************************************************************************
;;; construction des differents champs de l'application editeur d'attribut
;;;***************************************************************************************

;;;***************************************************************************************
;;; construction du champ <commentaire>

(de :const-ch-scroll-com (appli nom-attr schema-clas)
    (lets ((list-comm (#:ivan:ed-util:val-fac-he schema-clas nom-attr '$com)) 
           (list-com (mapcar '(lambda (chaine)
                                      (let ((chaine-font (font #:ivan:ed-global:fstd chaine)))
                                           chaine-font
                                           )
                                      )
                             list-comm
                             )
                   )
           (col-com (apply 'column list-com))
           (larg (#:ivan:ed-util:larg-max list-comm))
           (haut (ifn (null list-com) (length list-com)))
           (h-scroll (+ {scroller}:scrollbarheight (#:ivan:ed-util:hc :%h-max) 2))
           (w-scroll (+ {scroller}:scrollbarwidth (#:ivan:ed-util:wc :%l-ea) 2))
           (img-com (cond ((null list-com) (rectangle 0 0 w-scroll 0))
                          ((and (<= larg :%l-ea) (<= haut :%h-max))
                           (view (rectangle 0 0 w-scroll (#:ivan:ed-util:hc haut)) col-com)
                           )
                          ((and (> larg :%l-ea) (> haut :%h-max)) (scroller 0 0 w-scroll h-scroll col-com t t))
                          ((> larg :%l-ea) (horizontalscroller 0 0 w-scroll h-scroll col-com))
                          ( t (verticalscroller 0 0 w-scroll h-scroll col-com))
                          )
                   )
           )
          (add-component appli 'img-com img-com)
          (if (null list-com) (rectangle 0 0 (+ 12 w-scroll) 0)
              (column (#:ivan:ed-util:clusterimage img-com #M#:txt-const:comment) "")
              )
          )
    )

;;;***************************************************************************************
;construction du champ <titre>

(de :const-ch-titre (appli nom-attr bliste type-attr bspec-loc)
    (lets ((liste-de (if bliste (font #:ivan:ed-global:fstd #M#:txt-const:liste-de) ""))
           (spec-loc (if bspec-loc (font #:ivan:ed-global:fstd #M#:txt-const:spec-loc) ""))
           (titre-attr #M#:txt-const:att-type)    
           (img (centeredview (rectangle 0 0 (send 'width (component 'img-com appli)) 0)
                        (row liste-de (font #:ivan:ed-global:fstdb (string type-attr)) " " spec-loc)
                        )
                )
           )
          (#:ivan:ed-util:clusterimage img titre-attr)
          )
    )

;;;***************************************************************************************
;;; construction du champ editeur de chaine pour saisie de la valeur de l'attribut

(de :const-ch-edc-val (appli nom-inst-trav nom-attr bliste btype-simple
                             type-attr valeur-prec bvaleur list-dom bspec-loc bmodif)
    (lets ((bout-effacer (standardbutton #M#:txt-const:effacer))
           (bout-editer (standardbutton  #M#:txt-const:editer))
           (val-initiale (#:ivan:ed-util:nom-ch (if (or bliste (null valeur-prec)) '"" valeur-prec)))
           (titre-edc (font #:ivan:ed-global:fstdb (string nom-attr)))
           (larg (send 'width (component 'img-com appli)))
           (edc-val (stringedit 0 0 larg val-initiale))
           (img-edc (column (#:ivan:ed-util:centeredimage (row titre-edc " ?"))
                            (#:ivan:ed-util:boxedimage edc-val)
                            ""
                            (if btype-simple (row " " bout-effacer " ") (row " " bout-effacer " " bout-editer " "))
                            )
                   )
           )
          (cond ((eq type-attr 'entier) (send 'filter-func edc-val ':filtre-edc-entier)
                 (send 'validate-func edc-val ':valid-edc-entier)
                 )
                ((eq type-attr 'reel) (send 'filter-func edc-val ':filtre-edc-reel)
                 (send 'validate-func edc-val ':valid-edc-reel)
                 )
                ( t (send 'filter-func edc-val ':filtre-edc) (send 'validate-func edc-val ':valid-edc))
                )
          (send 'error-func edc-val ':erreur-edc-val)
          (add-component appli 'edc-val edc-val)
          ({application}:userdata edc-val (list bliste btype-simple type-attr nom-inst-trav nom-attr))
          (set-action edc-val ':action-edc-val)
          ({application}:userdata bout-effacer (list nom-inst-trav nom-attr bliste))
          ({application}:userdata bout-editer (list nom-inst-trav nom-attr type-attr list-dom bspec-loc))
          (set-action bout-effacer ':action-bout-effacer)
          (set-action bout-editer ':action-bout-editer)
          (if bmodif (#:ivan:ed-util:clusterimage img-edc #M#:txt-const:modification)
              (#:ivan:ed-util:clusterimage img-edc #M#:txt-const:question)
              )
          )
    )

;;;***************************************************************************************
;;; filtres de l'editeur de chaine

(de :filtre-edc-entier (edc char)
    (let ((bok (or (digitp char) (equal (cascii "-") char) (equal (cascii "+") char))))
         (:filtre-msg bok)
         )
    )

(de :filtre-edc-reel (edc char)
    (let ((bok (or (digitp char) (equal (cascii "-") char) (equal (cascii "+") char) (equal (cascii ".") char))))
         (:filtre-msg bok)
         )
    )

(de :filtre-edc (edc char)
    (let ((bok (or (letterp char) (digitp char) (equal (cascii "-") char) (equal (cascii "+") char)   
                   (equal (cascii ".") char) (equal (cascii " ") char) (equal (cascii ",") char) 
                   )
               )
          )
         (:filtre-msg bok)
         )
    )

;;;***************************************************************************************
;;; envoi d'un message d'erreur si la saisie est incorrecte

(de :filtre-msg (bok)
    (if bok (:action-sa-warn (component 'sa-warn edc) '(""))
        (:action-sa-warn (component 'sa-warn edc) '("" #M#:txt-const:caractere-invalide))
        (tybeep)
        )
    bok
    )

;;;***************************************************************************************
;;; fonctions de validation de l'editeur de chaine

(de :valid-edc-entier (edc)
    (lets ((rep (send 'get-line edc))
           (val (when (> (slen rep) 0) (read-from-string rep)))
           )
          (fixp val)
          )
    )

(de :valid-edc-reel (edc)
    (lets ((rep (send 'get-line edc))
           (val (when (> (slen rep) 0) (read-from-string rep)))
           )
          (floatp val)
          )
    )

(de :valid-edc (edc)
    (lets ((rep (send 'get-line edc))
           (val (when (> (slen rep) 0) (read-from-string rep)))
           )
          (or (symbolp val) (stringp val))
          )
    )

;;;***************************************************************************************
;;; fonction d'erreur de l'editeur de chaine

(de :erreur-edc-val (edc)
    (:action-sa-warn (component 'sa-warn edc)
            (list (font #:ivan:ed-global:fstdb #M#:txt-const:valid-impossible)
                  (font #:ivan:ed-global:fstd #M#:txt-const:incorrect-type)
                  )
            )
    )

;;;***************************************************************************************
;;; creer un selecteur d'application pour afficher l'aide textuelle sur l'action en cours.

(de :const-ch-sa-action (appli)
    (let ((sa-warn (selectorapplication 0 0 (send 'width (component 'img-com appli))
                           (#:ivan:ed-util:hc 3) nil
                           )
                  )
          )
         (add-component appli 'sa-warn sa-warn)
         (#:ivan:ed-util:clusterimage sa-warn #M#:txt-const:message)
         )
    )

;;;***************************************************************************************
;;; construction du scroller de valeurs de l'attribut.

(de :const-ch-scroll-val (appli nom-inst-trav nom-attr schema-clas bliste type-attr card-min card-max list-valeur)
    (lets ((list-val-sy (#:ivan:ed-util:val-attr-sym nom-attr nom-inst-trav))
           (list-val-sym (if (null list-val-sy) list-valeur list-val-sy))
           (list-val-ch (if (listp list-val-sym) (mapcar 'string list-val-sym)
                            (list (string list-val-sym))
                            )
                   )
           (sm-val (stringmenu list-val-ch))
           (cb-entete (checkbox 0 0 #20wc #hc #M#:txt-const:ins-tete))
           (larg (- (div (send 'width ({fc-edatt}:ch-scroll-com appli)) 2) 12))
           (scroll-val (scroller 0 0 larg #10hc sm-val t t))
           (titre-img (if bliste #M#:txt-const:valeurs #M#:txt-const:valeur))
           (img-sel-val (if bliste scroll-val scroll-val))
           )
          (add-component appli 'scroll-val scroll-val)
          (add-component appli 'sm-val sm-val)
          (add-component appli 'img-sel-val img-sel-val)
          (add-component appli 'cb-entete cb-entete)
          ({application}:userdata sm-val (list nom-inst-trav nom-attr type-attr))
          (set-action sm-val ':action-sm-val)
          (set-action cb-entete ':action-cb-entete)
          (if bliste (#:ivan:ed-util:clusterimage img-sel-val titre-img) (rectangle 0 0 (+ 12 larg) 0))
          
          )
    )

;;;***************************************************************************************
;;; construction du scroller des valeurs possibles soit instances, soit domaine

(de :const-ch-scroll-choix (appli bliste btype-simple type-attr list-dom)
    (lets ((list-val-pos (if (null list-dom) (#:ivan:ed-util:diff-liste (#:ivan:ed-util:l-inst-t-ch type-attr)
                                                     #:ivan:ed-global:%list-inst-trav
                                                     )
                             ;                                             list-dom
                             ; a supprimer si l'on ne veut pas afficher le terme autre
                             (if (equal type-attr 'booleen)
                                 list-dom
                                 (cons list-dom 'autre)
                                 )
                             )
                   )
           (img-sel-val (component 'img-sel-val appli))
           (liste-dom-autre (#:iace:fc-interf:list-plate (if list-val-pos list-val-pos nil)))
           (sm-choix (stringmenu (mapcar 'string liste-dom-autre)))
           (larg (- (div (send 'width ({fc-edatt}:ch-scroll-com appli)) 2) 12))
           (scroll-choix (scroller 0 0 larg #10hc sm-choix t t))
           (titre-img (if (null list-dom) (row #M#:txt-const:inst-de (string type-attr))
                          #M#:txt-const:domaine
                          )
                   )
           (img-sel-inst (view (rectangle 0 0 larg (send 'height img-sel-val)) scroll-choix)) 
           )
          (add-component appli 'scroll-choix scroll-choix)  
          (add-component appli 'sm-choix sm-choix)
          ({application}:userdata sm-choix bliste)
          (set-action sm-choix ':action-sm-choix)
          (if (and btype-simple (null list-dom)) (rectangle 0 0 0 0)
              (#:ivan:ed-util:clusterimage img-sel-inst titre-img)
              )
          )
    )

;;;***************************************************************************************
;;; construction de la ligne de validation

(de :const-ch-ligne-valid (appli nom-inst-trav nom-attr bliste btype-simple type-attr valeur-prec bvaleur)
    (lets ((bout-indefini  (standardbutton #M#:txt-const:indefini))
           (bout-valider (standardbutton #M#:txt-const:valider-cla))
           (bout-arreter (standardbutton #M#:txt-const:arreter-cla))
           (ligne (#:ivan:ed-util:centeredimage (row bout-valider "  " bout-indefini "  " bout-arreter)))
           )
          (send 'w ligne (send 'width (component 'img-com appli)))
          ({application}:userdata bout-arreter (list nom-inst-trav nom-attr bliste type-attr valeur-prec))
          ({application}:userdata bout-indefini (list nom-inst-trav nom-attr bliste type-attr valeur-prec))
          (set-action bout-arreter ':action-bout-arreter)
          (add-component appli 'bout-valider bout-valider)
          ({application}:userdata bout-valider) 
          (set-action bout-valider ':action-bout-valider)
          (add-component appli 'bout-indefini bout-indefini)
          (set-action bout-indefini ':action-bout-indefini)
          (#:ivan:ed-util:clusterimage ligne #M#:txt-const:comande)
          )
    )

;;;***************************************************************************************
;;; construction du champ des contraintes a partir des facettes $sauf et $intervalle.

(de :const-ch-contraintes (appli list-sauf list-inter)
    (lets ((list-binf (:list-borne list-inter t))
           (list-bsup (:list-borne list-inter nil))
           (sm-binf (stringmenu (mapcar 'string list-binf)))
           (sm-bsup (stringmenu (mapcar 'string list-bsup)))
           (tit-binf (font #:ivan:ed-global:fstd #M#:txt-const:borne-inf))
           (tit-bsup (font #:ivan:ed-global:fstd #M#:txt-const:borne-sup))
           (titre (row (rectangle 0 0 {scroller}:scrollbarwidth 0) tit-binf "  " tit-bsup))
           (scroll-inter (scroller 0 0 (send 'width titre) #5hc (row sm-binf "  " sm-bsup) t t))
           (img-inter (if (null list-inter) (rectangle 0 0 (send 'width titre) 0)
                          (#:ivan:ed-util:clusterimage (column titre scroll-inter) "Intervalle")
                          )
                   )
           (sm-sauf (stringmenu (mapcar 'string list-sauf)))
           (larg-sauf (- (send 'width ({fc-edatt}:ch-scroll-com appli)) (send 'width img-inter) 12))
           (scroll-sauf (scroller 0 0 larg-sauf #5hc sm-sauf t t))
           (img-sauf (if (null list-sauf) (rectangle 0 0 (+ larg-sauf 12) 0)
                         (#:ivan:ed-util:clusterimage scroll-sauf "Valeurs interdites")
                         )
                   )
           (img (if (and (null list-sauf) (null list-inter)) (rectangle 0 0 0 0) (row img-sauf img-inter)))
           )
          (send 'w sm-binf (send 'width tit-binf))
          (send 'w sm-bsup (send 'width tit-bsup))
          (when (or list-sauf list-inter) (send 'resize img nil (max (send 'height img-sauf) (send 'height img-inter))))
          (set-action sm-sauf ':action-reinit-sm)
          (set-action sm-binf ':action-reinit-sm)
          (set-action sm-bsup ':action-reinit-sm)
          img
          )
    )

;;;***************************************************************************************
;;; construire la liste des bornes min ou max en fonction la variable pos

(de :list-borne (int bpos)
    (let ((list nil))
         (cond ((null int) nil)
               ( bpos (cons (caar int) (:list-borne (cdr int) bpos)))
               ( t (cons (cadar int) (:list-borne (cdr int) bpos))) 
               )
         )
    )

;;;***************************************************************************************
;;; deroulement des action sur les champs
;;;***************************************************************************************

;;;***************************************************************************************
;;; action du bouton standard de validation

(de :action-bout-valider (b)
    (let ((bok (:action-edc-val (component 'edc-val b))))
         (when bok (remove-application (component 'top b)))
         )
    )

;;;***************************************************************************************
;;; action du bouton standard arreter

(de :action-bout-arreter (b)
    (exit arret-classif (setq %arret t))
    ;    (lets ((list-param ({application}:userdata b))
    ;           (blist (nth 2 list-param))
    ;          )
    ;          (if blist  (setq sortie '(<))
    ;                     (setq sortie "<")
    ;          )    
    ;          (remove-application (component 'top b))
    ;    )
    )

;;;***************************************************************************************
;;; action du bouton standard indefini

(de :action-bout-indefini (b)
    (lets ((list-param ({application}:userdata b))
           (blist (nth 2 list-param))
           )
          (if blist  (setq sortie '(-))
              (setq sortie "-")
              )
          (remove-application (component 'top b))
          )
    )

;;;***************************************************************************************
;;; action du bouton standard d'edition d'une instance

(de :action-bout-editer (b)
    (lets ((list-param ({application}:userdata b))
           (nom-inst-trav (nth 0 list-param))
           (nom-attr (nth 1 list-param))
           (type-attr (nth 2 list-param))
           (list-dom (nth 3 list-param))
           (bspec-loc (nth 4 list-param))
           (valedc-ch (send 'get-line (component 'edc-val b)))
           (valedc-sym (#:ivan:ed-util:symbole valedc-ch))
           (nom-classe (#:ivan:ed-util:symbole type-attr))
           (list-val (#:ivan:ed-util:l-inst-t-ch type-attr))
           classe-valedc
           )
          (when (activatedp b)
                (ifn valedc-sym (progn (:envoie-msg b (list (font #:ivan:ed-global:fstd "")
                                                            (font #:ivan:ed-global:fstd
                                                                  "Il faut d'abord donner un nom d'instance !"
                                                                  )
                                                            )
                                               )
                                       (current-keyboard-focus-window ({application}:window (component 'edc-val b)))
                                       nil
                                       )
                     (if (and bspec-loc
                              (not (member valedc-sym (#:ivan:ed-util:l-inst-t-sym
                                                              (#:iace:fc-util:schema nom-classe)
                                                              )
                                           )
                                   )
                              )
                         (progn (:envoie-msg b (list (font #:ivan:ed-global:fstdb
                                                           "Valeur invalide !"
                                                           )
                                                     (font #:ivan:ed-global:fstd
                                                           "Il faut choisir une instance connue"
                                                           )
                                                     (font #:ivan:ed-global:fstd
                                                           "dans le cas de la specialisation locale."
                                                           )
                                                     )
                                        )
                                nil
                                ) 
                         (if (member valedc-sym (#:iace:fc-util:l-inst-t (#:iace:fc-util:schema 'objet)))
                             (setq classe-valedc (#:iace:fc-util:nom-sch
                                                         (#:ivan:ed-util:classe-de valedc-sym)
                                                         )
                                   )
                             (setq classe-valedc type-attr)
                             )
                         (if (and (not (#:iace:fc-util:admissible?
                                               valedc-sym
                                               (#:ivan:ed-util:ch-as-sym nom-attr)
                                               (#:iace:fc-util:schema (#:ivan:ed-util:classe-de nom-inst-trav))
                                               (#:iace:fc-util:schema nom-inst-trav)
                                               )
                                       )
                                  (not (equal type-attr classe-valedc)) 
                                  )
                             (progn (:envoie-msg b (list (row (font #:ivan:ed-global:fstdb
                                                                    valedc-ch
                                                                    )
                                                              (font #:ivan:ed-global:fstd
                                                                    " (classe "
                                                                    )
                                                              (font #:ivan:ed-global:fstdb
                                                                    (string classe-valedc)
                                                                    )
                                                              (font #:ivan:ed-global:fstd ")")
                                                              )
                                                         (font #:ivan:ed-global:fstd 
                                                               "est une instance incompatible pour l'attribut"
                                                               )
                                                         (row (font #:ivan:ed-global:fstdb
                                                                    (string nom-attr)
                                                                    )
                                                              (font #:ivan:ed-global:fstd " !")
                                                              )
                                                         )
                                            )
                                    nil
                                    )
                             (if (member valedc-sym #:ivan:ed-global:%list-nom-inst)
                                 (progn (:envoie-msg b (list (font #:ivan:ed-global:fstd 
                                                                   "Impossible !"
                                                                   )
                                                             (font #:ivan:ed-global:fstdb 
                                                                   "Instance deja en cours d'edition."
                                                                   )
                                                             )
                                                )
                                        nil
                                        )
                                 (#:ivan:ed-edinst:edit classe-valedc valedc-sym nil nil nil nil nil)
                                 (lets ((list-val-pos (if (null list-dom)
                                                          (#:ivan:ed-util:diff-liste
                                                                  (#:ivan:ed-util:l-inst-t-ch type-attr)
                                                                  #:ivan:ed-global:%list-inst-trav
                                                                  )
                                                          (mapcar 'string (#:iace:fc-interf:list-plate
                                                                                  ;                                                                                         list-dom
                                                                                  ; a supprimer si l'on ne veut pas afficher le terme autre
                                                                                  (if (equal type-attr 'booleen)
                                                                                      list-dom
                                                                                      (cons list-dom 'autre)
                                                                                      )
                                                                                  )
                                                                  )
                                                          )
                                                ) 
                                        (val-edc (#:ivan:ed-util:symbole
                                                         (car (#:ivan:ed-util:diff-liste
                                                                      (#:ivan:ed-util:l-inst-t-ch type-attr)
                                                                      list-val
                                                                      )
                                                              )
                                                         )
                                                )
                                        (val-ret (if val-edc val-edc valedc-ch))
                                        )
                                       (send 'set-strings (component 'sm-choix b) list-val-pos)
                                       (#:ivan:ed-util:positionne (component 'scroll-choix b) nil)
                                       (send 'set-line (component 'edc-val b) (string val-ret))
                                       t
                                       )
                                 )
                             )
                         )
                     )
                )
          )
    )

;;;***************************************************************************************
;;; action du bouton standard d'effacement de la zone d'edition

(de :action-bout-effacer (b)
    (lets ((list-param ({application}:userdata b))
           (nom-inst-trav (nth 0 list-param))
           (nom-attr (nth 1 list-param))
           (bliste (nth 2 list-param))
           )
          (when (activatedp b)
                (send 'set-line (component 'edc-val b) '"") 
                (:action-sa-warn b (list " "))
                )
          )
    )

;;;***************************************************************************************
;;; action apres saisie d'une valeur d'attribut dans l'editeur de chaine 

(de :action-edc-val (edc)
    (lets ((list-param ({application}:userdata edc))
           (bliste (nth 0 list-param))
           (btype-simple (nth 1 list-param))
           (type-attr (nth 2 list-param))
           (nom-inst-trav (nth 3 list-param))
           (nom-attr (nth 4 list-param))
           (pere (component 'top edc))
           (sm-val (component 'sm-val edc))
           (scroll-val (component 'scroll-val edc))
           (cb-entete (component 'cb-entete edc))
           (nom-edc-ch (send 'get-line edc))
           (nom-edc-sym (#:ivan:ed-util:symbole nom-edc-ch))
           (nom-classe (#:ivan:ed-util:symbole type-attr))
           valret
           )
          (:action-sa-warn edc '(""))
          (if (<= (slength nom-edc-ch) 0)
              (:action-sa-warn edc (list (font #:ivan:ed-global:fstd "Donnez plus d'information ...")))
              (if (and (not btype-simple) (not (member nom-edc-sym (#:ivan:ed-util:l-inst-t-sym nom-classe))))
                  (progn (:action-sa-warn edc (list (font #:ivan:ed-global:fstd "Instance inconnue pour la classe : ")
                                                    (row (font #:ivan:ed-global:fstdb (string type-attr))
                                                         (font #:ivan:ed-global:fstd " !")
                                                         )
                                                    )
                                 )
                         (ifn (:action-bout-editer edc)
                              nil
                              (if (member nom-edc-sym (#:ivan:ed-util:l-inst-t-sym nom-classe))
                                  (:bajout-val bliste nom-inst-trav nom-attr nom-edc-ch sm-val type-attr cb-entete pere)
                                  (unless (member (#:ivan:ed-util:symbole nom-edc-ch)
                                                  (#:ivan:ed-util:l-inst-t-sym 'objet)
                                                  )
                                          (:envoie-msg edc (list (font #:ivan:ed-global:fstdb 
									#M#:txt-const:inst-pas-cree)
                                                                 (font #:ivan:ed-global:fstd
									#M#:txt-const:saisir-autre-ou-creer)
                                                                 (font #:ivan:ed-global:fstd
									#M#:txt-const:clic-edit)
                                                                 )
                                                  )
                                          )
                                  nil
                                  )
                              )
                         )
                  (:bajout-val bliste nom-inst-trav nom-attr nom-edc-ch sm-val type-attr cb-entete pere)
                  )
              )
          )
    )

;;;***************************************************************************************
;;; ajouter la valeur de l'attribut d'une instance

(de :bajout-val (bliste nom-inst-trav nom-attr valeur sm-val type-attr cb-entete pere)
    (if bliste (:ajoute-val-sm nom-inst-trav nom-attr valeur sm-val type-attr (#:ivan:ed-util:ins-en-fin? cb-entete))
        (:ajoute-val nom-inst-trav nom-attr valeur pere type-attr)
        )
    )

;;;***************************************************************************************
;;; ajouter la valeur dans le cas d'un attribut multi-value

(de :ajoute-val-sm (nom-inst-trav nom-attr valeur sm-val type-attr ins-en-fin)
    (if (member valeur (send 'get-strings sm-val))
        (:envoie-msg sm-val (list (font #:ivan:ed-global:fstdb #M#:txt-const:valeur-non-admiss)
                                  (font #:ivan:ed-global:fstd #M#:txt-const:changer-val)
                                  (font #:ivan:ed-global:fstd #M#:txt-const:effacer-avant)
                                  )
                )
        (lets ((old (send 'get-strings sm-val))
               (new (if ins-en-fin (reverse (cons valeur (reverse old))) (cons valeur old)))
               )
              (send 'set-strings sm-val new)         
              (#:ivan:ed-util:positionne (component 'scroll-val sm-val) ins-en-fin)
              (send 'set-line edc "")
              (:action-sa-warn sm-val (list (font #:ivan:ed-global:fstd
						(catenate #M#:txt-const:choix-autre #M#:txt-const:de-liste))))
              (setq sortie new)
              )
        t
        )
    )

;;;***************************************************************************************
;;; ajouter la valeur dans le cas d'un attribut mono-value

(de :ajoute-val (nom-inst-trav nom-attr valeur appli type-attr)
    (let ()
         (:action-sa-warn appli (list (font #:ivan:ed-global:fstd #M#:txt-const:clic-val)
                                      )
                 )
         )
    (setq sortie valeur)
    t
    )

;;;***************************************************************************************
;;; envoi du message <list-msg> au composant sa-warn de l'application <appli>

(de :action-sa-warn (appli list-msg)
    (let ((col-msg (apply 'column list-msg)))
         (send 'set-image (component 'sa-warn appli) col-msg)
         )
    )

;;;***************************************************************************************
;;; envoi du message <list-msg> en declenchant 2 beeps

(de :envoie-msg (comp list-msg)
    (tybeep) (:action-sa-warn comp list-msg)
    )

;;;***************************************************************************************
;;; action du selecteur de menus

(de :action-sm-val (sm)
    (lets ((valeur (send 'get-selected-string sm))
           (rang (if valeur (+ (send 'get-selected-rank sm) 1)))
           (list-param ({application}:userdata sm))
           (nom-inst-trav (nth 0 list-param))
           (nom-attr (nth 1 list-param))
           (type-attr (nth 2 list-param))
           )
          (ifn valeur 't
               (send 'set-strings sm (#:ivan:ed-util:supp-nl rang (send 'get-strings sm)))
               (send 'set-line (component 'edc-val sm) valeur)
               )
          )
    )

;;;***************************************************************************************
;;; action de la case a cocher dans le cas d'une liste de valeurs

(de :action-cb-entete (cb)
    (let ((choix (send 'checkedp cb)))
         (if choix (:action-sa-warn cb (list (font #:ivan:ed-global:fstd 
						(catenate #M#:txt-const:ins-tete #M#:txt-const:de-liste))
                                             )
                           )
             (:action-sa-warn cb (list (font #:ivan:ed-global:fstd 
						(catenate #M#:txt-const:ins-fin #M#:txt-const:de-liste))
                                       )
                     )
             )
         )
    )

;;;***************************************************************************************
;;; action du selecteur de menus sm

(de :action-sm-choix (sm)
    (lets ((valeur (send 'get-selected-string sm))
           (bliste ({application}:userdata sm))
           (list-val (send 'get-strings (component 'sm-val sm)))
           )
          (ifn valeur 't
               (send 'set-selected-string sm "")
               (send 'set-line (component 'edc-val sm) valeur)
               (if bliste (:action-sa-warn sm (list (font #:ivan:ed-global:fstd #M#:txt-const:faire-rc)
                                                    (font #:ivan:ed-global:fstd
						    (catenate #M#:txt-const:pour-aj-val #M#:txt-const:ou-valid))
                                                    )
                                  )
                   (:action-sa-warn sm (list (font #:ivan:ed-global:fstd #M#:txt-const:clic-val)))
                   )
               )
          )
    )

;;;***************************************************************************************
;;; reinitialise le scroller sm pour desselectionner la valeur qui a ete cliquee.

(de :action-reinit-sm (sm)
    (let ((valeur (send 'get-selected-string sm)))
         (ifn valeur 't (send 'set-selected-string sm ""))
         )
    )

;;;***************************************************************************************
