;;; Repertoire: ~/LeShirka/LeIvan/CodeIace/
;;;
;     +----------------------------------------+-----------------------------------------+
;     | fichier :  fc-expli.ll                 | package : #:iace:fc-expli               |
;     +----------------------------------------+-----------------------------------------+
;     |                                                                                  |
;     |                     Projet de memoire CNAM en informatique                       |
;     |             Interface d'Aide a la Classification et a l'Explication              |
;     |                dans une base de connaissances a objets Shirka.                   |
;     |                        Francois Cruypenninck    1991-1992                        |
;     |                                                                                  |
;     +----------------------------------------------------------------------------------+
;     | descriptif du package :                                                          |
;     |                                                                                  |
;     | La fonction principale :moteur d'explication shirka modifie pour le rendre       |
;     |  compatible avec l'interface IACE .                                              |
;     | Interactivite entre le module de classification pour que l'explication se fasse  |
;     |  en meme temps que la classification de l'instance .                             |
;     | Explication apres classification pour permettre une modification d'attribut      |
;     |  puis relancer la classification .                                               |
;     |                                                                                  |
;     +----------------------------------------------------------------------------------+

;;;***************************************************************************************
;;; personnalisation du package
;;;***************************************************************************************

(defvar #:sys-package:colon '#:iace:fc-expli)

;;;***************************************************************************************
;;; bouton [mode] qui definit si on fait de la classification ou de l'explication

(de :action-bouts-mode (b)
    (ifn (send 'get-current (component 'ed-arbre b))
         (when t (#:iace:fc-interf:action-sa-warn b nil t (list (font #:ivan:in-global:fstd
									#M#:txt-const:no-cl-sel)
                                                                )
                         )
               (setq selection-classe nil)
               )
         ({medite}:readonly-flag (component 'edl-expli b) ())
         (if %mode (progn (send 'set-line (component 'edl-expli b) #M#:txt-const:mode-expl)
                          ;hy-----------------------------------------------------------
                          ; permet la selection a la souris dans le texte d'explication
                          (te-set-local-binding (component 'sm-explication b) 'down0 '#:iace:fc-interf:appel-hyper)
                          (te-set-local-binding (component 'sm-explication b) 'down1 '#:iace:fc-interf:appel-hyper)
                          (te-set-local-binding (component 'sm-explication b) 'down2 '#:iace:fc-interf:appel-hyper)
                          ;-------------------------------------------------------------
                          (setq %mode ())
                          (:explication b)
                          )
             ;hy-----------------------------------------------------------
             ;                   (#:iace:fc-interf:reinit-sm (component 'scroll-explication b)
             ;                                               (component 'sm-explication b)
             ;                                               ""
             ;                   )
             ; permet la selection a la souris dans le texte d'explication
             (te-set-local-binding (component 'sm-explication b) 'down0 '())
             (te-set-local-binding (component 'sm-explication b) 'down1 '())
             (te-set-local-binding (component 'sm-explication b) 'down2 '())
             ; reinit editeur hypertexte
             (#:iace:fc-interf:reinit-sm-hy (component 'scroll-explication b)
                     (component 'sm-explication b)
                     ()
                     )
             ;-------------------------------------------------------------
             (send 'set-line (component 'edl-expli b) #M#:txt-const:mode-clas)
             (setq %mode t)
             )
         ({medite}:readonly-flag (component 'edl-expli b) t)
         )
    )

;;;***************************************************************************************
;;; deroulement de l'explication active. pendant une classification

(de :explication (bouton)
    (if (send 'get-current (component 'ed-arbre bouton))
        (lets ((nom-cl (list (#:ivan:ed-util:symbole (send 'nom (send 'get-current (component 'ed-arbre bouton))))))
               (instance (send 'nom-inst (send 'get-current (component 'ed-arbre bouton))))
               (nom-inst (#:ivan:ed-util:symbole (if (equal instance "")
                                                     (send 'get-line (component 'edl-instance bouton))
                                                     instance
                                                     )
                                 )
                       )
               (nom-inst-bid (getprop nom-inst 'inst-bid))
               )
              (inhibit-application (component 'bouts-pourquoi bouton))
              (:rech-expl nom-inst nom-inst-bid nom-cl bouton)
              )
        ;hy-----------------------
        ;reinit editeur hypertexte
        ;        (#:iace:fc-interf:reinit-sm (component 'scroll-explication bouton)
        ;                                    (component 'sm-explication bouton)
        ;                                    ""
        ;        )
        (#:iace:fc-interf:reinit-sm-hy (component 'scroll-explication bouton)
                (component 'sm-explication bouton)
                ()
                )
        ;-------------------------
        )
    )

(de :rech-expl (nom-inst nom-inst-bid lis-classes bouton)
    (let ((lis-bid lis-classes))
         (if (eq (length lis-classes) 1) (setq %liste-expli nil))
         (while (nextl lis-classes nom-pere)
                (if (and (> (length lis-bid) 1)
                         (equal (send 'img (getprop nom-pere 'noeud-iace)) "sur")
                         )
(when #:trace:cla
                    (print "pas d`explication")
)
                    (:trait-expl nom-inst nom-inst-bid nom-pere bouton)
                    )
                )
         )
    )

(de :trait-expl (nom-inst nom-inst-bid nom-sch bouton)
    (lets ((image (send 'img (send 'get-current (component 'ed-arbre bouton)))))
          (if (or (not nom-inst-bid)(equal image "interro")) ; explication d'une classe ? apres une classification
              (let ((text1 (concat #M#:txt-const:l-inst (string nom-inst)))
                    (text2 #M#:txt-const:pas-testee)
                    (text3 (concat #M#:txt-const:ratt-imp2 (STRINg nom-sch) "."))
                    )
                   ;                   (setq %liste-expli nil)
                   (setq %liste-expli (cons %liste-expli (#:ivan:ed-util:symbole text1)))
                   (setq %liste-expli (cons %liste-expli (#:ivan:ed-util:symbole text2)))
                   (setq %liste-expli (cons %liste-expli (#:ivan:ed-util:symbole text3)))
                   ;hy------------------------
                   ; reinit editeur hypertexte
                   ;                   (#:iace:fc-interf:reinit-sm (component 'scroll-explication bouton)
                   ;                                               (component 'sm-explication bouton)
                   ;                                               (:list-plate-expli %liste-expli)
                   ;                   )
                   (#:iace:fc-interf:reinit-sm-hy (component 'scroll-explication bouton)
                           (component 'sm-explication bouton)
                           (:list-plate-expli %liste-expli)
                           )
                   ;--------------------------
                   )
              (if (eq (#:iace:fc-util:prop-inst nom-inst-bid nom-sch) 'sur)
                  (:affexpl nom-inst nom-inst-bid nom-sch bouton) ;# explication dans le cas d'une classe SUR
                  (let ((expl (getprop nom-inst-bid nom-sch)))
                       (if expl (:affexpl nom-inst nom-inst-bid nom-sch bouton)
                           (:rech-expl nom-inst nom-inst-bid
                                   (#:iace:fc-util:peres (#:iace:fc-util:schema nom-sch)) bouton
                                   )
                           )
                       )
                  )
              )
          )
    )

;;;***************************************************************************************
;;; affichage proprement dit de l'explication

(de :affexpl (nom-inst nom-inst-bid nom-sch bouton)
    (slet ((explication (getprop nom-inst-bid nom-sch))
           (prop (if (eq (#:iace:fc-util:prop-inst nom-inst-bid nom-sch) 'sur)
                     'sur
                     (car explication)
                     )
                 )
           (explic (cdr explication))
           )
          ;          (setq %liste-expli nil)
          (let ((text1 (concat #M#:txt-const:l-inst (string nom-inst)))
                (text2 (concat (selectq prop (sur #M#:txt-const:peut)
                                       (possible #M#:txt-const:pourrait)
                                       (impossible #M#:txt-const:ne-peut-pas)
                                       )
                               #M#:txt-const:appart
                               )
                       )
                (text3 (concat #M#:txt-const:ratt-imp2 (string nom-sch) "."))
                )
               (setq %liste-expli (cons %liste-expli (#:ivan:ed-util:symbole text1)))
               (setq %liste-expli (cons %liste-expli (#:ivan:ed-util:symbole text2)))
               (setq %liste-expli (cons %liste-expli (#:ivan:ed-util:symbole text3)))
               (if (eq prop 'sur)
                   (lets ((cl-tempo (#:iace:fc-util:gen-symbole nom-sch))
                          (sch-inst (#:iace:fc-util:schema nom-inst))
                          (sch-tempo (#:iace:fc-util:cr-inst-temp sch-inst nom-sch cl-tempo))
                          (prop-sch (getprop cl-tempo 'schema))
                          )
                         (:visualiser sch-tempo nil nil 0 t)
                         (#:iace:fc-util:sup-inst prop-sch nil)
                         )
                   ) 
               )
          (while (nextl explic expl)
                 (if (neq (vref expl 2) 'vide)
                     (slet (((type-di . dom-inter)(vref expl 2))
                            (prop (vref expl 0))
                            (nom-att (car (vref expl 1)))
                            (valeurs (if (listp (cadr (vref expl 1)))
                                         (caadr (vref expl 1))
                                         (cadr (vref expl 1))
                                         )
                                    )
                            (val (if (vectorp valeurs)
                                     (#:iace:fc-util:nom-sch valeurs)
                                     valeurs
                                     )
                                 )
                            (text11 (concat #M#:txt-const:val-inst (string nom-att)))
                            (text12 (concat #M#:txt-const:est
                                            (if (and (null type-di)(null dom-inter)(null val))
                                                (if (eq prop 'possible) #M#:txt-const:inverif
									#M#:txt-const:verif-imp)
                                                (ifn val #M#:txt-const:ind (concat " " (string (:ecr-dom val))))
                                                )
                                            )
                                    )
                            (text2 (ifn (and (null type-di)(null dom-inter)(null val))
                                        (if (eq type-di 't) (concat #M#:txt-const:appart-cl
                                                                    (string (vref (#:iace:fc-util:schema val) %est-un))
                                                                    )
                                            )
                                        )
                                   )
                            (text31 (ifn (and (null type-di)(null dom-inter)(null val))
                                         (if (eq type-di 'p)(concat #M#:txt-const:pred
                                                                    (string (:ecr-dom dom-inter)) "."
                                                                    )
						#M#:txt-const:adm-pour)
                                         )
                                    )
                            (text32 (ifn (and (null type-di)(null dom-inter)(null val))
                                         (ifn (eq type-di 'p)(concat "   " (if (eq type-di 'i)
                                                                               (string (:ecr-int dom-inter))
                                                                               (if (eq type-di 'd)
                                                                                   (string (:ecr-dom dom-inter))
										   #M#:txt-const:la-cla
                                                                                   (concat " " (string (car dom-inter)))
                                                                                   )
                                                                               )
                                                                     "."
                                                                     )
                                              )
                                         )
                                    )
                            )
                           (setq %liste-expli (cons %liste-expli (#:ivan:ed-util:symbole text11)))
                           (setq %liste-expli (cons %liste-expli (#:ivan:ed-util:symbole text12)))
                           (ifn text2
                                (inhibit-application (component 'bouts-pourquoi bouton))
                                (authorize-application (component 'bouts-pourquoi bouton))
                                (setq %liste-expli (cons %liste-expli (#:ivan:ed-util:symbole text2)))
                                )
                           (if text31 (progn (setq %liste-expli (cons %liste-expli (#:ivan:ed-util:symbole text31)))
                                             (setq %liste-expli (cons %liste-expli (#:ivan:ed-util:symbole text32)))
                                             )
                               )
                           )
                     (setq %liste-expli
                           (cons %liste-expli (#:ivan:ed-util:symbole
                                                      (concat #M#:txt-const:intersec
                                                              #M#:txt-const:de-l-att
                                                              (string (car (vref expl 1)))
                                                              )
                                                      )
                                 )
                           )
                     (setq %liste-expli (cons %liste-expli
                                              (#:ivan:ed-util:symbole #M#:txt-const:cla-orig)
                                              )
                           )
                     (setq %liste-expli (cons %liste-expli
                                              (#:ivan:ed-util:symbole
                                                      (concat "    "
                                                              (string (vref (#:iace:fc-util:schema nom-inst) %est-un)) 
                                                              #M#:txt-const:vide
                                                              )
                                                      )
                                              )
                           )
                     )
                 )
          ;hy------------------------
          ; reinit editeur hypertexte
          ;          (#:iace:fc-interf:reinit-sm (component 'scroll-explication bouton)
          ;                                      (component 'sm-explication bouton)
          ;                                      (:list-plate-expli %liste-expli)
          ;          )
          (#:iace:fc-interf:reinit-sm-hy (component 'scroll-explication bouton)
                  (component 'sm-explication bouton)
                  (:list-plate-expli %liste-expli)
                  )
          ;--------------------------
          )
    )

;;;***************************************************************************************
;;; cas d'une explication sur une classe "sure" 
;;; on fait donc une visualisation des valeurs d'attributs de cette classe

(de :visualiser (instance pour-classes sauf-classes niveau binf)
    (if pour-classes (setq pour-classes (nconc1 pour-classes 'Attribut-Shirka-est-un))
        (setq sauf-classes (nconc1 sauf-classes 'Attribut-Shirka-sauf-est-un))
        )
    (slet ((schema (#:iace:fc-util:schema (#:iace:fc-util:val-inst instance %est-un)))
           (nom-inst (#:iace:fc-util:nom-sch instance))
           )
          (if (cdr (#:iace:fc-util:l-nom-att-he-class schema pour-classes sauf-classes)); il n'y a pas d'attribut pour
              (setq %liste-expli (cons %liste-expli #M#:txt-const:val-att)); cette classe
              )
          (mapc '(lambda (nom-att)
                         (ifn (eq nom-att 'est-un)
                              (:vi-att instance pour-classes sauf-classes schema nom-att niveau binf)
                              )
                         )
                (if binf (#:iace:fc-util:l-nom-att-he-class schema pour-classes sauf-classes)
                    (#:iace:fc-util:l-nom-att-inst-he-class schema  pour-classes sauf-classes)
                    )
                )
          )
    )

;;;***************************************************************************************
;;; visualisation d'un attribut nomme "nom-att"

(de :vi-att (instance pour-classes sauf-classes schema nom-att niveau binf)
    (ifn (eq nom-att 'lui-meme)
         (let (((nature type) (#:iace:fc-util:nature schema nom-att))
               (nom-inst (#:iace:fc-util:nom-sch instance))
               (valeurs (if binf (#:iace:fc-util:valeur? nom-att instance)
                            (#:iace:fc-util:val-inst instance (#:iace:fc-util:pos-nom-att schema nom-att))
                            )
                       )
               )
              (setq %liste-expli
                    (cons %liste-expli
                          (#:ivan:ed-util:symbole
                                  (concat "    " nom-att " = "
                                          (if (listp valeurs)
                                              (progn (setq liste "")
                                                     (mapc '(lambda (valeur)
                                                                    (setq liste (concat liste (string valeur) " "))
                                                                    )
                                                           (if (listp (car valeurs))
                                                               (if (vectorp (caar valeurs))
                                                                   (list (#:iace:fc-util:nom-sch (caar valeurs)))
                                                                   (car valeurs)
                                                                   )
                                                               (if (vectorp (car valeurs))
                                                                   (list (#:iace:fc-util:nom-sch (car valeurs)))
                                                                   valeurs
                                                                   )
                                                               )
                                                           )
                                                     liste                                                 
                                                     )
                                              (if (vectorp valeurs)
                                                  (#:iace:fc-util:nom-sch valeurs)
                                                  valeurs
                                                  )
                                              )
                                          )
                                  )
                          )
                    )
              )
         )
    )

;;;***************************************************************************************
;;; action sur le bouton [pourquoi] 
;;; avec objets complexes, il faut deplacer la classe pour avoir une explication plus precise

(de :action-bouts-pourquoi (b)
    (lets ((nom-sch (#:ivan:ed-util:symbole (send 'nom (send 'get-current (component 'ed-arbre b)))))
           (instance (send 'nom-inst (send 'get-current (component 'ed-arbre b))))
           (nom-inst (#:ivan:ed-util:symbole (if (equal instance "")
                                                 (send 'get-line (component 'edl-instance b))
                                                 instance
                                                 )
                             )
                   )
           (nom-inst-bid (getprop nom-inst 'inst-bid))
           (explication (getprop nom-inst-bid nom-sch))
           (explic (cdr explication))
           (expl (car explic))
           ((type-di . dom-inter)(vref expl 2))
           (valeurs (if (listp (cadr (vref expl 1)))
                        (caadr (vref expl 1))
                        (cadr (vref expl 1))
                        )
                   )
           (val (if (vectorp valeurs)
                    (#:iace:fc-util:nom-sch valeurs)
                    valeurs
                    )
                )                                   
           (noeud-classe (if (or (equal (#:ivan:ed-util:symbole val)
                                        (#:ivan:ed-util:symbole (send 'get-line (component 'edl-instance b)))
                                        )
                                 (atom list-concept)
                                 (eq (length list-concept) 1)
                                 )
                             (getprop (#:ivan:ed-util:symbole (car dom-inter)) 'noeud-iace)
                             (getprop (#:ivan:ed-util:symbole (car dom-inter)) val)
                             )
                   )
           )
          (send 'set-current (component 'ed-arbre b) noeud-classe)
          )
    )

;;;***************************************************************************************
;;; ecriture des intervalles s'il y en a

(de :ecr-int (inter)
    (let (li)
         (mapc '(lambda (int)
                        (setq li (concat li " [" (string (car int)) " " (string (cadr int)) "]"))
                        )
               inter
               )
         li
         )
    )

;;;***************************************************************************************
;;; ecriture du domaine s'il y en a

(de :ecr-dom (dom)
    (setq li nil)
    (if (atom dom)
        (setq li dom)
        (when (vectorp dom)
              (setq dom (vref dom %nom-inst))
              )
        (if (consp dom)
            (mapc '(lambda (element)
                           (setq li (concat li " "(string element)))
                           )
                  dom
                  )
            (setq li (car dom))
            )
        )
    li
    )

;;;***************************************************************************************
;;; renvoyer la liste plate contenant les atomes de l
;;; on prend toutes les occurences d'un atome

(de :list-plate-expli (list)
    (let ((l (:list-plate2-expli list))
          li
          )
         (mapc '(lambda (atom) 
                        (setq li (cons atom li))
                        )
               l
               )
         (reverse li)
         )
    )

(de :list-plate2-expli (list)
    (cond ((null list) nil)
          ((atom list) (cons list nil))
          ( t (append (:list-plate2-expli (car list))
                      (:list-plate2-expli (cdr list)) 
                      )
             )
          )
    )

;;;***************************************************************************************
