;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; correction de la fct spec-inst (valable s'il n'y a pas d'heritage multiple) :
;;;
;;; avec cette correction une instance qui appartient a la classe c1 (du dessin qui suit)
;;; ne peut appartenir a la classe c2 => la classe c2 n'est pas testee pour l'instance
;;;
;;;        |-- c1
;;;     c -|                    => message "types incoherentes"
;;;        |-- c2
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(defvar #:sys-package:colon '#:iace:fc-classif)

(de :spec-inst (instance nom-sch-dest pour-types sauf-types binf bdial b)
    (tag erreur
         (slet ((nom-sch-orig (#:shirka:noyau:val-inst instance %est-un))
                (schema-orig (#:shirka:noyau:schema nom-sch-orig))
; ===>	; modif Jutta - pour SCARP : ne pas tenter de specialiser vers une classe
	; qui n'est ni une classe plus generale (surclasse de la classe d'origine)
	; ni une classe plus specifique (sous-classe de la classe d'origine) -
	; (les classes creees par specialisation locale sont remplacees par leur
	; classe-mere)
		(spec-loc-orig (equal (ascii (sref (string nom-sch-orig) 0)) '%))
		(nom-orig (if spec-loc-orig (car (vref schema-orig 4)) nom-sch-orig))
		(spec-loc-dest (equal (ascii (sref (string nom-sch-dest) 0)) '%))
		(schema-dest (#:shirka:noyau:schema nom-sch-dest))
		(nom-dest (if spec-loc-dest (car (vref schema-dest 4)) nom-sch-dest))
; <===
                (bguide)
                (nom-inst (#:iace:fc-util:nom-inst instance))
                (nom-inst-bid (getprop nom-inst 'inst-bid)))
               (ifn (eq (#:iace:fc-util:chef-fam nom-sch-orig)
			(#:iace:fc-util:chef-fam nom-sch-dest))
                    (exit erreur 
			(if #:trace:cla (print "familles incoherentes") "familles incoherentes")))
; ===>	; modif Jutta - pour SCARP :
	(unless (or	(member nom-dest
				(cons nom-sch-orig (#:shirka:noyau:ancetres 
					(#:shirka:noyau:schema nom-sch-orig))))
	   		(member nom-orig
				(cons nom-sch-dest (#:shirka:noyau:ancetres
					(#:shirka:noyau:schema nom-sch-dest))))
		)
		(progn 	
(when #:trace:cla
			(print nom-dest
				(cons nom-sch-orig (#:shirka:noyau:ancetres
                                        (#:shirka:noyau:schema nom-sch-orig))))
       			(print nom-orig
				(cons nom-sch-dest (#:shirka:noyau:ancetres
                                        (#:shirka:noyau:schema nom-sch-dest))))
)
		    	(exit erreur 
				(if #:trace:cla (print "types incoherentes") "types incoherentes"))
		)
	)
; <===
		(ifn nom-inst-bid
               		(setq nom-inst-bid (#:iace:fc-util:crebid-cl-inst instance))
                )
		(#:iace:fc-util:marquer-sur-anc schema-orig nom-inst-bid)

               (#:iace:fc-util:marquer-sur-anc schema-orig nom-inst-bid)
               (:specialiser-vers nom-inst-bid nom-sch-dest
                                  pour-types sauf-types
                                  bguide binf bdial b))
))

;;; package Shirka

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; correction de la fct spec-inst (valable s'il n'y a pas d'heritage multiple) :
;;;
;;; avec cette correction une instance qui appartient a la classe c1 (du dessin qui suit) 
;;; ne peut appartenir a la classe c2 => la classe c2 n'est pas testee pour l'instance
;;;
;;;        |-- c1
;;;     c -|                    => message "types incoherentes"
;;;        |-- c2
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defvar #:sys-package:colon '#:shirka:classif)

(de :spec-inst (instance nom-sch-dest pour-types sauf-types binf bdial)
    (tag erreur
         (slet ((nom-sch-orig (#:shirka:noyau:val-inst instance %est-un))
                (schema-orig (#:shirka:noyau:schema nom-sch-orig))
; ===>	; modif Jutta - pour SCARP : ne pas tenter de specialiser vers une classe
	; qui n'est ni une classe plus generale (surclasse de la classe d'origine)
	; ni une classe plus specifique (sous-classe de la classe d'origine) -
	; (les classes creees par specialisation locale sont remplacees par leur
	; classe-mere)
		(spec-loc-orig (equal (ascii (sref (string nom-sch-orig) 0)) '%))
		(nom-orig (if spec-loc-orig (car (vref schema-orig 4)) nom-sch-orig))
		(spec-loc-dest (equal (ascii (sref (string nom-sch-dest) 0)) '%))
		(schema-dest (#:shirka:noyau:schema nom-sch-dest))
		(nom-dest (if spec-loc-dest (car (vref schema-dest 4)) nom-sch-dest))
; <===
                (bguide)
                (nom-inst (:nom-inst instance))
                (nom-inst-bid (getprop nom-inst 'inst-bid)))
               (ifn (eq (:chef-fam nom-sch-orig)(:chef-fam nom-sch-dest))
                    (exit erreur 
			(if #:trace:cla (print "familles incoherentes") "familles incoherentes")))
; ===>	; modif Jutta - pour SCARP :
	(unless (or	(member nom-dest
				(cons nom-sch-orig (#:shirka:noyau:ancetres 
					(#:shirka:noyau:schema nom-sch-orig))))
	   		(member nom-orig
				(cons nom-sch-dest (#:shirka:noyau:ancetres
					(#:shirka:noyau:schema nom-sch-dest))))
		)
		(progn 	
(when #:trace:cla
			(print nom-dest
				(cons nom-sch-orig (#:shirka:noyau:ancetres
                                        (#:shirka:noyau:schema nom-sch-orig))))
       			(print nom-orig
				(cons nom-sch-dest (#:shirka:noyau:ancetres
                                        (#:shirka:noyau:schema nom-sch-dest))))
)
		    	(exit erreur 
				(if #:trace:cla (print "types incoherentes") "types incoherentes"))
		)
	)
; <===
               (ifn nom-inst-bid
                    (setq nom-inst-bid (:crebid-cl-inst instance)))
               (:marquer-sur-anc schema-orig nom-inst-bid)
               (:specialiser-vers nom-inst-bid nom-sch-dest
                                  pour-types sauf-types
                                  bguide binf bdial))
))

