;;; Repertoire: ~LeShirka/LeIvan/CodeIace/
;;;
;     +----------------------------------------+-----------------------------------------+
;     | fichier :  fc-util.ll                  | package : #:iace:fc-util                |
;     +----------------------------------------+-----------------------------------------+
;     |                                                                                  |
;     |                     Projet de memoire CNAM en informatique                       |
;     |             Interface d'Aide a la Classification et a l'Explication              |
;     |                dans une base de connaissances a objets Shirka.                   |
;     |                        Francois Cruypenninck    1991-1992                        |
;     |                                                                                  |
;     +----------------------------------------------------------------------------------+
;     | descriptif du package :                                                          |
;     |                                                                                  |
;     | Fichier contenant toutes les fonction d'appel SHIRKA utile pour que IACE         |
;     | fonctionne.                                                                      |
;     | Ceci permet de donner la possibilitee de modifier SHIRKA sans avoir a reprendre  |
;     | le code de IACE. Il suffit de remettre a jour ce fichier.                        |
;     |                                                                                  |
;     +----------------------------------------------------------------------------------+

;;;***************************************************************************************
;;; personnalisation du package
;;;***************************************************************************************

(defvar #:sys-package:colon '#:iace:fc-util)

;;;***************************************************************************************
;;; Dans : fc-edatt.ll

;;; Dans: fc-interf.ll

(de :demarquer-fils (var)
    (#:shirka:noyau:demarquer-fils var)
    )

(de :l-spec (var)
    (#:shirka:noyau:l-spec var)
    )

(de :impr-res (var)
    (#:shirka:top:impr-res var)
    )

(de :trad-sch (var1 var2)
    (#:shirka:top:trad-sch var1 var2)
    )

(de :visualiser (var1 var2 var3 var4 var5)
    (#:shirka:vi:visualiser var1 var2 var3 var4 var5)
    )

;;;***************************************************************************************
;;; Dans: fc-classif.ll

(de :make-inst (var1 var2)
    (#:shirka:noyau:make-inst var1 var2)
    )

(de :l-nom-att-he (var)
    (#:shirka:noyau:l-nom-att-he var)
    )

(de :nom-att (var)
    (#:shirka:noyau:nom-att var)
    )

(de :classe-att-he (var1 var2)
    (#:shirka:noyau:classe-att-he var1 var2)
    )

(de :considerer-classe-att (var1 var2 var3)
    (#:shirka:noyau:considerer-classe-att var1 var2 var3)
    )

(de :nouv-att? (var1 var2)
    (#:shirka:noyau:nouv-att? var1 var2)
    )

(de :val-fac (var1 var2)
    (#:shirka:noyau:val-fac var1 var2)
    )

(de :attrib (var1 var2)
    (#:shirka:noyau:attrib var1 var2)
    )

(de :l-att (var)
    (#:shirka:noyau:l-att var)
    )

(de :attrib-he (var1 var2)
    (#:shirka:noyau:attrib-he var1 var2)
    )

(de :app-sauf? (var1 var2 var3)
    (#:shirka:noyau:app-sauf? var1 var2 var3)
    )

(de :app-dom? (var1 var2 var3)
    (#:shirka:noyau:app-dom? var1 var2 var3)
    )

(de :type-simple? (var)
    (#:shirka:noyau:type-simple? var)
    )

(de :app-inter? (var1 var2 var3)
    (#:shirka:noyau:app-inter? var1 var2 var3)
    )

(de :aj-valeur (var1 var2 var3 var4)
    (#:shirka:moteur:aj-valeur var1 var2 var3 var4)
    )

(de :creer-est-un (var1 var2)
    (#:shirka:moteur:creer-est-un var1 var2)
    )

(de :a-verifier? (var1 var2 var3 var4)
    (#:shirka:moteur:a-verifier? var1 var2 var3 var4)
    )

(de :fin-cl (var)
    (#:shirka:classif:fin-cl var)
    )

(de :nom-inst (var)
    (#:shirka:classif:nom-inst var)
    )

(de :expl-cl (var1 var2)
    (#:shirka:classif:expl-cl var1 var2)
    )

(de :sup-instance (var)
    (#:shirka:classif:sup-instance var)
    )

(de :assoc-schema (var)
    (#:shirka:classif:assoc-schema var)
    )

(de :chef-fam (var)
    (#:shirka:classif:chef-fam var)
    )

(de :crebid-cl-inst (var)
    (#:shirka:classif:crebid-cl-inst var)
    )

(de :marquer-sur-anc (var1 var2)
    (#:shirka:classif:marquer-sur-anc var1 var2)
    )

(de :filles (var)
    (#:shirka:classif:filles var)
    )

(de :chef (var)
    (#:shirka:classif:chef var)
    )

(de :trait-imposs (var1 var2)
    (#:shirka:classif:trait-imposs var1 var2)
    )

(de :trait-poss (var1 var2)
    (#:shirka:classif:trait-poss var1 var2)
    )

(de :sur-peres? (var1 var2)
    (#:shirka:classif:sur-peres? var1 var2)
    )

(de :trait-sur (var1 var2)
    (#:shirka:classif:trait-sur var1 var2)
    )

(de :pintervalle (var1 var2 var3)
    (#:shirka:classif:pintervalle var1 var2 var3)
    )

(de :pdomaine (var1 var2 var3)
    (#:shirka:classif:pdomaine var1 var2 var3)
    )

(de :comb-i-d (var1 var2 var3)
    (#:shirka:classif:comb-i-d var1 var2 var3)
    )

(de :allonge (var1 var2 var3 var4)
    (#:shirka:classif:allonge var1 var2 var3 var4)
    )

(de :verif-lui-meme (var1 var2)
    (#:shirka:classif:verif-lui-meme var1 var2)
    )

(de :ecr-expl (var1 var2 var3 var4 var5 var6)
    (#:shirka:classif:ecr-expl var1 var2 var3 var4 var5 var6)
    )

(de :dom-adm (var1 var2 var3)
    (#:shirka:classif:dom-adm var1 var2 var3)
    )

(de :infer-val (var1 var2 var3 var4 var5 var6)
    (#:shirka:classif:infer-val var1 var2 var3 var4 var5 var6)
    )

;;;***************************************************************************************
;;; Dans: fc-edatt.ll

(de :admissible? (var1 var2 var3 var4)
    (#:shirka:moteur:admissible? var1 var2 var3 var4)
    )

;;;***************************************************************************************
;;; Dans : fc-expli.ll

(de :l-nom-att-inst-he-class (var1 var2 var3)
    (#:shirka:noyau:l-nom-att-inst-he-class var1 var2 var3)
    )

(de :l-nom-att-he-class (var1 var2 var3)
    (#:shirka:noyau:l-nom-att-he-class var1 var2 var3)
    )

(de :sup-inst (var1 var2)
    (#:shirka:moteur:sup-inst var1 var2)
    )

(de :cr-inst-temp (var1 var2 var3)
    (#:shirka:classif:cr-inst-temp var1 var2 var3)
    )

(de :gen-symbole (var)
    (#:shirka:comp:gen-symbole var)
    )

;;;***************************************************************************************
;;; Dans : fc-modif.ll

(de :l-nom-att-inst-he (var)
    (#:shirka:noyau:l-nom-att-inst-he var)
    )

(de :a-v (var1 var2 var3)
    (#:shirka:classif:a-v var1 var2 var3)
    )

(de :m-v (var1 var2 var3 var4)
    (#:shirka:classif:m-v var1 var2 var3 var4)
    )

(de :s-v (var1 var2 var3)
    (#:shirka:classif:s-v var1 var2 var3)
    )

;;;***************************************************************************************
;;; Dans : fc-classif.ll, fc-expli.ll

(de :nature (var1 var2)
    (#:shirka:noyau:nature var1 var2)
    )

(de :pos-nom-att (var1 var2)
    (#:shirka:noyau:pos-nom-att var1 var2)
    )

(de :prop-inst (var1 var2)
    (#:shirka:classif:prop-inst var1 var2)
    )

;;;***************************************************************************************
;;; Dans : fc-classif.ll, fc-modif.ll

(de :union-int-dom (var1 var2 var3 var4)
    (#:shirka:classif:union-int-dom var1 var2 var3 var4)
    )

;;;***************************************************************************************
;;; Dans fichiers : fc-expli.ll, fc-complex.ll

(de :valeur? (var1 var2)
    (#:shirka:moteur:valeur? var1 var2)
    )

;;;***************************************************************************************
;;; Dans: fc-interf.ll, fc-classif.ll, fc-edatt.ll

(de :l-inst-t (var)
    (#:shirka:noyau:l-inst-t var)
    )

;;;***************************************************************************************
;;; Dans : fc-classif.ll, fc-edatt.ll, fc-expli.ll

(de :nom-sch (var)
    (#:shirka:noyau:nom-sch var)
    )

;;;***************************************************************************************
;;; Dans: fc-classif.ll, fc-expli.ll, fc-modif.ll

(de :val-inst (var1 var2)
    (#:shirka:noyau:val-inst var1 var2)
    )

;;;***************************************************************************************
;;; Dans: fc-interf.ll, fc-classif.ll, fc-edatt.ll, fc-expli.ll, fc-modif.ll, fc-complex.ll

(de :peres (var)
    (#:shirka:noyau:peres var)
    )

(de :schema (var)
    (#:shirka:noyau:schema var)
    )

;;;***************************************************************************************
