;;; Repertoire: ~/LeShirka/LeIvan/CodeIvan/Editeur/
;
;     +----------------------------------------+-----------------------------------------+
;     | fichier : ivan-ed-global.ll            | package : #:ivan:ed-global              |
;     +----------------------------------------+-----------------------------------------+
;     |                                                                                  |
;     |                     Projet de memoire CNAM en informatique                       |
;     |             Interface de Visualisation et d'Aide a la Navigation                 |
;     |                dans une base de connaissances a objets Shirka.                   |
;     |                        Sylvain Grivaud          1991                             |
;     |                                                                                  |
;     +----------------------------------------------------------------------------------+
;     | descriptif du package :                                                          |
;     |                                                                                  |
;     |  Ce fichier contient la definition des variables globales utilisees dans les     |
;     |  editeurs d'instances/d'attributs.                                               |
;     |                                                                                  |
;     +----------------------------------------------------------------------------------+

;;;*****************************************************************************************

(defvar #:sys-package:colon '#:ivan:ed-global)

;;;*****************************************************************************************

;;; definition des fontes utilisees par les editeurs

(defvar :fstd   #:ivan:font:f9x15)    ; font standard (fstd)
(defvar :fstdb  #:ivan:font:f9x15b)   ; font standard bold (ecriture en gras)
(defvar :fmicro #:ivan:font:f8x13)    ; font micro
(defvar :ftitre #:ivan:font:f8x13)    ; font pour le titre des cluster  

;;; definition des textes des boutons utilises par les editeurs

(defvar :txt-valider (font :fstd #M#:txt-const:valider))
(defvar :txt-annuler (font :fstd  #M#:txt-const:annuler))
(defvar :txt-effacer (font :fstd #M#:txt-const:effacer))
(defvar :txt-editer  (font :fstd #M#:txt-const:editer))
(defvar :txt-daccord (font :fstd  #M#:txt-const:d-accord))
(defvar :txt-supprimer (font :fstd  #M#:txt-const:supprimer))
(defvar :txt-instance (font :fstdb #M#:txt-const:nom-inst))

;;; abscisse de positionnement de la fenetre
(setq :%x #30wd)

;;; ordonnee de positionnement de la fenetre
(setq :%y #10hd)

;;; liste des instances de travail internes 
(setq :%list-inst-trav nil)

;;; liste des noms d'instance en cours de modification
(setq :%list-nom-inst  nil)

;;; booleen d'affichage des attributs par ordre alphabetique
(setq :attralpha nil)
;;;*****************************************************************************************
