;;; Repertoire: ~/LeShirka/LeIvan/CodeIvan/Interface/
;;;
;;;     +----------------------------------------+-----------------------------------------+
;;;     | fichier :  ivan-in-global.ll           | package : #:ivan:in-global              |
;;;     +----------------------------------------+-----------------------------------------+
;;;     |                                                                                  |
;;;     |                     Projet de memoire CNAM en informatique                       |
;;;     |             Interface de Visualisation et d'Aide a la Navigation                 |
;;;     |                dans une base de connaissances a objets Shirka.                   |
;;;     |                        Sylvain Grivaud          1991                             |
;;;     |                                                                                  |
;;;     +----------------------------------------------------------------------------------+
;;;     | descriptif du package :                                                          |
;;;     |                                                                                  |
;;;     | Ce fichier contient la definition des variables globales utilisees pour la cons- |
;;;     | de l'interface.                                                                  |  
;;;     |                                                                                  |
;;;     +----------------------------------------------------------------------------------+

;;;*****************************************************************************************

(defvar #:sys-package:colon '#:ivan:in-global)

;;;*****************************************************************************************

(defvar :fstd     #:ivan:font:f8x13)
(defvar :fstdb    #:ivan:font:f8x13b)
(defvar :fmicro   #:ivan:font:fclR6x10)
(defvar :freduct1 #:ivan:font:fclB6x10)
(defvar :ftitre   #:ivan:font:f8x13)

;;;(current-font #:ivan:font:f9x15b)

(defvar green (make-named-color "forestgreen"))
(defvar red   (make-named-color "red"        ))
(defvar wheat (make-named-color "wheat"      ))
(defvar grey  (make-named-color "grey"       ))

(defvar ic-arrow-right (libloadicon 'ic-arrow-right.i))
(defvar ic-arrow-down  (libloadicon 'ic-arrow-down.i ))
(defvar ic-artemis     (libloadicon 'ic-artemis.i))
(defvar ic-peigne      (libloadicon 'ic-peigne.i))
(defvar logo
        (background 
                (make-named-color "white")
                (row
                     (icon 0 0 ic-artemis)
                     (centeredview 
                             (rectangle 0 0 0 (send 'height (icon 0 0 ic-artemis)))
                             
                             (column "INRIA "
                                     "Sherpa")
                             )))
        )

;;; variables globales

(defvar :version "1.93.12")
(defvar :limite  10)  ; nombre de sous-classes maximum acceptables pour la
                      ; representation graphique

(defvar :larg-appli #99wd)
(defvar :haut-appli #90hd)

(defvar :larg 0)
(defvar :bminitree nil)
(defvar :breduct1  nil)
(defvar :breduct2  nil)
(defvar :bobjet    nil)
;;;*****************************************************************************************
