;;; Repertoire : ~/LeShirka/LeIvan/
;;; fichier    : ivan-iace-mh.ll 
;;; mise a jour: septembre 93
;;;----------------------------------------------------------------------------------------
;;;                             interfaces IVAN-IACE
;;;
;;; chargement de l'interface de consultation/navigation/classification  de bases SHIRKA
;;; on installe IVAN avec les modules de gestion <<Hypertexte>> et multi-heritage actif.
;;; version adaptee pour Aida 1.65 (distrib. '/usr/ilog/aida/..' )
;;;----------------------------------------------------------------------------------------

;;;***************************** IMPORTANT *****************************
;;; IVAN/IACE/SHIRKA sont integres sous la meme racine
;;; hierarchie: Shirka puis Ivan et Iace.
;;; la racine est le repertoire immediatement AU-DESSUS qui contient
;;; l'installation "LeShirka"
;;;*********************************************************************

;;;
;;;(print "Trace du chargement " (date) )
;;;(print "*******************") (print)
;;;(print "******************************* Shirka ***********************************")

(unless (boundp '#:shirka:load)
        (defvar #:shirka:load ()))

;;; variable permettant de charger Ivan/Iace en meme temps
(defvar ivan t)

;;;
;;; Preparation des variables d'acces aux repertoires
;;;
;;;(print)
;;;(print "Repertoires pour IVAN")

;;; repertoire de l'interface de visualisation <<IVAN>>
;;; acces installation locale avec modifs Aida 1.65

(defvar #:ivan:*home* #:ivan:root-dir)
;;;(print "#:ivan:*home* " #:ivan:*home*)
;
(defvar #:iace:*home* (catenate #:ivan:*home* "CodeIace/"))
;;;(print "#:iace:*home* " #:iace:*home*)

;;;(print)
;;;(print "Repertoires pour Shirka")
        ;
(defvar #:shirka:*code* (catenate #:shirka:root-dir "CodeShirka/"))
;;;(print "#:shirka:*code*  -> " #:shirka:*code*)
        ;
        ; repertoire des bases Shirka (suffixe ".sh" )
        ;
(defvar #:shirka:*bases* (catenate #:shirka:root-dir "BasesShirka/"))
;;;(print "#:shirka:*bases* -> " #:shirka:*bases*)
        ;
        ; repertoire des bases verifiees
        ; ( ATTENTION: droits en ecriture sur ce repertoire, si different de /tmp )
        ;                        ^^^^^^^^
;;;(defvar #:shirka:*verif* (catenate #:shirka:*bases* "BasesVerif/"))
(defvar #:shirka:*verif* "/tmp/SHIRKA/BasesVerif/")
;;;(print "#:shirka:*verif* -> " #:shirka:*verif*)
        ;
        ; choix du format d'impression: <<1>> OU <<2>> OU <<...>>
        ;
        ; <<1>>  impressions standard en 72 colonnes : "lpr" standard
;;;(defvar #:shirka:verif:format-v 'a4-portrait)
        ; <<2>>  impressions <<a l'italienne>> : exemple "a2ps -np"
(defvar #:shirka:verif:format-v 'a4-paysage)
        ; <<autres>> : a definir...

;;;(print "*********************************************")
;
; chargement effectif de <<SHIRKA>>
;
(funcall 'load (catenate #:shirka:*code* "kashir.ll"))
;
;;; changement optionnel du repertoire des bases
;;;(defvar #:shirka:*bases* (catenate #:shirka:root-dir "BasesShirka/"))
;
; chargement effectif de <<IVAN>>
;
;;;(print "******************************* Ivan ***********************************")

; chargement des fichiers contenant les chaine constantes (anglais / francais)
;       et definissant des variables pour afficher une trace dans la fenetre AIDA
(funcall 'load (catenate #:ivan:root-dir "textes-constants.ll"))
(funcall 'load (catenate #:ivan:root-dir "tracer-ou-non.ll"))

;(current-font 1)
;
(defvar #:ivan:load t)          ; pour les messages de chargement
(defvar #:ivan:*ho (catcherror nil #:ivan:*home*))

;;;(print)
;;;(print "Chargement des modules de IVAN...")
;;;(print)
;
; chemin d'acces pour les icones
;
(defvar #:system:icon-path
        (newr #:system:icon-path
              (catenate #:ivan:*home* "CodeIvan/Icone/") ))
;
; module de gestion du catalogue
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Unix/unix.std.ll"))
;
; polices de caracteres
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Font/ivan-font-def.ll"))
;
; editeur instances & attributs
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Editeur/ivan-ed-charge.ll"))
;
; interface
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Interface/ivan-in-charge.ll"))
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Interface/ivan-in-interf+hy.ll"))
;
; requetes
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Requete/ivan-re-charge.ll"))
;
; hypertexte + structures IACE pour hypertexte
;
;;;(print "chargement des structures de l'interface iace-struct ...")
(funcall 'load (catenate #:iace:*home* "iace-struct.ll"))
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Hypertexte/ivan-hy-charge.ll"))
;
; chargement de IACE
;;;(print "******************** IACE ********************")
;;;(print)
(funcall 'load (catenate #:iace:*home* "iace-global.ll"))
(funcall 'load (catenate #:iace:*home* "iace-util.ll"))
(funcall 'load (catenate #:iace:*home* "iace-interf.ll"))
(funcall 'load (catenate #:iace:*home* "iace-classif.ll"))
(funcall 'load (catenate #:iace:*home* "iace-expli.ll"))
(funcall 'load (catenate #:iace:*home* "iace-edatt.ll"))
(funcall 'load (catenate #:iace:*home* "iace-complex.ll"))
(funcall 'load (catenate #:iace:*home* "iace-modif.ll"))
;;;(print ";;; fin IACE")
;
; initialisations des applications
;
(defvar #:iace:appli (#:iace:fc-interf:interface))
(defvar #:ivan:appli (#:ivan:in-interf:interface))
;
;----------------------------------------------------------------------------------------
;(current-font #:ivan:font:f9x15b)
;;;(print "Fin de trace a " (date))
;----------------------------------------------------------------------------------------
;;; fin de chargement et fin de la trace
(de ivan ()
    (if (< (read-from-string aidaversion) 1.65)
        (#:systeme:unix:aller-dans #:shirka:*bases*))
    (if (activatedp #:ivan:appli)
        (pop-application #:ivan:appli)
        (add-application #:ivan:appli)
    )   
    'ivan
)

(de iace ()
    (if (< (read-from-string aidaversion) 1.65)
        (#:systeme:unix:aller-dans #:shirka:*bases*))
    (if (activatedp #:iace:appli)
        (pop-application #:iace:appli)
        (add-application #:iace:appli)
    )
    'iace
)
    
(de iace/ivan ()
    (print)
    (if (< (implode (explode aidaversion)) 1.65)
        (progn (print "Lancement impossible: version AIDA < 1.65") 'ABANDON)            
        ; ajout des composants
        ;----------------------
        (if ivan (when (add-component #:iace:appli 'ivan #:ivan:appli)
                       (add-component #:ivan:appli 'iace #:iace:appli)
                       )
            )
        
        ; activer la fenetre IACE
        ;-------------------------
        (add-application #:iace:appli)
        
        ; autoriser les boutons de IACE
        ;-------------------------------
        (#:iace:fc-interf:inhiber-com   #:iace:appli)
        (#:iace:fc-interf:autoriser-com #:iace:appli)
        
        ; variable permettant de combiner les deux applications avec l'hypertexte
        ;-------------------------------------------------------------------------
        (defvar var-hyper nil)
        
        ; activer la fenetre IVAN
        ;-------------------------
        (if ivan (add-application #:ivan:appli))
        )
    )
;;; lancement final
(iace/ivan)
