;;; Repertoire : ~/LeShirka/LeIvan/
;;; fichier    : ivan.ll 
;;; mise a jour: septembre 93
;;;----------------------------------------------------------------------------------------
;;;                           interface IVAN
;;;
;;; chargement de l'interface de consultation/navigation de bases SHIRKA
;;; on installe IVAN avec les modules de gestion <<Hypertexte>>
;;; version adaptee pour Aida 1.65 (distrib. standard /usr/ilog/aida/..' )
;;;----------------------------------------------------------------------------------------

;;;***************************** IMPORTANT *****************************
;;; IVAN/IACE/SHIRKA sont integres sous la meme racine
;;; hierarchie: Shirka puis Ivan et Iace.
;;; la racine est le repertoire immediatement AU-DESSUS qui contient
;;; l'installation "LeShirka"
;;;*********************************************************************

;;;
;;;(print "Trace du chargement" (date) )
;;;(print "*******************") (print)
;;;(print "******************************* Shirka ***********************************")

(unless (boundp '#:shirka:load)
        (defvar #:shirka:load ()))

;;; Preparation des variables d'acces aux repertoires
;;;
;;;(print "Repertoires pour IVAN")
;
;;; repertoire de l'interface de visualisation <<IVAN>>
;;; acces installation locale avec modifs aida1.65

(defvar #:ivan:*home* #:ivan:root-dir)
;;;(print "#:ivan:*home* " #:ivan:*home*)
;
(defvar #:iace:*home* (catenate #:ivan:*home* "CodeIace/"))
;;;(print "#:iace:*home* " #:iace:*home*)

;;;(print)
;;;(print "Repertoires pour Shirka")
        ;
(defvar #:shirka:*code* (catenate #:shirka:root-dir "CodeShirka/"))
;;;(print "#:shirka:*code*  -> " #:shirka:*code*)
        ;
        ; repertoire des bases Shirka (suffixe ".sh" )
        ;
(defvar #:shirka:*bases* (catenate #:shirka:root-dir "BasesShirka/"))
;;;(print "#:shirka:*bases* -> " #:shirka:*bases*)
        ;
        ; repertoire des bases verifiees
        ; ( ATTENTION: droits en ecriture sur ce repertoire, si different de /tmp )
        ;                        ^^^^^^^^
;;;(defvar #:shirka:*verif* (catenate #:shirka:*bases* "BasesVerif/"))
(defvar #:shirka:*verif* "/tmp/SHIRKA/BasesVerif/")
;;;(print "#:shirka:*verif* -> " #:shirka:*verif*)
        ;
        ; choix du format d'impression: <<1>> OU <<2>> OU <<...>>
        ;
        ; <<1>>  impressions standard en 72 colonnes : "lpr" standard
;;;(defvar #:shirka:verif:format-v 'a4-portrait)
        ; <<2>>  impressions <<a l'italienne>> : exemple "a2ps -np"
(defvar #:shirka:verif:format-v 'a4-paysage)
        ; <<autres>> : a definir...

;;;(print "*********************************************")
;
; chargement effectif de <<SHIRKA>>
;
(funcall 'load (catenate #:shirka:*code* "kashir.ll"))
;
;;; changement optionnel du repertoire des bases
;;;(defvar #:shirka:*bases* (catenate #:shirka:root-dir "BasesShirka/"))
;
; chargement effectif de <<IVAN>>
;
;;;(print "******************************* Ivan ***********************************")

; chargement des fichiers contenant les chaine constantes (anglais / francais)
;       et definissant des variables pour afficher une trace dans la fenetre AIDA
(funcall 'load (catenate #:ivan:root-dir "textes-constants.ll"))
(funcall 'load (catenate #:ivan:root-dir "tracer-ou-non.ll"))

;(current-font 1)
;
(defvar #:ivan:load t)          ; pour les messages de chargement
(defvar #:ivan:*ho (catcherror nil #:ivan:*home*))
;

;;;(print)
;;;(print "Chargement des modules de IVAN...")
;;;(print)
;
; chemin d'acces pour les icones
;
(defvar #:system:icon-path
        (newr #:system:icon-path
              (catenate #:ivan:*home* "CodeIvan/Icone/") ))
;
; module de gestion du catalogue
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Unix/unix.std.ll"))
;
; polices de caracteres
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Font/ivan-font-def.ll"))
;
; editeur instances & attributs
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Editeur/ivan-ed-charge.ll"))
;
; interface
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Interface/ivan-in-charge.ll"))
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Interface/ivan-in-interf+hy.ll"))
;
; requetes
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Requete/ivan-re-charge.ll"))
;
; hypertexte + structures IACE pour hypertexte
;
;;;(print "chargement des structures de l'interface iace-struct ...")
(funcall 'load (catenate #:ivan:*home* "CodeIace/iace-struct.ll"))
;
(funcall 'load (catenate #:ivan:*home* "CodeIvan/Hypertexte/ivan-hy-charge.ll"))
;
;;; fin de chargement et fin de la trace

;
;----------------------------------------------------------------------------------------
;(current-font #:ivan:font:f9x15b)
(print)
;----------------------------------------------------------------------------------------

(de ivan-appli ()
    (defvar #:ivan:appli (#:ivan:in-interf:interface)) )
(ivan-appli)
(de ivan ()
    (if (< (read-from-string aidaversion) 1.65)
        (#:systeme:unix:aller-dans #:shirka:*bases*))
    (add-application  #:ivan:appli)
    'ivan
    )
;;; lancement final
(ivan)
